//=============================================================================
//
// file :        FSafety.h
//
// description : Include for the FSafety class.
//
// project :	
//
// $Author: graziano $
//
// $Revision: 1.21 $
//
// $Log: FSafety.h,v $
// Revision 1.21  2017-08-24 07:51:16  graziano
// added Undulator_board_disabled_xxx attributes and fixed Version
//
// Revision 1.20  2017-08-21 11:53:40  claudio
// #1554 tango-9.2.5a
//
// Revision 1.19  2017-07-24 08:31:04  graziano
// Added uh plc version
//
// Revision 1.18  2016-03-17 13:49:53  graziano
// added new board disabled attributes
//
// Revision 1.17  2015-07-06 08:12:40  graziano
// fixed for ctf
//
// Revision 1.16  2015-01-21 09:45:30  graziano
// Device_4Impl and fixed ntohs
//
// Revision 1.15  2012-04-03 09:23:07  zambonl
// .ndd
//
// Revision 1.14  2010/11/09 10:32:37  zambonl
// .ndd
//
// Revision 1.13  2010/09/27 12:00:27  zambonl
//
// Revision 1.12  2010/08/26 10:20:36  zambonl
// .
//
// Revision 1.11  2010/06/21 14:44:17  zambonl
// ndd
//
// Revision 1.10  2010/06/10 16:41:12  zambonl
// ndd
//
// Revision 1.9  2010/01/28 11:03:53  zambonl
// ndd
//
// Revision 1.8  2009/08/28 10:35:52  sara
// Actived periodic refresh of names table
//
// Revision 1.7  2009/07/16 07:53:59  sara
// added command for door acknowledge, fixed bugs
//
// Revision 1.6  2009/07/13 12:39:28  sara
// commands ready
//
// Revision 1.5  2009/06/11 14:43:10  sara
// ll attributes are now static
//
// Revision 1.4  2009/04/27 08:17:34  sara
// added generig command SendCmd
//
// Revision 1.3  2009/04/21 14:32:49  sara
// fixed bug in dynamic StringSpectrumAttributes
//
// Revision 1.2  2009/04/20 12:13:09  sara
// added dynamic attributes for DevShort and DevString types
//
// Revision 1.1.1.1  2009/04/03 09:11:57  sara
// first import
//
//
// copyleft :    European Synchrotron Radiation Facility
//               BP 220, Grenoble 38043
//               FRANCE
//
//=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================
#ifndef _FSAFETY_H
#define _FSAFETY_H

#include <tango.h>
#include <math.h>
#include <sys/time.h>
//using namespace Tango;

/**
 * @author	$Author: graziano $
 * @version	$Revision: 1.21 $
 */

 //	Add your own constants definitions here.
 //-----------------------------------------------
// timeout for ping command (milliseconds)
#define PING_TIMEOT  300 
//max len of boolattr  array
#define MAX_BOOL   40 
//max len of shortattr  array
#define MAX_SHORT   10 
//max len of shortattr  array
#define MAX_REAL 4
//max len of stringattr  array
#define MAX_STRING   120 
#define MAX_ALL   120 
//attribute cache refresh period in us 
#define RFSH_CACHE   100000 
//badge string size in words
#define	BADGE_SIZE	8
//single name len
#define	NAME_LEN	16
//db names length
#define	DB_NAMES_LEN	116
//num keys
#define	NUM_KEYS	16

#define	CNAMES_RFSH_RATE	17	
#define	SNAMES_RFSH_RATE	160	

//stat message from ll srv strarts at byte 12.0, to 371.7
#define	OFFSET	96
//size of dbstat in bit
#define	MESG_STAT_LEN	1440
#define	MESG_STAT_MAX_LEN	3000

#define	MESG_ALM_MAX_LEN	3040
//size of dbacc in bit
#define	MESG_ACC_LEN	16
#define	MESG_ACC_MAX_LEN	2432
//max number of attributes
#define	MAX_N_DB	5
#define	MAX_N_ATTR	200
#define	MAX_N_CMD	100
#define	MAX_LEN_ATTR	100 //34


#define	MAX_LEN_LABEL	100 //34
#define	MAX_LEN_DESC	100 //60

//size of the message buffer
#define	BUF_LEN	3000

#define	ECHO_51_CMD	51	
#define	ECHO_121_CMD	121	

#define NULL_BADGE	"             "

#define	TYPE_BOOL	0	
#define	TYPE_STRING	1	
#define	TYPE_INT	2	
#define	TYPE_BYTE	3	

//cmd codes
#define	CMD_LINACSWITCHCONF	0
#define	CMD_DELPOSTO	1
#define	CMD_LINACBSTOPEN	2
#define	CMD_LINACBSTCLOSE	3
#define	CMD_LINACRPASV	4
#define	CMD_LINACEMEACK	5
#define	CMD_LINACSEARCHREQ	6
#define	CMD_LINACSEARCHSTART	7
#define	CMD_LINACSEARCHSTOP	8
#define	CMD_LINACDOORRESET	9
#define	CMD_LINACDOOROPEN	10
#define	CMD_LINACACKDOOR	11
#define	CMD_SERVICE	12
#define	CMD_LINACEMETLACK	13
#define	CMD_UNDULATORSWITCHCONF	0
#define	CMD_UNDULATORDELPOSTO	1
#define	CMD_UNDULATORBSTOPEN	2
#define	CMD_UNDULATORBSTCLOSE	3
#define	CMD_UNDULATORRPASV	4
#define	CMD_UNDULATOREMEACK	5
#define	CMD_UNDULATORSEARCHREQ	6
#define	CMD_UNDULATORSEARCHSTART	7
#define	CMD_UNDULATORSEARCHSTOP	8
#define	CMD_UNDULATORDOORRESET	9
#define	CMD_UNDULATORDOOROPEN	10
#define	CMD_UNDULATORACKDOOR	11
#define	CMD_UNDULATORSERVICE	12

//offset in bit from byte 46 of command start_search[]
#define	OFF_0	9	
#define	OFF_1	3	
#define	OFF_2	5	
#define	OFF_3	7	
#define	OFF_4	1	
#define	OFF_5	12	
#define	OFF_6	0	
#define	OFF_7	-1	
#define	OFF_8	-1	
#define	OFF_9	11	
#define	OFF_10	14	
#define	OFF_11	-1	

static short off_search[] = {
	OFF_0, 
	OFF_1, 
	OFF_2, 
	OFF_3, 
	OFF_4, 
	OFF_5,
	OFF_6,
	OFF_7,
	OFF_8,
	OFF_9,
	OFF_10
	OFF_11
};
#define TIME_CONFIRM	1500000	//time in usec between command and confirm
//position of confirm cmds
#define	POS_0	16	
#define	POS_1	18	
#define	POS_2	32	
#define	POS_3	38	
#define	POS_N	-1	
static u_short pos_confirm[] = {
	POS_0,	
	POS_1,	
	POS_2,	
	POS_3,	
};

#define del0		0xfffe
#define del1		0xfffd
#define del2		0xfffb
#define del3		0xfff7
#define del4		0xffef
#define del5		0xffdf
#define del6		0xffbf
#define del7		0xff7f
#define del8		0xfeff
#define del9		0xfdff
#define del10		0xfbff
#define del11		0xf7ff
#define del12		0xefff
#define del13		0xdfff
#define del14		0xbfff
#define del15		0x7fff

/*
#define del0		0x0001
#define del1		0x0002
#define del2		0x0004
#define del3		0x0008
#define del4		0x0010
#define del5		0x0020
#define del6		0x0040
#define del7		0x0080
#define del8		0x0100
#define del9		0x0200
#define del10		0x0400
#define del11		0x0800
#define del12		0x1000
#define del13		0x2000
#define del14		0x4000
#define del15		0x8000
*/
static u_short del_posti[] = {
	del0, 
	del1, 
	del2, 
	del3, 
	del4, 
	del5, 
	del6, 
	del7,
	del8,
	del9,
	del10,
	del11,
	del12,
	del13,
	del14,
	del15
};

/*static u_short del_conf[][] = {
	del0, 
	del1, 
	del2, 
	del3, 
	del4, 
	del5, 
	del6, 
	del7,
	del8,
	del9,
	del10,
	del11,
	del12,
	del13,
	del14,
	del15
};*/

class FSafetyClass;

namespace FSafety_ns
{
//cmd structure
typedef u_char st_cmd[48];	
//typedef u_short st_cmd[48];	

typedef struct start_idx{
	int bit_pos;
	int byte_pos;
};	

/**
 * Class Description:
 * hi level tango server that manages communication with FERMI safety PLC, by FSafety
 */

/*
 *	Device States Description:
*  Tango::ON :
*  Tango::FAULT :
 */


class FSafety: public TANGO_BASE_CLASS
{
public :
	//	Add your own data members here
	//-----------------------------------------
float ntohf(float val_f);
Tango::DevDouble mbd_current;
Tango::DevDouble cm_mbd_fel_01_01;
Tango::DevDouble cm_mbd_fel_02_01;
Tango::DevDouble cm_sfel_01_01;
Tango::DevDouble cm_sfel_02_01;
Tango::DevDouble cm_mbd_01;

	//	Here is the Start of the automatic code generation part
	//-------------------------------------------------------------	
/**
 *	@name attributes
 *	Attributs member data.
 */
//@{
		Tango::DevShort	*attr_Linac_mod_on_pcgun_read;
		Tango::DevShort	*attr_Linac_mod_onS0_read;
		Tango::DevDouble	*attr_Linac_mbd_current_read;
		Tango::DevBoolean	*attr_Plc_status_read;
		Tango::DevBoolean	*attr_Undulator_plc_status_read;
		Tango::DevDouble	*attr_Undulator_cm_sfel_01_01_read;
		Tango::DevDouble	*attr_Undulator_cm_sfel_02_01_read;
		Tango::DevDouble	*attr_Undulator_cm_mbd_fel_01_01_read;
		Tango::DevDouble	*attr_Undulator_cm_mbd_fel_02_01_read;
		Tango::DevDouble	*attr_Undulator_cm_mbd_01_read;
		Tango::DevShort	*attr_Undulator_mbd_fel_1_read;
		Tango::DevShort	*attr_Undulator_mbd_fel_2_read;
		Tango::DevShort	*attr_Undulator_mbd_01_read;
		Tango::DevShort	*attr_Undulator_sprd_fel_1_read;
		Tango::DevShort	*attr_Undulator_sprd_fel_2_read;
		Tango::DevString	*attr_Version_read;
		Tango::DevBoolean	*attr_Exphall_gamma_read;
		Tango::DevBoolean	*attr_Linac_access_signals_read;
		Tango::DevBoolean	*attr_Linac_access_state_read;
		Tango::DevString	*attr_Linac_badge_all_read;
		Tango::DevString	*attr_Linac_badge_ack_read;
		Tango::DevBoolean	*attr_Linac_boards_disabled_read;
		Tango::DevBoolean	*attr_Linac_board_disabled_008_read;
		Tango::DevBoolean	*attr_Linac_board_disabled_040_read;
		Tango::DevBoolean	*attr_Linac_board_disabled_058_read;
		Tango::DevBoolean	*attr_Linac_board_disabled_068_read;
		Tango::DevBoolean	*attr_Linac_board_disabled_078_read;
		Tango::DevBoolean	*attr_Linac_board_disabled_100_read;
		Tango::DevBoolean	*attr_Linac_board_disabled_106_read;
		Tango::DevBoolean	*attr_Linac_board_disabled_126_read;
		Tango::DevBoolean	*attr_Linac_board_disabled_132_read;
		Tango::DevBoolean	*attr_Linac_board_disabled_152_read;
		Tango::DevBoolean	*attr_Linac_board_disabled_158_read;
		Tango::DevBoolean	*attr_Linac_board_disabled_178_read;
		Tango::DevBoolean	*attr_Linac_board_disabled_184_read;
		Tango::DevBoolean	*attr_Linac_board_disabled_190_read;
		Tango::DevBoolean	*attr_Linac_board_disabled_196_read;
		Tango::DevBoolean	*attr_Linac_board_disabled_202_read;
		Tango::DevBoolean	*attr_Linac_board_disabled_216_read;
		Tango::DevBoolean	*attr_Linac_board_disabled_240_read;
		Tango::DevBoolean	*attr_Linac_board_disabled_252_read;
		Tango::DevBoolean	*attr_Linac_board_disabled_258_read;
		Tango::DevBoolean	*attr_Linac_board_disabled_280_read;
		Tango::DevBoolean	*attr_Linac_board_disabled_286_read;
		Tango::DevBoolean	*attr_Linac_board_disabled_308_read;
		Tango::DevBoolean	*attr_Linac_board_disabled_314_read;
		Tango::DevBoolean	*attr_Linac_board_disabled_088_read;
		Tango::DevBoolean	*attr_Linac_board_disabled_232_read;
		Tango::DevBoolean	*attr_Linac_board_disabled_222_read;
		Tango::DevBoolean	*attr_Linac_board_disabled_227_read;
		Tango::DevBoolean	*attr_Linac_board_disabled_246_read;
		Tango::DevBoolean	*attr_Linac_board_disabled_264_read;
		Tango::DevBoolean	*attr_Linac_board_disabled_269_read;
		Tango::DevBoolean	*attr_Linac_board_disabled_292_read;
		Tango::DevBoolean	*attr_Linac_board_disabled_297_read;
		Tango::DevBoolean	*attr_Linac_board_disabled_320_read;
		Tango::DevBoolean	*attr_Linac_board_disabled_325_read;
		Tango::DevBoolean	*attr_Linac_boards_resettable_read;
		Tango::DevBoolean	*attr_Linac_bst_1_read;
		Tango::DevShort	*attr_Linac_disp_ext_code_read;
		Tango::DevShort	*attr_Linac_disp_int_code_read;
		Tango::DevBoolean	*attr_Linac_doors_e0_read;
		Tango::DevBoolean	*attr_Linac_doors_e1_read;
		Tango::DevBoolean	*attr_Linac_doors_e2_read;
		Tango::DevBoolean	*attr_Linac_doors_e3_read;
		Tango::DevBoolean	*attr_Linac_doors_l_read;
		Tango::DevBoolean	*attr_Linac_doors_tl_read;
		Tango::DevBoolean	*attr_Linac_doors_memoopen_e0_read;
		Tango::DevBoolean	*attr_Linac_doors_memoopen_e1_read;
		Tango::DevBoolean	*attr_Linac_doors_memoopen_e2_read;
		Tango::DevBoolean	*attr_Linac_doors_memoopen_e3_read;
		Tango::DevBoolean	*attr_Linac_doors_memoopen_l_read;
		Tango::DevBoolean	*attr_Linac_doors_memoopen_tl_read;
		Tango::DevBoolean	*attr_Linac_emergency_buttons_read;
		Tango::DevBoolean	*attr_Linac_gamma_read;
		Tango::DevBoolean	*attr_Linac_key_glob_read;
		Tango::DevBoolean	*attr_Linac_glob_signals_read;
		Tango::DevBoolean	*attr_Linac_key_ext_read;
		Tango::DevBoolean	*attr_Linac_key_int_read;
		Tango::DevBoolean	*attr_Linac_key_release_read;
		Tango::DevBoolean	*attr_Linac_mod_abi_hv_read;
		Tango::DevBoolean	*attr_Linac_mod_abi_rf_read;
		Tango::DevBoolean	*attr_Linac_mod_hv_read;
		Tango::DevBoolean	*attr_Linac_mod_rf_read;
		Tango::DevBoolean	*attr_Linac_mod_positions_read;
		Tango::DevBoolean	*attr_Linac_mod_pre_hv_abi_read;
		Tango::DevBoolean	*attr_Linac_pickup_read;
		Tango::DevBoolean	*attr_Linac_safety_read;
		Tango::DevBoolean	*attr_Linac_search_barriers_read;
		Tango::DevBoolean	*attr_Linac_search_buttons_read;
		Tango::DevBoolean	*attr_Linac_search_doorlights_read;
		Tango::DevBoolean	*attr_Linac_search_lights_read;
		Tango::DevBoolean	*attr_Linac_search_req_l_read;
		Tango::DevBoolean	*attr_Linac_search_req_tl_read;
		Tango::DevBoolean	*attr_Linac_search_req_e0_read;
		Tango::DevBoolean	*attr_Linac_search_req_e1_read;
		Tango::DevBoolean	*attr_Linac_search_req_e2_read;
		Tango::DevBoolean	*attr_Linac_search_req_e3_read;
		Tango::DevBoolean	*attr_Linac_search_signals_e0_read;
		Tango::DevBoolean	*attr_Linac_search_signals_e1_read;
		Tango::DevBoolean	*attr_Linac_search_signals_e2_read;
		Tango::DevBoolean	*attr_Linac_search_signals_e3_read;
		Tango::DevBoolean	*attr_Linac_search_signals_l_read;
		Tango::DevBoolean	*attr_Linac_search_signals_tl_read;
		Tango::DevBoolean	*attr_Linac_search_ini_e0_read;
		Tango::DevBoolean	*attr_Linac_search_ini_e1_read;
		Tango::DevBoolean	*attr_Linac_search_ini_e2_read;
		Tango::DevBoolean	*attr_Linac_search_ini_e3_read;
		Tango::DevBoolean	*attr_Linac_search_ini_l_read;
		Tango::DevBoolean	*attr_Linac_search_ini_tl_read;
		Tango::DevBoolean	*attr_Linac_search_fail_e0_read;
		Tango::DevBoolean	*attr_Linac_search_fail_e1_read;
		Tango::DevBoolean	*attr_Linac_search_fail_e2_read;
		Tango::DevBoolean	*attr_Linac_search_fail_e3_read;
		Tango::DevBoolean	*attr_Linac_search_fail_l_read;
		Tango::DevBoolean	*attr_Linac_search_fail_tl_read;
		Tango::DevBoolean	*attr_Linac_sir_buz_read;
		Tango::DevBoolean	*attr_Linac_state_read;
		Tango::DevBoolean	*attr_Linac_switches_abi_read;
		Tango::DevShort	*attr_Linac_switches_config_read;
		Tango::DevBoolean	*attr_Linac_switches_load_read;
		Tango::DevBoolean	*attr_Linac_switches_moving_read;
		Tango::DevBoolean	*attr_Linac_switches_stable_read;
		Tango::DevBoolean	*attr_Linac_doors_ext_read;
		Tango::DevString	*attr_Linac_access_names_read;
		Tango::DevString	*attr_Linac_search_names_read;
		Tango::DevBoolean	*attr_Linac_doors_memoopen_ext_read;
		Tango::DevBoolean	*attr_Linac_emergency_memo_buttons_read;
		Tango::DevBoolean	*attr_Linac_badge_on_read;
		Tango::DevBoolean	*attr_Linac_mod_inhib_rf_k1_read;
		Tango::DevBoolean	*attr_Linac_mod_inhib_rf_k2_read;
		Tango::DevBoolean	*attr_Linac_mod_inhib_hv_k1_read;
		Tango::DevBoolean	*attr_Linac_mod_inhib_hv_k2_read;
		Tango::DevBoolean	*attr_Linac_mod_inhib_hv_ks_read;
		Tango::DevBoolean	*attr_Linac_mod_inhib_rf_ks_read;
		Tango::DevBoolean	*attr_Linac_mod_inhib_rf_gen_read;
		Tango::DevBoolean	*attr_Linac_mod_inhib_hv_gen_read;
		Tango::DevBoolean	*attr_Undulator_access_signals_read;
		Tango::DevBoolean	*attr_Undulator_access_state_read;
		Tango::DevBoolean	*attr_Undulator_access_hutch_read;
		Tango::DevString	*attr_Undulator_badge_all_read;
		Tango::DevString	*attr_Undulator_badge_ack_read;
		Tango::DevBoolean	*attr_Undulator_badge_on_read;
		Tango::DevBoolean	*attr_Undulator_boards_disabled_read;
		Tango::DevBoolean	*attr_Undulator_board_disabled_008_read;
		Tango::DevBoolean	*attr_Undulator_board_disabled_024_read;
		Tango::DevBoolean	*attr_Undulator_board_disabled_100_read;
		Tango::DevBoolean	*attr_Undulator_board_disabled_106_read;
		Tango::DevBoolean	*attr_Undulator_board_disabled_126_read;
		Tango::DevBoolean	*attr_Undulator_board_disabled_132_read;
		Tango::DevBoolean	*attr_Undulator_board_disabled_152_read;
		Tango::DevBoolean	*attr_Undulator_board_disabled_158_read;
		Tango::DevBoolean	*attr_Undulator_board_disabled_178_read;
		Tango::DevBoolean	*attr_Undulator_board_disabled_184_read;
		Tango::DevBoolean	*attr_Undulator_board_disabled_204_read;
		Tango::DevBoolean	*attr_Undulator_board_disabled_214_read;
		Tango::DevBoolean	*attr_Undulator_board_disabled_248_read;
		Tango::DevBoolean	*attr_Undulator_board_disabled_270_read;
		Tango::DevBoolean	*attr_Undulator_board_disabled_288_read;
		Tango::DevBoolean	*attr_Undulator_boards_resettable_read;
		Tango::DevBoolean	*attr_Undulator_bst1_fel1_read;
		Tango::DevBoolean	*attr_Undulator_bst2_fel1_read;
		Tango::DevBoolean	*attr_Undulator_bst1_fel2_read;
		Tango::DevBoolean	*attr_Undulator_bst2_fel2_read;
		Tango::DevBoolean	*attr_Undulator_bst_diag_read;
		Tango::DevBoolean	*attr_Undulator_bst_inhibit_linac_read;
		Tango::DevBoolean	*attr_Undulator_bst_inhibit_bl_read;
		Tango::DevShort	*attr_Undulator_disp_ext_code_read;
		Tango::DevShort	*attr_Undulator_disp_int_code_read;
		Tango::DevBoolean	*attr_Undulator_doors_e4_read;
		Tango::DevBoolean	*attr_Undulator_doors_e5_read;
		Tango::DevBoolean	*attr_Undulator_doors_e6_read;
		Tango::DevBoolean	*attr_Undulator_doors_e7_read;
		Tango::DevBoolean	*attr_Undulator_doors_so_read;
		Tango::DevBoolean	*attr_Undulator_doors_esa_read;
		Tango::DevBoolean	*attr_Undulator_doors_memoopen_e4_read;
		Tango::DevBoolean	*attr_Undulator_doors_memoopen_e5_read;
		Tango::DevBoolean	*attr_Undulator_doors_memoopen_e6_read;
		Tango::DevBoolean	*attr_Undulator_doors_memoopen_e7_read;
		Tango::DevBoolean	*attr_Undulator_doors_memoopen_so_read;
		Tango::DevBoolean	*attr_Undulator_doors_memoopen_esa_read;
		Tango::DevBoolean	*attr_Undulator_emergency_buttons_read;
		Tango::DevBoolean	*attr_Undulator_emergency_memo_buttons_read;
		Tango::DevBoolean	*attr_Undulator_glob_signals_read;
		Tango::DevBoolean	*attr_Undulator_key_glob_read;
		Tango::DevBoolean	*attr_Undulator_key_ext_read;
		Tango::DevBoolean	*attr_Undulator_key_int_read;
		Tango::DevBoolean	*attr_Undulator_key_release_read;
		Tango::DevBoolean	*attr_Undulator_search_barriers_read;
		Tango::DevBoolean	*attr_Undulator_search_buttons_read;
		Tango::DevBoolean	*attr_Undulator_search_doorlights_read;
		Tango::DevBoolean	*attr_Undulator_search_lights_read;
		Tango::DevBoolean	*attr_Undulator_search_req_so_read;
		Tango::DevBoolean	*attr_Undulator_search_req_e4_read;
		Tango::DevBoolean	*attr_Undulator_search_req_e5_read;
		Tango::DevBoolean	*attr_Undulator_search_req_e6_read;
		Tango::DevBoolean	*attr_Undulator_search_req_e7_read;
		Tango::DevBoolean	*attr_Undulator_search_req_esa1_read;
		Tango::DevBoolean	*attr_Undulator_search_req_esa2_read;
		Tango::DevBoolean	*attr_Undulator_search_signals_so_read;
		Tango::DevBoolean	*attr_Undulator_search_signals_e4_read;
		Tango::DevBoolean	*attr_Undulator_search_signals_e5_read;
		Tango::DevBoolean	*attr_Undulator_search_signals_e6_read;
		Tango::DevBoolean	*attr_Undulator_search_signals_e7_read;
		Tango::DevBoolean	*attr_Undulator_search_signals_esa1_read;
		Tango::DevBoolean	*attr_Undulator_search_signals_esa2_read;
		Tango::DevBoolean	*attr_Undulator_search_ini_so_read;
		Tango::DevBoolean	*attr_Undulator_search_ini_e4_read;
		Tango::DevBoolean	*attr_Undulator_search_ini_e5_read;
		Tango::DevBoolean	*attr_Undulator_search_ini_e6_read;
		Tango::DevBoolean	*attr_Undulator_search_ini_e7_read;
		Tango::DevBoolean	*attr_Undulator_search_fail_so_read;
		Tango::DevBoolean	*attr_Undulator_search_fail_e4_read;
		Tango::DevBoolean	*attr_Undulator_search_fail_e5_read;
		Tango::DevBoolean	*attr_Undulator_search_fail_e6_read;
		Tango::DevBoolean	*attr_Undulator_search_fail_e7_read;
		Tango::DevBoolean	*attr_Undulator_search_fail_esa1_read;
		Tango::DevBoolean	*attr_Undulator_search_fail_esa2_read;
		Tango::DevBoolean	*attr_Undulator_sir_buz_read;
		Tango::DevBoolean	*attr_Undulator_state_read;
//@}

/**
 *	@name Device properties
 *	Device properties member data.
 */
//@{
/**
 *	
 */
	string	low_level_srv;
/**
 *	
 */
	string	undulator_low_level_srv;
/**
 *	
 */
	string	data_config;
/**
 *	
 */
	vector<string>	cmdCodeDescription;
/**
 *	
 */
	vector<string>	undulatorCmdCodeDescription;
//@}

/**@name Constructors
 * Miscellaneous constructors */
//@{
/**
 * Constructs a newly allocated Command object.
 *
 *	@param cl	Class.
 *	@param s 	Device Name
 */
	FSafety(Tango::DeviceClass *cl,string &s);
/**
 * Constructs a newly allocated Command object.
 *
 *	@param cl	Class.
 *	@param s 	Device Name
 */
	FSafety(Tango::DeviceClass *cl,const char *s);
/**
 * Constructs a newly allocated Command object.
 *
 *	@param cl	Class.
 *	@param s 	Device name
 *	@param d	Device description.
 */
	FSafety(Tango::DeviceClass *cl,const char *s,const char *d);
//@}

/**@name Destructor
 * Only one desctructor is defined for this class */
//@{
/**
 * The object desctructor.
 */	
	~FSafety() {delete_device();};
/**
 *	will be called at device destruction or at init command.
 */
	void delete_device();
//@}

	
/**@name Miscellaneous methods */
//@{
/**
 *	Initialize the device
 */
	virtual void init_device();
/**
 *	Always executed method befor execution command method.
 */
	virtual void always_executed_hook();

//@}

/**
 * @name FSafety methods prototypes
 */

//@{
/**
 *	Hardware acquisition for attributes.
 */
	virtual void read_attr_hardware(vector<long> &attr_list);
/**
 *	Extract real attribute values for Linac_mod_on_pcgun acquisition result.
 */
	virtual void read_Linac_mod_on_pcgun(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_mod_onS0 acquisition result.
 */
	virtual void read_Linac_mod_onS0(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_mbd_current acquisition result.
 */
	virtual void read_Linac_mbd_current(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Plc_status acquisition result.
 */
	virtual void read_Plc_status(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_plc_status acquisition result.
 */
	virtual void read_Undulator_plc_status(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_cm_sfel_01_01 acquisition result.
 */
	virtual void read_Undulator_cm_sfel_01_01(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_cm_sfel_02_01 acquisition result.
 */
	virtual void read_Undulator_cm_sfel_02_01(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_cm_mbd_fel_01_01 acquisition result.
 */
	virtual void read_Undulator_cm_mbd_fel_01_01(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_cm_mbd_fel_02_01 acquisition result.
 */
	virtual void read_Undulator_cm_mbd_fel_02_01(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_cm_mbd_01 acquisition result.
 */
	virtual void read_Undulator_cm_mbd_01(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_mbd_fel_1 acquisition result.
 */
	virtual void read_Undulator_mbd_fel_1(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_mbd_fel_2 acquisition result.
 */
	virtual void read_Undulator_mbd_fel_2(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_mbd_01 acquisition result.
 */
	virtual void read_Undulator_mbd_01(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_sprd_fel_1 acquisition result.
 */
	virtual void read_Undulator_sprd_fel_1(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_sprd_fel_2 acquisition result.
 */
	virtual void read_Undulator_sprd_fel_2(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Version acquisition result.
 */
	virtual void read_Version(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Exphall_gamma acquisition result.
 */
	virtual void read_Exphall_gamma(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_access_signals acquisition result.
 */
	virtual void read_Linac_access_signals(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_access_state acquisition result.
 */
	virtual void read_Linac_access_state(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_badge_all acquisition result.
 */
	virtual void read_Linac_badge_all(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_badge_ack acquisition result.
 */
	virtual void read_Linac_badge_ack(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_boards_disabled acquisition result.
 */
	virtual void read_Linac_boards_disabled(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_board_disabled_xxx acquisition result.
 */
	virtual void read_Linac_board_disabled_008(Tango::Attribute &attr);
	virtual void read_Linac_board_disabled_040(Tango::Attribute &attr);
	virtual void read_Linac_board_disabled_058(Tango::Attribute &attr);
	virtual void read_Linac_board_disabled_068(Tango::Attribute &attr);
	virtual void read_Linac_board_disabled_078(Tango::Attribute &attr);
	virtual void read_Linac_board_disabled_100(Tango::Attribute &attr);
	virtual void read_Linac_board_disabled_106(Tango::Attribute &attr);
	virtual void read_Linac_board_disabled_126(Tango::Attribute &attr);
	virtual void read_Linac_board_disabled_132(Tango::Attribute &attr);
	virtual void read_Linac_board_disabled_152(Tango::Attribute &attr);
	virtual void read_Linac_board_disabled_158(Tango::Attribute &attr);
	virtual void read_Linac_board_disabled_178(Tango::Attribute &attr);
	virtual void read_Linac_board_disabled_184(Tango::Attribute &attr);
	virtual void read_Linac_board_disabled_190(Tango::Attribute &attr);
	virtual void read_Linac_board_disabled_196(Tango::Attribute &attr);
	virtual void read_Linac_board_disabled_202(Tango::Attribute &attr);
	virtual void read_Linac_board_disabled_216(Tango::Attribute &attr);
	virtual void read_Linac_board_disabled_240(Tango::Attribute &attr);
	virtual void read_Linac_board_disabled_252(Tango::Attribute &attr);
	virtual void read_Linac_board_disabled_258(Tango::Attribute &attr);
	virtual void read_Linac_board_disabled_280(Tango::Attribute &attr);
	virtual void read_Linac_board_disabled_286(Tango::Attribute &attr);
	virtual void read_Linac_board_disabled_308(Tango::Attribute &attr);
	virtual void read_Linac_board_disabled_314(Tango::Attribute &attr);
	virtual void read_Linac_board_disabled_088(Tango::Attribute &attr);
	virtual void read_Linac_board_disabled_232(Tango::Attribute &attr);
	virtual void read_Linac_board_disabled_222(Tango::Attribute &attr);
	virtual void read_Linac_board_disabled_227(Tango::Attribute &attr);
	virtual void read_Linac_board_disabled_246(Tango::Attribute &attr);
	virtual void read_Linac_board_disabled_264(Tango::Attribute &attr);
	virtual void read_Linac_board_disabled_269(Tango::Attribute &attr);
	virtual void read_Linac_board_disabled_292(Tango::Attribute &attr);
	virtual void read_Linac_board_disabled_297(Tango::Attribute &attr);
	virtual void read_Linac_board_disabled_320(Tango::Attribute &attr);
	virtual void read_Linac_board_disabled_325(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_boards_resettable acquisition result.
 */
	virtual void read_Linac_boards_resettable(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_bst_1 acquisition result.
 */
	virtual void read_Linac_bst_1(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_disp_ext_code acquisition result.
 */
	virtual void read_Linac_disp_ext_code(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_disp_int_code acquisition result.
 */
	virtual void read_Linac_disp_int_code(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_doors_e0 acquisition result.
 */
	virtual void read_Linac_doors_e0(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_doors_e1 acquisition result.
 */
	virtual void read_Linac_doors_e1(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_doors_e2 acquisition result.
 */
	virtual void read_Linac_doors_e2(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_doors_e3 acquisition result.
 */
	virtual void read_Linac_doors_e3(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_doors_l acquisition result.
 */
	virtual void read_Linac_doors_l(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_doors_tl acquisition result.
 */
	virtual void read_Linac_doors_tl(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_doors_memoopen_e0 acquisition result.
 */
	virtual void read_Linac_doors_memoopen_e0(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_doors_memoopen_e1 acquisition result.
 */
	virtual void read_Linac_doors_memoopen_e1(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_doors_memoopen_e2 acquisition result.
 */
	virtual void read_Linac_doors_memoopen_e2(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_doors_memoopen_e3 acquisition result.
 */
	virtual void read_Linac_doors_memoopen_e3(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_doors_memoopen_l acquisition result.
 */
	virtual void read_Linac_doors_memoopen_l(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_doors_memoopen_tl acquisition result.
 */
	virtual void read_Linac_doors_memoopen_tl(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_emergency_buttons acquisition result.
 */
	virtual void read_Linac_emergency_buttons(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_gamma acquisition result.
 */
	virtual void read_Linac_gamma(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_key_glob acquisition result.
 */
	virtual void read_Linac_key_glob(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_glob_signals acquisition result.
 */
	virtual void read_Linac_glob_signals(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_key_ext acquisition result.
 */
	virtual void read_Linac_key_ext(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_key_int acquisition result.
 */
	virtual void read_Linac_key_int(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_key_release acquisition result.
 */
	virtual void read_Linac_key_release(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_mod_abi_hv acquisition result.
 */
	virtual void read_Linac_mod_abi_hv(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_mod_abi_rf acquisition result.
 */
	virtual void read_Linac_mod_abi_rf(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_mod_hv acquisition result.
 */
	virtual void read_Linac_mod_hv(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_mod_rf acquisition result.
 */
	virtual void read_Linac_mod_rf(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_mod_positions acquisition result.
 */
	virtual void read_Linac_mod_positions(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_mod_pre_hv_abi acquisition result.
 */
	virtual void read_Linac_mod_pre_hv_abi(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_pickup acquisition result.
 */
	virtual void read_Linac_pickup(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_safety acquisition result.
 */
	virtual void read_Linac_safety(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_search_barriers acquisition result.
 */
	virtual void read_Linac_search_barriers(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_search_buttons acquisition result.
 */
	virtual void read_Linac_search_buttons(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_search_doorlights acquisition result.
 */
	virtual void read_Linac_search_doorlights(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_search_lights acquisition result.
 */
	virtual void read_Linac_search_lights(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_search_req_l acquisition result.
 */
	virtual void read_Linac_search_req_l(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_search_req_tl acquisition result.
 */
	virtual void read_Linac_search_req_tl(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_search_req_e0 acquisition result.
 */
	virtual void read_Linac_search_req_e0(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_search_req_e1 acquisition result.
 */
	virtual void read_Linac_search_req_e1(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_search_req_e2 acquisition result.
 */
	virtual void read_Linac_search_req_e2(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_search_req_e3 acquisition result.
 */
	virtual void read_Linac_search_req_e3(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_search_signals_e0 acquisition result.
 */
	virtual void read_Linac_search_signals_e0(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_search_signals_e1 acquisition result.
 */
	virtual void read_Linac_search_signals_e1(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_search_signals_e2 acquisition result.
 */
	virtual void read_Linac_search_signals_e2(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_search_signals_e3 acquisition result.
 */
	virtual void read_Linac_search_signals_e3(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_search_signals_l acquisition result.
 */
	virtual void read_Linac_search_signals_l(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_search_signals_tl acquisition result.
 */
	virtual void read_Linac_search_signals_tl(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_search_ini_e0 acquisition result.
 */
	virtual void read_Linac_search_ini_e0(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_search_ini_e1 acquisition result.
 */
	virtual void read_Linac_search_ini_e1(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_search_ini_e2 acquisition result.
 */
	virtual void read_Linac_search_ini_e2(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_search_ini_e3 acquisition result.
 */
	virtual void read_Linac_search_ini_e3(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_search_ini_l acquisition result.
 */
	virtual void read_Linac_search_ini_l(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_search_ini_tl acquisition result.
 */
	virtual void read_Linac_search_ini_tl(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_search_fail_e0 acquisition result.
 */
	virtual void read_Linac_search_fail_e0(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_search_fail_e1 acquisition result.
 */
	virtual void read_Linac_search_fail_e1(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_search_fail_e2 acquisition result.
 */
	virtual void read_Linac_search_fail_e2(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_search_fail_e3 acquisition result.
 */
	virtual void read_Linac_search_fail_e3(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_search_fail_l acquisition result.
 */
	virtual void read_Linac_search_fail_l(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_search_fail_tl acquisition result.
 */
	virtual void read_Linac_search_fail_tl(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_sir_buz acquisition result.
 */
	virtual void read_Linac_sir_buz(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_state acquisition result.
 */
	virtual void read_Linac_state(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_switches_abi acquisition result.
 */
	virtual void read_Linac_switches_abi(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_switches_config acquisition result.
 */
	virtual void read_Linac_switches_config(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_switches_load acquisition result.
 */
	virtual void read_Linac_switches_load(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_switches_moving acquisition result.
 */
	virtual void read_Linac_switches_moving(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_switches_stable acquisition result.
 */
	virtual void read_Linac_switches_stable(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_doors_ext acquisition result.
 */
	virtual void read_Linac_doors_ext(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_access_names acquisition result.
 */
	virtual void read_Linac_access_names(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_search_names acquisition result.
 */
	virtual void read_Linac_search_names(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_doors_memoopen_ext acquisition result.
 */
	virtual void read_Linac_doors_memoopen_ext(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_emergency_memo_buttons acquisition result.
 */
	virtual void read_Linac_emergency_memo_buttons(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_badge_on acquisition result.
 */
	virtual void read_Linac_badge_on(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_mod_inhib_rf_k1 acquisition result.
 */
	virtual void read_Linac_mod_inhib_rf_k1(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_mod_inhib_rf_k2 acquisition result.
 */
	virtual void read_Linac_mod_inhib_rf_k2(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_mod_inhib_hv_k1 acquisition result.
 */
	virtual void read_Linac_mod_inhib_hv_k1(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_mod_inhib_hv_k2 acquisition result.
 */
	virtual void read_Linac_mod_inhib_hv_k2(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_mod_inhib_hv_ks acquisition result.
 */
	virtual void read_Linac_mod_inhib_hv_ks(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_mod_inhib_rf_ks acquisition result.
 */
	virtual void read_Linac_mod_inhib_rf_ks(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_mod_inhib_rf_gen acquisition result.
 */
	virtual void read_Linac_mod_inhib_rf_gen(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Linac_mod_inhib_hv_gen acquisition result.
 */
	virtual void read_Linac_mod_inhib_hv_gen(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_access_signals acquisition result.
 */
	virtual void read_Undulator_access_signals(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_access_state acquisition result.
 */
	virtual void read_Undulator_access_state(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_access_hutch acquisition result.
 */
	virtual void read_Undulator_access_hutch(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_badge_all acquisition result.
 */
	virtual void read_Undulator_badge_all(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_badge_ack acquisition result.
 */
	virtual void read_Undulator_badge_ack(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_badge_on acquisition result.
 */
	virtual void read_Undulator_badge_on(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_boards_disabled acquisition result.
 */
	virtual void read_Undulator_boards_disabled(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_board_disabled_xxx acquisition result.
 */
	virtual void read_Undulator_board_disabled_008(Tango::Attribute &attr);
	virtual void read_Undulator_board_disabled_024(Tango::Attribute &attr);
	virtual void read_Undulator_board_disabled_100(Tango::Attribute &attr);
	virtual void read_Undulator_board_disabled_106(Tango::Attribute &attr);
	virtual void read_Undulator_board_disabled_126(Tango::Attribute &attr);
	virtual void read_Undulator_board_disabled_132(Tango::Attribute &attr);
	virtual void read_Undulator_board_disabled_152(Tango::Attribute &attr);
	virtual void read_Undulator_board_disabled_158(Tango::Attribute &attr);
	virtual void read_Undulator_board_disabled_178(Tango::Attribute &attr);
	virtual void read_Undulator_board_disabled_184(Tango::Attribute &attr);
	virtual void read_Undulator_board_disabled_204(Tango::Attribute &attr);
	virtual void read_Undulator_board_disabled_214(Tango::Attribute &attr);
	virtual void read_Undulator_board_disabled_248(Tango::Attribute &attr);
	virtual void read_Undulator_board_disabled_270(Tango::Attribute &attr);
	virtual void read_Undulator_board_disabled_288(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_boards_resettable acquisition result.
 */
	virtual void read_Undulator_boards_resettable(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_bst1_fel1 acquisition result.
 */
	virtual void read_Undulator_bst1_fel1(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_bst2_fel1 acquisition result.
 */
	virtual void read_Undulator_bst2_fel1(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_bst1_fel2 acquisition result.
 */
	virtual void read_Undulator_bst1_fel2(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_bst2_fel2 acquisition result.
 */
	virtual void read_Undulator_bst2_fel2(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_bst_diag acquisition result.
 */
	virtual void read_Undulator_bst_diag(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_bst_inhibit_linac acquisition result.
 */
	virtual void read_Undulator_bst_inhibit_linac(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_bst_inhibit_bl acquisition result.
 */
	virtual void read_Undulator_bst_inhibit_bl(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_disp_ext_code acquisition result.
 */
	virtual void read_Undulator_disp_ext_code(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_disp_int_code acquisition result.
 */
	virtual void read_Undulator_disp_int_code(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_doors_e4 acquisition result.
 */
	virtual void read_Undulator_doors_e4(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_doors_e5 acquisition result.
 */
	virtual void read_Undulator_doors_e5(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_doors_e6 acquisition result.
 */
	virtual void read_Undulator_doors_e6(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_doors_e7 acquisition result.
 */
	virtual void read_Undulator_doors_e7(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_doors_so acquisition result.
 */
	virtual void read_Undulator_doors_so(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_doors_esa acquisition result.
 */
	virtual void read_Undulator_doors_esa(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_doors_memoopen_e4 acquisition result.
 */
	virtual void read_Undulator_doors_memoopen_e4(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_doors_memoopen_e5 acquisition result.
 */
	virtual void read_Undulator_doors_memoopen_e5(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_doors_memoopen_e6 acquisition result.
 */
	virtual void read_Undulator_doors_memoopen_e6(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_doors_memoopen_e7 acquisition result.
 */
	virtual void read_Undulator_doors_memoopen_e7(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_doors_memoopen_so acquisition result.
 */
	virtual void read_Undulator_doors_memoopen_so(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_doors_memoopen_esa acquisition result.
 */
	virtual void read_Undulator_doors_memoopen_esa(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_emergency_buttons acquisition result.
 */
	virtual void read_Undulator_emergency_buttons(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_emergency_memo_buttons acquisition result.
 */
	virtual void read_Undulator_emergency_memo_buttons(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_glob_signals acquisition result.
 */
	virtual void read_Undulator_glob_signals(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_key_glob acquisition result.
 */
	virtual void read_Undulator_key_glob(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_key_ext acquisition result.
 */
	virtual void read_Undulator_key_ext(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_key_int acquisition result.
 */
	virtual void read_Undulator_key_int(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_key_release acquisition result.
 */
	virtual void read_Undulator_key_release(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_search_barriers acquisition result.
 */
	virtual void read_Undulator_search_barriers(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_search_buttons acquisition result.
 */
	virtual void read_Undulator_search_buttons(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_search_doorlights acquisition result.
 */
	virtual void read_Undulator_search_doorlights(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_search_lights acquisition result.
 */
	virtual void read_Undulator_search_lights(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_search_req_so acquisition result.
 */
	virtual void read_Undulator_search_req_so(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_search_req_e4 acquisition result.
 */
	virtual void read_Undulator_search_req_e4(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_search_req_e5 acquisition result.
 */
	virtual void read_Undulator_search_req_e5(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_search_req_e6 acquisition result.
 */
	virtual void read_Undulator_search_req_e6(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_search_req_e7 acquisition result.
 */
	virtual void read_Undulator_search_req_e7(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_search_req_esa1 acquisition result.
 */
	virtual void read_Undulator_search_req_esa1(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_search_req_esa2 acquisition result.
 */
	virtual void read_Undulator_search_req_esa2(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_search_signals_so acquisition result.
 */
	virtual void read_Undulator_search_signals_so(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_search_signals_e4 acquisition result.
 */
	virtual void read_Undulator_search_signals_e4(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_search_signals_e5 acquisition result.
 */
	virtual void read_Undulator_search_signals_e5(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_search_signals_e6 acquisition result.
 */
	virtual void read_Undulator_search_signals_e6(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_search_signals_e7 acquisition result.
 */
	virtual void read_Undulator_search_signals_e7(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_search_signals_esa1 acquisition result.
 */
	virtual void read_Undulator_search_signals_esa1(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_search_signals_esa2 acquisition result.
 */
	virtual void read_Undulator_search_signals_esa2(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_search_ini_so acquisition result.
 */
	virtual void read_Undulator_search_ini_so(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_search_ini_e4 acquisition result.
 */
	virtual void read_Undulator_search_ini_e4(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_search_ini_e5 acquisition result.
 */
	virtual void read_Undulator_search_ini_e5(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_search_ini_e6 acquisition result.
 */
	virtual void read_Undulator_search_ini_e6(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_search_ini_e7 acquisition result.
 */
	virtual void read_Undulator_search_ini_e7(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_search_fail_so acquisition result.
 */
	virtual void read_Undulator_search_fail_so(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_search_fail_e4 acquisition result.
 */
	virtual void read_Undulator_search_fail_e4(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_search_fail_e5 acquisition result.
 */
	virtual void read_Undulator_search_fail_e5(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_search_fail_e6 acquisition result.
 */
	virtual void read_Undulator_search_fail_e6(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_search_fail_e7 acquisition result.
 */
	virtual void read_Undulator_search_fail_e7(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_search_fail_esa1 acquisition result.
 */
	virtual void read_Undulator_search_fail_esa1(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_search_fail_esa2 acquisition result.
 */
	virtual void read_Undulator_search_fail_esa2(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_sir_buz acquisition result.
 */
	virtual void read_Undulator_sir_buz(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Undulator_state acquisition result.
 */
	virtual void read_Undulator_state(Tango::Attribute &attr);
/**
 *	Read/Write allowed for Linac_mod_on_pcgun attribute.
 */
	virtual bool is_Linac_mod_on_pcgun_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_mod_onS0 attribute.
 */
	virtual bool is_Linac_mod_onS0_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_mbd_current attribute.
 */
	virtual bool is_Linac_mbd_current_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Plc_status attribute.
 */
	virtual bool is_Plc_status_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_plc_status attribute.
 */
	virtual bool is_Undulator_plc_status_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_cm_sfel_01_01 attribute.
 */
	virtual bool is_Undulator_cm_sfel_01_01_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_cm_sfel_02_01 attribute.
 */
	virtual bool is_Undulator_cm_sfel_02_01_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_cm_mbd_fel_01_01 attribute.
 */
	virtual bool is_Undulator_cm_mbd_fel_01_01_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_cm_mbd_fel_02_01 attribute.
 */
	virtual bool is_Undulator_cm_mbd_fel_02_01_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_cm_mbd_01 attribute.
 */
	virtual bool is_Undulator_cm_mbd_01_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_mbd_fel_1 attribute.
 */
	virtual bool is_Undulator_mbd_fel_1_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_mbd_fel_2 attribute.
 */
	virtual bool is_Undulator_mbd_fel_2_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_mbd_01 attribute.
 */
	virtual bool is_Undulator_mbd_01_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_sprd_fel_1 attribute.
 */
	virtual bool is_Undulator_sprd_fel_1_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_sprd_fel_2 attribute.
 */
	virtual bool is_Undulator_sprd_fel_2_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Version attribute.
 */
	virtual bool is_Version_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Exphall_gamma attribute.
 */
	virtual bool is_Exphall_gamma_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_access_signals attribute.
 */
	virtual bool is_Linac_access_signals_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_access_state attribute.
 */
	virtual bool is_Linac_access_state_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_badge_all attribute.
 */
	virtual bool is_Linac_badge_all_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_badge_ack attribute.
 */
	virtual bool is_Linac_badge_ack_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_boards_disabled attribute.
 */
	virtual bool is_Linac_boards_disabled_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_board_disabled_xxx attribute.
 */
	virtual bool is_Linac_board_disabled_008_allowed(Tango::AttReqType type);
	virtual bool is_Linac_board_disabled_040_allowed(Tango::AttReqType type);
	virtual bool is_Linac_board_disabled_058_allowed(Tango::AttReqType type);
	virtual bool is_Linac_board_disabled_068_allowed(Tango::AttReqType type);
	virtual bool is_Linac_board_disabled_078_allowed(Tango::AttReqType type);
	virtual bool is_Linac_board_disabled_100_allowed(Tango::AttReqType type);
	virtual bool is_Linac_board_disabled_106_allowed(Tango::AttReqType type);
	virtual bool is_Linac_board_disabled_126_allowed(Tango::AttReqType type);
	virtual bool is_Linac_board_disabled_132_allowed(Tango::AttReqType type);
	virtual bool is_Linac_board_disabled_152_allowed(Tango::AttReqType type);
	virtual bool is_Linac_board_disabled_158_allowed(Tango::AttReqType type);
	virtual bool is_Linac_board_disabled_178_allowed(Tango::AttReqType type);
	virtual bool is_Linac_board_disabled_184_allowed(Tango::AttReqType type);
	virtual bool is_Linac_board_disabled_190_allowed(Tango::AttReqType type);
	virtual bool is_Linac_board_disabled_196_allowed(Tango::AttReqType type);
	virtual bool is_Linac_board_disabled_202_allowed(Tango::AttReqType type);
	virtual bool is_Linac_board_disabled_216_allowed(Tango::AttReqType type);
	virtual bool is_Linac_board_disabled_240_allowed(Tango::AttReqType type);
	virtual bool is_Linac_board_disabled_252_allowed(Tango::AttReqType type);
	virtual bool is_Linac_board_disabled_258_allowed(Tango::AttReqType type);
	virtual bool is_Linac_board_disabled_280_allowed(Tango::AttReqType type);
	virtual bool is_Linac_board_disabled_286_allowed(Tango::AttReqType type);
	virtual bool is_Linac_board_disabled_308_allowed(Tango::AttReqType type);
	virtual bool is_Linac_board_disabled_314_allowed(Tango::AttReqType type);
	virtual bool is_Linac_board_disabled_088_allowed(Tango::AttReqType type);
	virtual bool is_Linac_board_disabled_232_allowed(Tango::AttReqType type);
	virtual bool is_Linac_board_disabled_222_allowed(Tango::AttReqType type);
	virtual bool is_Linac_board_disabled_227_allowed(Tango::AttReqType type);
	virtual bool is_Linac_board_disabled_246_allowed(Tango::AttReqType type);
	virtual bool is_Linac_board_disabled_264_allowed(Tango::AttReqType type);
	virtual bool is_Linac_board_disabled_269_allowed(Tango::AttReqType type);
	virtual bool is_Linac_board_disabled_292_allowed(Tango::AttReqType type);
	virtual bool is_Linac_board_disabled_297_allowed(Tango::AttReqType type);
	virtual bool is_Linac_board_disabled_320_allowed(Tango::AttReqType type);
	virtual bool is_Linac_board_disabled_325_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_boards_resettable attribute.
 */
	virtual bool is_Linac_boards_resettable_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_bst_1 attribute.
 */
	virtual bool is_Linac_bst_1_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_disp_ext_code attribute.
 */
	virtual bool is_Linac_disp_ext_code_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_disp_int_code attribute.
 */
	virtual bool is_Linac_disp_int_code_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_doors_e0 attribute.
 */
	virtual bool is_Linac_doors_e0_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_doors_e1 attribute.
 */
	virtual bool is_Linac_doors_e1_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_doors_e2 attribute.
 */
	virtual bool is_Linac_doors_e2_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_doors_e3 attribute.
 */
	virtual bool is_Linac_doors_e3_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_doors_l attribute.
 */
	virtual bool is_Linac_doors_l_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_doors_tl attribute.
 */
	virtual bool is_Linac_doors_tl_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_doors_memoopen_e0 attribute.
 */
	virtual bool is_Linac_doors_memoopen_e0_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_doors_memoopen_e1 attribute.
 */
	virtual bool is_Linac_doors_memoopen_e1_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_doors_memoopen_e2 attribute.
 */
	virtual bool is_Linac_doors_memoopen_e2_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_doors_memoopen_e3 attribute.
 */
	virtual bool is_Linac_doors_memoopen_e3_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_doors_memoopen_l attribute.
 */
	virtual bool is_Linac_doors_memoopen_l_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_doors_memoopen_tl attribute.
 */
	virtual bool is_Linac_doors_memoopen_tl_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_emergency_buttons attribute.
 */
	virtual bool is_Linac_emergency_buttons_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_gamma attribute.
 */
	virtual bool is_Linac_gamma_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_key_glob attribute.
 */
	virtual bool is_Linac_key_glob_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_glob_signals attribute.
 */
	virtual bool is_Linac_glob_signals_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_key_ext attribute.
 */
	virtual bool is_Linac_key_ext_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_key_int attribute.
 */
	virtual bool is_Linac_key_int_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_key_release attribute.
 */
	virtual bool is_Linac_key_release_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_mod_abi_hv attribute.
 */
	virtual bool is_Linac_mod_abi_hv_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_mod_abi_rf attribute.
 */
	virtual bool is_Linac_mod_abi_rf_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_mod_hv attribute.
 */
	virtual bool is_Linac_mod_hv_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_mod_rf attribute.
 */
	virtual bool is_Linac_mod_rf_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_mod_positions attribute.
 */
	virtual bool is_Linac_mod_positions_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_mod_pre_hv_abi attribute.
 */
	virtual bool is_Linac_mod_pre_hv_abi_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_pickup attribute.
 */
	virtual bool is_Linac_pickup_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_safety attribute.
 */
	virtual bool is_Linac_safety_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_search_barriers attribute.
 */
	virtual bool is_Linac_search_barriers_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_search_buttons attribute.
 */
	virtual bool is_Linac_search_buttons_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_search_doorlights attribute.
 */
	virtual bool is_Linac_search_doorlights_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_search_lights attribute.
 */
	virtual bool is_Linac_search_lights_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_search_req_l attribute.
 */
	virtual bool is_Linac_search_req_l_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_search_req_tl attribute.
 */
	virtual bool is_Linac_search_req_tl_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_search_req_e0 attribute.
 */
	virtual bool is_Linac_search_req_e0_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_search_req_e1 attribute.
 */
	virtual bool is_Linac_search_req_e1_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_search_req_e2 attribute.
 */
	virtual bool is_Linac_search_req_e2_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_search_req_e3 attribute.
 */
	virtual bool is_Linac_search_req_e3_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_search_signals_e0 attribute.
 */
	virtual bool is_Linac_search_signals_e0_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_search_signals_e1 attribute.
 */
	virtual bool is_Linac_search_signals_e1_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_search_signals_e2 attribute.
 */
	virtual bool is_Linac_search_signals_e2_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_search_signals_e3 attribute.
 */
	virtual bool is_Linac_search_signals_e3_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_search_signals_l attribute.
 */
	virtual bool is_Linac_search_signals_l_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_search_signals_tl attribute.
 */
	virtual bool is_Linac_search_signals_tl_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_search_ini_e0 attribute.
 */
	virtual bool is_Linac_search_ini_e0_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_search_ini_e1 attribute.
 */
	virtual bool is_Linac_search_ini_e1_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_search_ini_e2 attribute.
 */
	virtual bool is_Linac_search_ini_e2_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_search_ini_e3 attribute.
 */
	virtual bool is_Linac_search_ini_e3_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_search_ini_l attribute.
 */
	virtual bool is_Linac_search_ini_l_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_search_ini_tl attribute.
 */
	virtual bool is_Linac_search_ini_tl_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_search_fail_e0 attribute.
 */
	virtual bool is_Linac_search_fail_e0_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_search_fail_e1 attribute.
 */
	virtual bool is_Linac_search_fail_e1_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_search_fail_e2 attribute.
 */
	virtual bool is_Linac_search_fail_e2_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_search_fail_e3 attribute.
 */
	virtual bool is_Linac_search_fail_e3_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_search_fail_l attribute.
 */
	virtual bool is_Linac_search_fail_l_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_search_fail_tl attribute.
 */
	virtual bool is_Linac_search_fail_tl_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_sir_buz attribute.
 */
	virtual bool is_Linac_sir_buz_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_state attribute.
 */
	virtual bool is_Linac_state_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_switches_abi attribute.
 */
	virtual bool is_Linac_switches_abi_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_switches_config attribute.
 */
	virtual bool is_Linac_switches_config_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_switches_load attribute.
 */
	virtual bool is_Linac_switches_load_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_switches_moving attribute.
 */
	virtual bool is_Linac_switches_moving_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_switches_stable attribute.
 */
	virtual bool is_Linac_switches_stable_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_doors_ext attribute.
 */
	virtual bool is_Linac_doors_ext_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_access_names attribute.
 */
	virtual bool is_Linac_access_names_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_search_names attribute.
 */
	virtual bool is_Linac_search_names_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_doors_memoopen_ext attribute.
 */
	virtual bool is_Linac_doors_memoopen_ext_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_emergency_memo_buttons attribute.
 */
	virtual bool is_Linac_emergency_memo_buttons_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_badge_on attribute.
 */
	virtual bool is_Linac_badge_on_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_mod_inhib_rf_k1 attribute.
 */
	virtual bool is_Linac_mod_inhib_rf_k1_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_mod_inhib_rf_k2 attribute.
 */
	virtual bool is_Linac_mod_inhib_rf_k2_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_mod_inhib_hv_k1 attribute.
 */
	virtual bool is_Linac_mod_inhib_hv_k1_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_mod_inhib_hv_k2 attribute.
 */
	virtual bool is_Linac_mod_inhib_hv_k2_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_mod_inhib_hv_ks attribute.
 */
	virtual bool is_Linac_mod_inhib_hv_ks_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_mod_inhib_rf_ks attribute.
 */
	virtual bool is_Linac_mod_inhib_rf_ks_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_mod_inhib_rf_gen attribute.
 */
	virtual bool is_Linac_mod_inhib_rf_gen_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Linac_mod_inhib_hv_gen attribute.
 */
	virtual bool is_Linac_mod_inhib_hv_gen_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_access_signals attribute.
 */
	virtual bool is_Undulator_access_signals_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_access_state attribute.
 */
	virtual bool is_Undulator_access_state_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_access_hutch attribute.
 */
	virtual bool is_Undulator_access_hutch_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_badge_all attribute.
 */
	virtual bool is_Undulator_badge_all_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_badge_ack attribute.
 */
	virtual bool is_Undulator_badge_ack_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_badge_on attribute.
 */
	virtual bool is_Undulator_badge_on_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_boards_disabled attribute.
 */
	virtual bool is_Undulator_boards_disabled_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_board_disabled_xxx attribute.
 */
	virtual bool is_Undulator_board_disabled_008_allowed(Tango::AttReqType type);
	virtual bool is_Undulator_board_disabled_024_allowed(Tango::AttReqType type);
	virtual bool is_Undulator_board_disabled_100_allowed(Tango::AttReqType type);
	virtual bool is_Undulator_board_disabled_106_allowed(Tango::AttReqType type);
	virtual bool is_Undulator_board_disabled_126_allowed(Tango::AttReqType type);
	virtual bool is_Undulator_board_disabled_132_allowed(Tango::AttReqType type);
	virtual bool is_Undulator_board_disabled_152_allowed(Tango::AttReqType type);
	virtual bool is_Undulator_board_disabled_158_allowed(Tango::AttReqType type);
	virtual bool is_Undulator_board_disabled_178_allowed(Tango::AttReqType type);
	virtual bool is_Undulator_board_disabled_184_allowed(Tango::AttReqType type);
	virtual bool is_Undulator_board_disabled_204_allowed(Tango::AttReqType type);
	virtual bool is_Undulator_board_disabled_214_allowed(Tango::AttReqType type);
	virtual bool is_Undulator_board_disabled_248_allowed(Tango::AttReqType type);
	virtual bool is_Undulator_board_disabled_270_allowed(Tango::AttReqType type);
	virtual bool is_Undulator_board_disabled_288_allowed(Tango::AttReqType type);
	
/**
 *	Read/Write allowed for Undulator_boards_resettable attribute.
 */
	virtual bool is_Undulator_boards_resettable_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_bst1_fel1 attribute.
 */
	virtual bool is_Undulator_bst1_fel1_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_bst2_fel1 attribute.
 */
	virtual bool is_Undulator_bst2_fel1_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_bst1_fel2 attribute.
 */
	virtual bool is_Undulator_bst1_fel2_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_bst2_fel2 attribute.
 */
	virtual bool is_Undulator_bst2_fel2_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_bst_diag attribute.
 */
	virtual bool is_Undulator_bst_diag_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_bst_inhibit_linac attribute.
 */
	virtual bool is_Undulator_bst_inhibit_linac_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_bst_inhibit_bl attribute.
 */
	virtual bool is_Undulator_bst_inhibit_bl_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_disp_ext_code attribute.
 */
	virtual bool is_Undulator_disp_ext_code_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_disp_int_code attribute.
 */
	virtual bool is_Undulator_disp_int_code_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_doors_e4 attribute.
 */
	virtual bool is_Undulator_doors_e4_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_doors_e5 attribute.
 */
	virtual bool is_Undulator_doors_e5_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_doors_e6 attribute.
 */
	virtual bool is_Undulator_doors_e6_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_doors_e7 attribute.
 */
	virtual bool is_Undulator_doors_e7_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_doors_so attribute.
 */
	virtual bool is_Undulator_doors_so_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_doors_esa attribute.
 */
	virtual bool is_Undulator_doors_esa_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_doors_memoopen_e4 attribute.
 */
	virtual bool is_Undulator_doors_memoopen_e4_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_doors_memoopen_e5 attribute.
 */
	virtual bool is_Undulator_doors_memoopen_e5_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_doors_memoopen_e6 attribute.
 */
	virtual bool is_Undulator_doors_memoopen_e6_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_doors_memoopen_e7 attribute.
 */
	virtual bool is_Undulator_doors_memoopen_e7_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_doors_memoopen_so attribute.
 */
	virtual bool is_Undulator_doors_memoopen_so_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_doors_memoopen_esa attribute.
 */
	virtual bool is_Undulator_doors_memoopen_esa_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_emergency_buttons attribute.
 */
	virtual bool is_Undulator_emergency_buttons_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_emergency_memo_buttons attribute.
 */
	virtual bool is_Undulator_emergency_memo_buttons_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_glob_signals attribute.
 */
	virtual bool is_Undulator_glob_signals_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_key_glob attribute.
 */
	virtual bool is_Undulator_key_glob_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_key_ext attribute.
 */
	virtual bool is_Undulator_key_ext_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_key_int attribute.
 */
	virtual bool is_Undulator_key_int_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_key_release attribute.
 */
	virtual bool is_Undulator_key_release_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_search_barriers attribute.
 */
	virtual bool is_Undulator_search_barriers_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_search_buttons attribute.
 */
	virtual bool is_Undulator_search_buttons_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_search_doorlights attribute.
 */
	virtual bool is_Undulator_search_doorlights_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_search_lights attribute.
 */
	virtual bool is_Undulator_search_lights_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_search_req_so attribute.
 */
	virtual bool is_Undulator_search_req_so_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_search_req_e4 attribute.
 */
	virtual bool is_Undulator_search_req_e4_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_search_req_e5 attribute.
 */
	virtual bool is_Undulator_search_req_e5_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_search_req_e6 attribute.
 */
	virtual bool is_Undulator_search_req_e6_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_search_req_e7 attribute.
 */
	virtual bool is_Undulator_search_req_e7_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_search_req_esa1 attribute.
 */
	virtual bool is_Undulator_search_req_esa1_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_search_req_esa2 attribute.
 */
	virtual bool is_Undulator_search_req_esa2_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_search_signals_so attribute.
 */
	virtual bool is_Undulator_search_signals_so_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_search_signals_e4 attribute.
 */
	virtual bool is_Undulator_search_signals_e4_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_search_signals_e5 attribute.
 */
	virtual bool is_Undulator_search_signals_e5_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_search_signals_e6 attribute.
 */
	virtual bool is_Undulator_search_signals_e6_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_search_signals_e7 attribute.
 */
	virtual bool is_Undulator_search_signals_e7_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_search_signals_esa1 attribute.
 */
	virtual bool is_Undulator_search_signals_esa1_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_search_signals_esa2 attribute.
 */
	virtual bool is_Undulator_search_signals_esa2_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_search_ini_so attribute.
 */
	virtual bool is_Undulator_search_ini_so_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_search_ini_e4 attribute.
 */
	virtual bool is_Undulator_search_ini_e4_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_search_ini_e5 attribute.
 */
	virtual bool is_Undulator_search_ini_e5_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_search_ini_e6 attribute.
 */
	virtual bool is_Undulator_search_ini_e6_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_search_ini_e7 attribute.
 */
	virtual bool is_Undulator_search_ini_e7_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_search_fail_so attribute.
 */
	virtual bool is_Undulator_search_fail_so_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_search_fail_e4 attribute.
 */
	virtual bool is_Undulator_search_fail_e4_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_search_fail_e5 attribute.
 */
	virtual bool is_Undulator_search_fail_e5_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_search_fail_e6 attribute.
 */
	virtual bool is_Undulator_search_fail_e6_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_search_fail_e7 attribute.
 */
	virtual bool is_Undulator_search_fail_e7_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_search_fail_esa1 attribute.
 */
	virtual bool is_Undulator_search_fail_esa1_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_search_fail_esa2 attribute.
 */
	virtual bool is_Undulator_search_fail_esa2_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_sir_buz attribute.
 */
	virtual bool is_Undulator_sir_buz_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Undulator_state attribute.
 */
	virtual bool is_Undulator_state_allowed(Tango::AttReqType type);
/**
 *	Execution allowed for LinacSwitchConf command.
 */
	virtual bool is_LinacSwitchConf_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for LinacDelPosto command.
 */
	virtual bool is_LinacDelPosto_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for LinacBstOpen command.
 */
	virtual bool is_LinacBstOpen_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for LinacBstClose command.
 */
	virtual bool is_LinacBstClose_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for LinacRPasv command.
 */
	virtual bool is_LinacRPasv_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for LinacEmeAck command.
 */
	virtual bool is_LinacEmeAck_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for LinacEmeTLAck command.
 */
	virtual bool is_LinacEmeTLAck_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for LinacSearchRequest command.
 */
	virtual bool is_LinacSearchRequest_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for LinacSearchStart command.
 */
	virtual bool is_LinacSearchStart_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for LinacSearchStop command.
 */
	virtual bool is_LinacSearchStop_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for LinacDoorReset command.
 */
	virtual bool is_LinacDoorReset_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for LinacDoorOpen command.
 */
	virtual bool is_LinacDoorOpen_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for LinacAckDoor command.
 */
	virtual bool is_LinacAckDoor_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for LinacService command.
 */
	virtual bool is_LinacService_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for UndulatorDelPosto command.
 */
	virtual bool is_UndulatorDelPosto_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for UndulatorBstOpen command.
 */
	virtual bool is_UndulatorBstOpen_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for UndulatorBstClose command.
 */
	virtual bool is_UndulatorBstClose_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for UndulatorRPasv command.
 */
	virtual bool is_UndulatorRPasv_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for UndulatorEmeAck command.
 */
	virtual bool is_UndulatorEmeAck_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for UndulatorSearchRequest command.
 */
	virtual bool is_UndulatorSearchRequest_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for UndulatorSearchStart command.
 */
	virtual bool is_UndulatorSearchStart_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for UndulatorSearchStop command.
 */
	virtual bool is_UndulatorSearchStop_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for UndulatorDoorReset command.
 */
	virtual bool is_UndulatorDoorReset_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for UndulatorDoorOpen command.
 */
	virtual bool is_UndulatorDoorOpen_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for UndulatorAckDoor command.
 */
	virtual bool is_UndulatorAckDoor_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for UndulatorService command.
 */
	virtual bool is_UndulatorService_allowed(const CORBA::Any &any);
/**
 * 
 *	@param	argin	from 0 to 9
 *	@exception DevFailed
 */
	void	linac_switch_conf(Tango::DevShort);
/**
 * 
 *	@param	argin	
 *	@exception DevFailed
 */
	void	linac_del_posto(const Tango::DevVarStringArray *);
/**
 * 
 *	@exception DevFailed
 */
	void	linac_bst_open();
/**
 * 
 *	@exception DevFailed
 */
	void	linac_bst_close();
/**
 * 
 *	@exception DevFailed
 */
	void	linac_rpasv();
/**
 * 
 *	@exception DevFailed
 */
	void	linac_eme_ack();
/**
 * 
 *	@exception DevFailed
 */
	void	linac_eme_tlack();
/**
 * vFailed
 *	@exception DevFailed
 */
	void	linac_search_request();
/**
 * 
 *	@param	argin	from 1 to 5
 *	@exception DevFailed
 */
	void	linac_search_start(Tango::DevShort);
/**
 * 
 *	@param	argin	from 1 to 5
 *	@exception DevFailed
 */
	void	linac_search_stop(Tango::DevShort);
/**
 * 
 *	@exception DevFailed
 */
	void	linac_door_reset();
/**
 * 
 *	@exception DevFailed
 */
	void	linac_door_open();
/**
 * 
 *	@param	argin	from 0 to 2
 *	@exception DevFailed
 */
	void	linac_ack_door(Tango::DevShort);
/**
 * 
 *	@param	argin	
 *	@exception DevFailed
 */
	void	linac_service(const Tango::DevVarStringArray *);
/**
 * 
 *	@param	argin	from 0 to 15 + password
 *	@exception DevFailed
 */
	void	undulator_del_posto(const Tango::DevVarStringArray *);
/**
 * 
 *	@param	argin	bst id from 1 to 5
 *	@exception DevFailed
 */
	void	undulator_bst_open(Tango::DevShort);
/**
 * 
 *	@param	argin	bst id from 1 to 5
 *	@exception DevFailed
 */
	void	undulator_bst_close(Tango::DevShort);
/**
 * 
 *	@exception DevFailed
 */
	void	undulator_rpasv();
/**
 * 
 *	@exception DevFailed
 */
	void	undulator_eme_ack();
/**
 * 
 *	@exception DevFailed
 */
	void	undulator_search_request();
/**
 * 
 *	@param	argin	0=UH 1=ESA1 2=ESA2 4-7=EmergencyExit4-7
 *	@exception DevFailed
 */
	void	undulator_search_start(Tango::DevShort);
/**
 * 
 *	@param	argin	0=UH 1=ESA1 2=ESA2 4-7=EmergencyExit4-7
 *	@exception DevFailed
 */
	void	undulator_search_stop(Tango::DevShort);
/**
 * 
 *	@exception DevFailed
 */
	void	undulator_door_reset();
/**
 * 
 *	@exception DevFailed
 */
	void	undulator_door_open();
/**
 * 
 *	@param	argin	from 0 to 80
 *	@exception DevFailed
 */
	void	undulator_ack_door(Tango::DevShort);
/**
 * 0,5 undulator hall
 *	1,6 E4
 *	2,7 E5
 *	3,8 E6
 *	4,9 E7
 *	@param	argin	service code
 *	@exception DevFailed
 */
	void	undulator_service(const Tango::DevVarStringArray *);

/**
 *	Read the device properties from database
 */
	 void get_device_property();
//@}

	//	Here is the end of the automatic code generation part
	//-------------------------------------------------------------	
	ifstream  fd;		//startup file
	string 	start_file;

	void load_cond(void);//load bit info from file
	void init_attributeprop(void);//init attribute properties
	void init_database(void);

	Tango::DevBoolean*	val_bool[MAX_N_ATTR];
	Tango::DevShort*	val_short[MAX_N_ATTR];
	Tango::DevShort*	val_byt[MAX_N_ATTR];
	Tango::DevFloat*		val_real[MAX_N_ATTR];
	Tango::DevString*	val_string[MAX_N_ATTR];
	char version_str[1024];
	

	start_idx*		pos_idx[MAX_N_ATTR];
	Tango::DevString*	val_labels[MAX_N_ATTR];
	Tango::DevString*	val_pos[MAX_N_ATTR];

	Tango::DevShort		att_index[MAX_N_ATTR];

	Tango::DevString	att_names[MAX_N_ATTR];
	Tango::DevShort		att_len[MAX_N_ATTR];
	Tango::DevString	att_db[MAX_N_ATTR];
	Tango::DevShort		att_type[MAX_N_ATTR];

	Tango::DevBoolean*	val_bool_undulator[MAX_N_ATTR];
	Tango::DevShort*	val_short_undulator[MAX_N_ATTR];
	Tango::DevShort*	val_byt_undulator[MAX_N_ATTR];
	Tango::DevFloat*		val_real_undulator[MAX_N_ATTR];
	Tango::DevString*	val_string_undulator[MAX_N_ATTR];
	start_idx*		pos_idx_undulator[MAX_N_ATTR];
	Tango::DevString*	val_labels_undulator[MAX_N_ATTR];
	Tango::DevString*	val_pos_undulator[MAX_N_ATTR];
	Tango::DevShort		att_index_undulator[MAX_N_ATTR];
	Tango::DevString	att_names_undulator[MAX_N_ATTR];
	Tango::DevShort		att_len_undulator[MAX_N_ATTR];
	Tango::DevString	att_db_undulator[MAX_N_ATTR];
	Tango::DevShort		att_type_undulator[MAX_N_ATTR];

	int			found_bool_undulator;
	int			found_string_undulator;
	int			found_short_undulator;
	int			found_byt_undulator;
	int			found_real_undulator;
	int			found_attr_undulator;
	int			found_cmd_undulator;
	int			found_stat_undulator;
	int			found_alm_undulator;

	Tango::DevString	dbb_names[MAX_N_DB];
	Tango::DevShort		dbb_len[MAX_N_DB];

	Tango::DevString	dbs_names[MAX_N_DB];
	Tango::DevShort		dbs_len[MAX_N_DB];

	Tango::DevBoolean	*db_bool[MAX_N_DB];
//	Tango::DevString 	**db_string;
	Tango::DevString 	*db_string[MAX_N_DB];


	Tango::DevString	cmd_names_undulator[MAX_N_CMD];
	Tango::DevShort		cmd_codes_undulator[MAX_N_CMD];
	Tango::DevShort		cmd_limits_undulator[MAX_N_CMD];

	Tango::DevString	cmd_names[MAX_N_CMD];
	Tango::DevShort		cmd_codes[MAX_N_CMD];
	Tango::DevShort		cmd_limits[MAX_N_CMD];
	int			found_bool;
	int			found_string;
	int			found_short;
	int			found_byt;
	int			found_real;
	int			found_attr;
	int			found_cmd;
	int			found_stat;
	int			found_alm;
	Tango::DevString	labels_stat[MESG_STAT_MAX_LEN];
	Tango::DevString	labels_alm[MESG_ALM_MAX_LEN];
	Tango::DevString	descr_stat[MESG_STAT_MAX_LEN];
	Tango::DevString	descr_alm[MESG_ALM_MAX_LEN];

	bool busy_key[NUM_KEYS];
	bool busy_key_undulator[NUM_KEYS];
	Tango::DevShort modpcgun;
	Tango::DevShort modS0;

	Tango::DevBoolean rondanames_ok;//ronda allowed people successful read
	Tango::DevBoolean ctrlnames_ok;//access allowed people successful read

	double timestamp_alm;
	double timestamp_stat;
	Tango::DevBoolean plc_status;
	Tango::DevBoolean plc_status_undulator;

	struct timeval last_cache_update;
	struct timeval last_cache_update_undulator;
	struct timeval now;

	Tango::DevShort		lsc[10];//support for linac_switches_config
	Tango::DevBoolean	lmp[11];//support for linac_mod_positions

	omni_mutex *mutex;


protected :	
	//	Add your own data members here
	//-----------------------------------------
	Tango::DeviceProxy * ll_server;
	Tango::DevBoolean	msg_stat[MESG_ALM_MAX_LEN];
//	Tango::DevBoolean	msg_alm[MESG_ALM_MAX_LEN];
	Tango::DevBoolean	msg_acc[MESG_ACC_MAX_LEN];
	Tango::DevString *ctrlacc_names;
	Tango::DevString *searchacc_names;
	Tango::DevString *acc_names;

	Tango::DeviceProxy * ll_server_undulator;
	Tango::DevBoolean	msg_stat_undulator[MESG_ALM_MAX_LEN];
	Tango::DevBoolean	msg_acc_undulator[MESG_ACC_MAX_LEN];
	Tango::DevString *ctrlacc_names_undulator;
	Tango::DevString *searchacc_names_undulator;
	Tango::DevString *acc_names_undulator;
	int rfsh;


	st_cmd prepared_cmd;
	void sendCmd(Tango::DevString argin);
	void sendCmd_undulator(Tango::DevString argin);
 
	unsigned long timeout_secs;
	unsigned long timeout_nanosecs;
	void write_msg(void);
	void send_frame (unsigned char *query, short query_length);
	int verify_modpcgun(void);
	int verify_modS0(void);

	void always_executed_hook_undulator();


//	bool firsttime;
};

}	// namespace_ns

#endif	// _FSAFETY_H
