static const char *RcsId     = "$Header:  $";
static const char *TagName   = "$ N a m e:  $";
static const char *HttpServer= "http://www.esrf.fr/computing/cs/tango/tango_doc/ds_doc/";
//+=============================================================================
//
// file :        FSafetyClass.cpp
//
// description : C++ source for the FSafetyClass. A singleton
//               class derived from DeviceClass. It implements the
//               command list and all properties and methods required
//               by the FSafety once per process.
//
// project :     TANGO Device Server
//
// $Author: graziano $
//
// $Revision: 1.19 $
//
// $Log: FSafetyClass.cpp,v $
// Revision 1.19  2017-08-24 07:51:16  graziano
// added Undulator_board_disabled_xxx attributes and fixed Version
//
// Revision 1.18  2016-03-17 13:49:53  graziano
// added new board disabled attributes
//
// Revision 1.17  2015-01-21 09:45:29  graziano
// Device_4Impl and fixed ntohs
//
// Revision 1.16  2012-04-03 09:29:25  zambonl
// .ndd
//
// Revision 1.15  2012-04-03 09:25:57  zambonl
// .ndd
//
// Revision 1.14  2011-04-22 08:31:16  alessio
// Update makefile to Tango 7.2.6 and fix the device_factory()
//
// Revision 1.13  2010/11/09 13:03:34  zambonl
// .ndd
//
// Revision 1.12  2010/11/09 10:32:37  zambonl
// .ndd
//
// Revision 1.11  2010/09/27 12:00:27  zambonl
//
// Revision 1.10  2010/08/26 10:20:36  zambonl
// .
//
// Revision 1.9  2010/06/21 14:44:17  zambonl
// ndd
//
// Revision 1.8  2010/06/10 16:41:12  zambonl
// ndd
//
// Revision 1.7  2009/08/28 10:35:52  sara
// Actived periodic refresh of names table
//
// Revision 1.6  2009/07/16 07:53:59  sara
// added command for door acknowledge, fixed bugs
//
// Revision 1.5  2009/07/13 12:39:28  sara
// commands ready
//
// Revision 1.4  2009/06/11 14:43:10  sara
// ll attributes are now static
//
// Revision 1.3  2009/04/21 14:32:49  sara
// fixed bug in dynamic StringSpectrumAttributes
//
// Revision 1.2  2009/04/20 12:13:09  sara
// added dynamic attributes for DevShort and DevString types
//
// Revision 1.1.1.1  2009/04/03 09:11:57  sara
// first import
//
//
// copyleft :   European Synchrotron Radiation Facility
//              BP 220, Grenoble 38043
//              FRANCE
//
//-=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================


#include <tango.h>

#include <FSafety.h>
#include <FSafetyClass.h>


//+----------------------------------------------------------------------------
/**
 *	Create FSafetyClass singleton and return it in a C function for Python usage
 */
//+----------------------------------------------------------------------------
extern "C" {
#ifdef WIN32

__declspec(dllexport)

#endif

	Tango::DeviceClass *_create_FSafety_class(const char *name) {
		return FSafety_ns::FSafetyClass::init(name);
	}
}


namespace FSafety_ns
{
//+----------------------------------------------------------------------------
//
// method : 		LinacServiceClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *LinacServiceClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "LinacServiceClass::execute(): arrived" << endl;

	const Tango::DevVarStringArray	*argin;
	extract(in_any, argin);

	((static_cast<FSafety *>(device))->linac_service(argin));
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		LinacDelPostoCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *LinacDelPostoCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "LinacDelPostoCmd::execute(): arrived" << endl;

	const Tango::DevVarStringArray	*argin;
	extract(in_any, argin);

	((static_cast<FSafety *>(device))->linac_del_posto(argin));
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		LinacEmeTLAckCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *LinacEmeTLAckCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "LinacEmeTLAckCmd::execute(): arrived" << endl;

	((static_cast<FSafety *>(device))->linac_eme_tlack());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		UndulatorServiceCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *UndulatorServiceCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "UndulatorServiceCmd::execute(): arrived" << endl;

	const Tango::DevVarStringArray	*argin;
	extract(in_any, argin);

	((static_cast<FSafety *>(device))->undulator_service(argin));
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		UndulatorAckDoorCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *UndulatorAckDoorCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "UndulatorAckDoorCmd::execute(): arrived" << endl;

	Tango::DevShort	argin;
	extract(in_any, argin);

	((static_cast<FSafety *>(device))->undulator_ack_door(argin));
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		UndulatorDoorOpenCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *UndulatorDoorOpenCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "UndulatorDoorOpenCmd::execute(): arrived" << endl;

	((static_cast<FSafety *>(device))->undulator_door_open());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		UndulatorDoorResetCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *UndulatorDoorResetCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "UndulatorDoorResetCmd::execute(): arrived" << endl;

	((static_cast<FSafety *>(device))->undulator_door_reset());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		UndulatorSearchStopCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *UndulatorSearchStopCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "UndulatorSearchStopCmd::execute(): arrived" << endl;

	Tango::DevShort	argin;
	extract(in_any, argin);

	((static_cast<FSafety *>(device))->undulator_search_stop(argin));
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		LinacSearchStartCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *LinacSearchStartCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "LinacSearchStartCmd::execute(): arrived" << endl;

	Tango::DevShort	argin;
	extract(in_any, argin);

	((static_cast<FSafety *>(device))->linac_search_start(argin));
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		UndulatorSearchStartCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *UndulatorSearchStartCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "UndulatorSearchStartCmd::execute(): arrived" << endl;

	Tango::DevShort	argin;
	extract(in_any, argin);

	((static_cast<FSafety *>(device))->undulator_search_start(argin));
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		UndulatorSearchRequestCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *UndulatorSearchRequestCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "UndulatorSearchRequestCmd::execute(): arrived" << endl;

	((static_cast<FSafety *>(device))->undulator_search_request());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		UndulatorEmeAckCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *UndulatorEmeAckCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "UndulatorEmeAckCmd::execute(): arrived" << endl;

	((static_cast<FSafety *>(device))->undulator_eme_ack());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		UndulatorRPasvCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *UndulatorRPasvCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "UndulatorRPasvCmd::execute(): arrived" << endl;

	((static_cast<FSafety *>(device))->undulator_rpasv());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		UndulatorBstCloseCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *UndulatorBstCloseCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "UndulatorBstCloseCmd::execute(): arrived" << endl;

	Tango::DevShort	argin;
	extract(in_any, argin);

	((static_cast<FSafety *>(device))->undulator_bst_close(argin));
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		UndulatorBstOpenCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *UndulatorBstOpenCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "UndulatorBstOpenCmd::execute(): arrived" << endl;

	Tango::DevShort	argin;
	extract(in_any, argin);

	((static_cast<FSafety *>(device))->undulator_bst_open(argin));
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		UndulatorDelPostoCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *UndulatorDelPostoCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "UndulatorDelPostoCmd::execute(): arrived" << endl;

	const Tango::DevVarStringArray	*argin;
	extract(in_any, argin);

	((static_cast<FSafety *>(device))->undulator_del_posto(argin));
	return new CORBA::Any();
}


//+----------------------------------------------------------------------------
//
// method : 		LinacAckDoorCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *LinacAckDoorCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "LinacAckDoorCmd::execute(): arrived" << endl;

	Tango::DevShort	argin;
	extract(in_any, argin);

	((static_cast<FSafety *>(device))->linac_ack_door(argin));
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		LinacDoorOpenClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *LinacDoorOpenClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "LinacDoorOpenClass::execute(): arrived" << endl;

	((static_cast<FSafety *>(device))->linac_door_open());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		LinacDoorResetClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *LinacDoorResetClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "LinacDoorResetClass::execute(): arrived" << endl;

	((static_cast<FSafety *>(device))->linac_door_reset());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		LinacSearchStopClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *LinacSearchStopClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "LinacSearchStopClass::execute(): arrived" << endl;

	Tango::DevShort	argin;
	extract(in_any, argin);

	((static_cast<FSafety *>(device))->linac_search_stop(argin));
	return new CORBA::Any();
}


//+----------------------------------------------------------------------------
//
// method : 		LinacSearchRequestClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *LinacSearchRequestClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "LinacSearchRequestClass::execute(): arrived" << endl;

	((static_cast<FSafety *>(device))->linac_search_request());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		LinacEmeAckClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *LinacEmeAckClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "LinacEmeAckClass::execute(): arrived" << endl;

	((static_cast<FSafety *>(device))->linac_eme_ack());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		LinacRPasvClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *LinacRPasvClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "LinacRPasvClass::execute(): arrived" << endl;

	((static_cast<FSafety *>(device))->linac_rpasv());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		LinacBstCloseClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *LinacBstCloseClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "LinacBstCloseClass::execute(): arrived" << endl;

	((static_cast<FSafety *>(device))->linac_bst_close());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		LinacBstOpenClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *LinacBstOpenClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "LinacBstOpenClass::execute(): arrived" << endl;

	((static_cast<FSafety *>(device))->linac_bst_open());
	return new CORBA::Any();
}


//+----------------------------------------------------------------------------
//
// method : 		LinacSwitchConfClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *LinacSwitchConfClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "LinacSwitchConfClass::execute(): arrived" << endl;

	Tango::DevShort	argin;
	extract(in_any, argin);

	((static_cast<FSafety *>(device))->linac_switch_conf(argin));
	return new CORBA::Any();
}


//
//----------------------------------------------------------------
//	Initialize pointer for singleton pattern
//----------------------------------------------------------------
//
FSafetyClass *FSafetyClass::_instance = NULL;

//+----------------------------------------------------------------------------
//
// method : 		FSafetyClass::FSafetyClass(string &s)
// 
// description : 	constructor for the FSafetyClass
//
// in : - s : The class name
//
//-----------------------------------------------------------------------------
FSafetyClass::FSafetyClass(string &s):DeviceClass(s)
{

	cout2 << "Entering FSafetyClass constructor" << endl;
	set_default_property();
	get_class_property();
	write_class_property();
	
	cout2 << "Leaving FSafetyClass constructor" << endl;

}
//+----------------------------------------------------------------------------
//
// method : 		FSafetyClass::~FSafetyClass()
// 
// description : 	destructor for the FSafetyClass
//
//-----------------------------------------------------------------------------
FSafetyClass::~FSafetyClass()
{
	_instance = NULL;
}

//+----------------------------------------------------------------------------
//
// method : 		FSafetyClass::instance
// 
// description : 	Create the object if not already done. Otherwise, just
//			return a pointer to the object
//
// in : - name : The class name
//
//-----------------------------------------------------------------------------
FSafetyClass *FSafetyClass::init(const char *name)
{
	if (_instance == NULL)
	{
		try
		{
			string s(name);
			_instance = new FSafetyClass(s);
		}
		catch (bad_alloc)
		{
			throw;
		}		
	}		
	return _instance;
}

FSafetyClass *FSafetyClass::instance()
{
	if (_instance == NULL)
	{
		cerr << "Class is not initialised !!" << endl;
		exit(-1);
	}
	return _instance;
}

//+----------------------------------------------------------------------------
//
// method : 		FSafetyClass::command_factory
// 
// description : 	Create the command object(s) and store them in the 
//			command list
//
//-----------------------------------------------------------------------------
void FSafetyClass::command_factory()
{
	command_list.push_back(new LinacSwitchConfClass("LinacSwitchConf",
		Tango::DEV_SHORT, Tango::DEV_VOID,
		"from 0 to 9",
		"",
		Tango::OPERATOR));
	command_list.push_back(new LinacDelPostoCmd("LinacDelPosto",
		Tango::DEVVAR_STRINGARRAY, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new LinacBstOpenClass("LinacBstOpen",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new LinacBstCloseClass("LinacBstClose",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new LinacRPasvClass("LinacRPasv",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new LinacEmeAckClass("LinacEmeAck",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new LinacEmeTLAckCmd("LinacEmeTLAck",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new LinacSearchRequestClass("LinacSearchRequest",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new LinacSearchStartCmd("LinacSearchStart",
		Tango::DEV_SHORT, Tango::DEV_VOID,
		"from 1 to 5",
		"",
		Tango::OPERATOR));
	command_list.push_back(new LinacSearchStopClass("LinacSearchStop",
		Tango::DEV_SHORT, Tango::DEV_VOID,
		"from 1 to 5",
		"",
		Tango::OPERATOR));
	command_list.push_back(new LinacDoorResetClass("LinacDoorReset",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new LinacDoorOpenClass("LinacDoorOpen",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new LinacAckDoorCmd("LinacAckDoor",
		Tango::DEV_SHORT, Tango::DEV_VOID,
		"from 0 to 2",
		"",
		Tango::OPERATOR));
	command_list.push_back(new LinacServiceClass("LinacService",
		Tango::DEVVAR_STRINGARRAY, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new UndulatorDelPostoCmd("UndulatorDelPosto",
		Tango::DEVVAR_STRINGARRAY, Tango::DEV_VOID,
		"from 0 to 15 + password",
		"",
		Tango::OPERATOR));
	command_list.push_back(new UndulatorBstOpenCmd("UndulatorBstOpen",
		Tango::DEV_SHORT, Tango::DEV_VOID,
		"bst id from 1 to 5",
		"",
		Tango::OPERATOR));
	command_list.push_back(new UndulatorBstCloseCmd("UndulatorBstClose",
		Tango::DEV_SHORT, Tango::DEV_VOID,
		"bst id from 1 to 5",
		"",
		Tango::OPERATOR));
	command_list.push_back(new UndulatorRPasvCmd("UndulatorRPasv",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new UndulatorEmeAckCmd("UndulatorEmeAck",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new UndulatorSearchRequestCmd("UndulatorSearchRequest",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new UndulatorSearchStartCmd("UndulatorSearchStart",
		Tango::DEV_SHORT, Tango::DEV_VOID,
		"0=UH 1=ESA1 2=ESA2 4-7=EmergencyExit4-7",
		"",
		Tango::OPERATOR));
	command_list.push_back(new UndulatorSearchStopCmd("UndulatorSearchStop",
		Tango::DEV_SHORT, Tango::DEV_VOID,
		"0=UH 1=ESA1 2=ESA2 4-7=EmergencyExit4-7",
		"",
		Tango::OPERATOR));
	command_list.push_back(new UndulatorDoorResetCmd("UndulatorDoorReset",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new UndulatorDoorOpenCmd("UndulatorDoorOpen",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new UndulatorAckDoorCmd("UndulatorAckDoor",
		Tango::DEV_SHORT, Tango::DEV_VOID,
		"from 0 to 80",
		"",
		Tango::OPERATOR));
	command_list.push_back(new UndulatorServiceCmd("UndulatorService",
		Tango::DEVVAR_STRINGARRAY, Tango::DEV_VOID,
		"service code",
		"",
		Tango::OPERATOR));

	//	add polling if any
	for (unsigned int i=0 ; i<command_list.size(); i++)
	{
	}
}

//+----------------------------------------------------------------------------
//
// method : 		FSafetyClass::get_class_property
// 
// description : 	Get the class property for specified name.
//
// in :		string	name : The property name
//
//+----------------------------------------------------------------------------
Tango::DbDatum FSafetyClass::get_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_prop.size() ; i++)
		if (cl_prop[i].name == prop_name)
			return cl_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}
//+----------------------------------------------------------------------------
//
// method : 		FSafetyClass::get_default_device_property()
// 
// description : 	Return the default value for device property.
//
//-----------------------------------------------------------------------------
Tango::DbDatum FSafetyClass::get_default_device_property(string &prop_name)
{
	for (unsigned int i=0 ; i<dev_def_prop.size() ; i++)
		if (dev_def_prop[i].name == prop_name)
			return dev_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//+----------------------------------------------------------------------------
//
// method : 		FSafetyClass::get_default_class_property()
// 
// description : 	Return the default value for class property.
//
//-----------------------------------------------------------------------------
Tango::DbDatum FSafetyClass::get_default_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_def_prop.size() ; i++)
		if (cl_def_prop[i].name == prop_name)
			return cl_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}
//+----------------------------------------------------------------------------
//
// method : 		FSafetyClass::device_factory
// 
// description : 	Create the device object(s) and store them in the 
//			device list
//
// in :		Tango::DevVarStringArray *devlist_ptr : The device name list
//
//-----------------------------------------------------------------------------
void FSafetyClass::device_factory(const Tango::DevVarStringArray *devlist_ptr)
{

	// Erase all the dynamic attributes previously added to the class
	//-------------------------------------------------------------
	//	Create all devices.(Automatic code generation)
	//-------------------------------------------------------------
	for (unsigned long i=0 ; i < devlist_ptr->length() ; i++)
	{
		cout4 << "Device name : " << (*devlist_ptr)[i].in() << endl;
						
		// Create devices and add it into the device list
		//----------------------------------------------------
		device_list.push_back(new FSafety(this, (*devlist_ptr)[i]));							 

		// Export device to the outside world
		// Check before if database used.
		//---------------------------------------------
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(device_list.back());
		else
			export_device(device_list.back(), (*devlist_ptr)[i]);
	}
	//	End of Automatic code generation
	//-------------------------------------------------------------
}
//+----------------------------------------------------------------------------
//	Method: FSafetyClass::attribute_factory(vector<Tango::Attr *> &att_list)
//-----------------------------------------------------------------------------
void FSafetyClass::attribute_factory(vector<Tango::Attr *> &att_list)
{
	//	Attribute : Linac_mod_on_pcgun
	Linac_mod_on_pcgunAttrib	*linac_mod_on_pcgun = new Linac_mod_on_pcgunAttrib();
	att_list.push_back(linac_mod_on_pcgun);

	//	Attribute : Linac_mod_onS0
	Linac_mod_onS0Attrib	*linac_mod_on_s0 = new Linac_mod_onS0Attrib();
	att_list.push_back(linac_mod_on_s0);

	//	Attribute : Linac_mbd_current
	Linac_mbd_currentAttrib	*linac_mbd_current = new Linac_mbd_currentAttrib();
	att_list.push_back(linac_mbd_current);

	//	Attribute : Plc_status
	Plc_statusAttrib	*plc_status = new Plc_statusAttrib();
	att_list.push_back(plc_status);

	//	Attribute : Undulator_plc_status
	Undulator_plc_statusAttrib	*undulator_plc_status = new Undulator_plc_statusAttrib();
	att_list.push_back(undulator_plc_status);

	//	Attribute : Undulator_cm_sfel_01_01
	Undulator_cm_sfel_01_01Attrib	*undulator_cm_sfel_01_01 = new Undulator_cm_sfel_01_01Attrib();
	att_list.push_back(undulator_cm_sfel_01_01);

	//	Attribute : Undulator_cm_sfel_02_01
	Undulator_cm_sfel_02_01Attrib	*undulator_cm_sfel_02_01 = new Undulator_cm_sfel_02_01Attrib();
	att_list.push_back(undulator_cm_sfel_02_01);

	//	Attribute : Undulator_cm_mbd_fel_01_01
	Undulator_cm_mbd_fel_01_01Attrib	*undulator_cm_mbd_fel_01_01 = new Undulator_cm_mbd_fel_01_01Attrib();
	att_list.push_back(undulator_cm_mbd_fel_01_01);

	//	Attribute : Undulator_cm_mbd_fel_02_01
	Undulator_cm_mbd_fel_02_01Attrib	*undulator_cm_mbd_fel_02_01 = new Undulator_cm_mbd_fel_02_01Attrib();
	att_list.push_back(undulator_cm_mbd_fel_02_01);

	//	Attribute : Undulator_cm_mbd_01
	Undulator_cm_mbd_01Attrib	*undulator_cm_mbd_01 = new Undulator_cm_mbd_01Attrib();
	att_list.push_back(undulator_cm_mbd_01);

	//	Attribute : Undulator_mbd_fel_1
	Undulator_mbd_fel_1Attrib	*undulator_mbd_fel_1 = new Undulator_mbd_fel_1Attrib();
	att_list.push_back(undulator_mbd_fel_1);

	//	Attribute : Undulator_mbd_fel_2
	Undulator_mbd_fel_2Attrib	*undulator_mbd_fel_2 = new Undulator_mbd_fel_2Attrib();
	att_list.push_back(undulator_mbd_fel_2);

	//	Attribute : Undulator_mbd_01
	Undulator_mbd_01Attrib	*undulator_mbd_01 = new Undulator_mbd_01Attrib();
	att_list.push_back(undulator_mbd_01);

	//	Attribute : Undulator_sprd_fel_1
	Undulator_sprd_fel_1Attrib	*undulator_sprd_fel_1 = new Undulator_sprd_fel_1Attrib();
	att_list.push_back(undulator_sprd_fel_1);

	//	Attribute : Undulator_sprd_fel_2
	Undulator_sprd_fel_2Attrib	*undulator_sprd_fel_2 = new Undulator_sprd_fel_2Attrib();
	att_list.push_back(undulator_sprd_fel_2);

	//	Attribute : Version
	VersionAttrib	*version = new VersionAttrib();
	att_list.push_back(version);

	//	Attribute : Exphall_gamma
	Exphall_gammaAttrib	*exphall_gamma = new Exphall_gammaAttrib();
	att_list.push_back(exphall_gamma);

	//	Attribute : Linac_access_signals
	Linac_access_signalsAttrib	*linac_access_signals = new Linac_access_signalsAttrib();
	att_list.push_back(linac_access_signals);

	//	Attribute : Linac_access_state
	Linac_access_stateAttrib	*linac_access_state = new Linac_access_stateAttrib();
	att_list.push_back(linac_access_state);

	//	Attribute : Linac_badge_all
	Linac_badge_allAttrib	*linac_badge_all = new Linac_badge_allAttrib();
	att_list.push_back(linac_badge_all);

	//	Attribute : Linac_badge_ack
	Linac_badge_ackAttrib	*linac_badge_ack = new Linac_badge_ackAttrib();
	att_list.push_back(linac_badge_ack);

	//	Attribute : Linac_boards_disabled
	Linac_boards_disabledAttrib	*linac_boards_disabled = new Linac_boards_disabledAttrib();
	att_list.push_back(linac_boards_disabled);

	//	Attribute : Linac_board_disabled_008
	Linac_board_disabled_008Attrib	*linac_board_disabled_008 = new Linac_board_disabled_008Attrib();
	att_list.push_back(linac_board_disabled_008);

	//	Attribute : Linac_board_disabled_040
	Linac_board_disabled_040Attrib	*linac_board_disabled_040 = new Linac_board_disabled_040Attrib();
	att_list.push_back(linac_board_disabled_040);

	//	Attribute : Linac_board_disabled_058
	Linac_board_disabled_058Attrib	*linac_board_disabled_058 = new Linac_board_disabled_058Attrib();
	att_list.push_back(linac_board_disabled_058);

	//	Attribute : Linac_board_disabled_068
	Linac_board_disabled_068Attrib	*linac_board_disabled_068 = new Linac_board_disabled_068Attrib();
	att_list.push_back(linac_board_disabled_068);

	//	Attribute : Linac_board_disabled_078
	Linac_board_disabled_078Attrib	*linac_board_disabled_078 = new Linac_board_disabled_078Attrib();
	att_list.push_back(linac_board_disabled_078);

	//	Attribute : Linac_board_disabled_100
	Linac_board_disabled_100Attrib	*linac_board_disabled_100 = new Linac_board_disabled_100Attrib();
	att_list.push_back(linac_board_disabled_100);

	//	Attribute : Linac_board_disabled_106
	Linac_board_disabled_106Attrib	*linac_board_disabled_106 = new Linac_board_disabled_106Attrib();
	att_list.push_back(linac_board_disabled_106);

	//	Attribute : Linac_board_disabled_126
	Linac_board_disabled_126Attrib	*linac_board_disabled_126 = new Linac_board_disabled_126Attrib();
	att_list.push_back(linac_board_disabled_126);

	//	Attribute : Linac_board_disabled_132
	Linac_board_disabled_132Attrib	*linac_board_disabled_132 = new Linac_board_disabled_132Attrib();
	att_list.push_back(linac_board_disabled_132);

	//	Attribute : Linac_board_disabled_152
	Linac_board_disabled_152Attrib	*linac_board_disabled_152 = new Linac_board_disabled_152Attrib();
	att_list.push_back(linac_board_disabled_152);

	//	Attribute : Linac_board_disabled_158
	Linac_board_disabled_158Attrib	*linac_board_disabled_158 = new Linac_board_disabled_158Attrib();
	att_list.push_back(linac_board_disabled_158);

	//	Attribute : Linac_board_disabled_178
	Linac_board_disabled_178Attrib	*linac_board_disabled_178 = new Linac_board_disabled_178Attrib();
	att_list.push_back(linac_board_disabled_178);

	//	Attribute : Linac_board_disabled_184
	Linac_board_disabled_184Attrib	*linac_board_disabled_184 = new Linac_board_disabled_184Attrib();
	att_list.push_back(linac_board_disabled_184);

	//	Attribute : Linac_board_disabled_190
	Linac_board_disabled_190Attrib	*linac_board_disabled_190 = new Linac_board_disabled_190Attrib();
	att_list.push_back(linac_board_disabled_190);

	//	Attribute : Linac_board_disabled_196
	Linac_board_disabled_196Attrib	*linac_board_disabled_196 = new Linac_board_disabled_196Attrib();
	att_list.push_back(linac_board_disabled_196);

	//	Attribute : Linac_board_disabled_202
	Linac_board_disabled_202Attrib	*linac_board_disabled_202 = new Linac_board_disabled_202Attrib();
	att_list.push_back(linac_board_disabled_202);

	//	Attribute : Linac_board_disabled_216
	Linac_board_disabled_216Attrib	*linac_board_disabled_216 = new Linac_board_disabled_216Attrib();
	att_list.push_back(linac_board_disabled_216);

	//	Attribute : Linac_board_disabled_240
	Linac_board_disabled_240Attrib	*linac_board_disabled_240 = new Linac_board_disabled_240Attrib();
	att_list.push_back(linac_board_disabled_240);

	//	Attribute : Linac_board_disabled_252
	Linac_board_disabled_252Attrib	*linac_board_disabled_252 = new Linac_board_disabled_252Attrib();
	att_list.push_back(linac_board_disabled_252);

	//	Attribute : Linac_board_disabled_258
	Linac_board_disabled_258Attrib	*linac_board_disabled_258 = new Linac_board_disabled_258Attrib();
	att_list.push_back(linac_board_disabled_258);

	//	Attribute : Linac_board_disabled_280
	Linac_board_disabled_280Attrib	*linac_board_disabled_280 = new Linac_board_disabled_280Attrib();
	att_list.push_back(linac_board_disabled_280);

	//	Attribute : Linac_board_disabled_286
	Linac_board_disabled_286Attrib	*linac_board_disabled_286 = new Linac_board_disabled_286Attrib();
	att_list.push_back(linac_board_disabled_286);

	//	Attribute : Linac_board_disabled_308
	Linac_board_disabled_308Attrib	*linac_board_disabled_308 = new Linac_board_disabled_308Attrib();
	att_list.push_back(linac_board_disabled_308);

	//	Attribute : Linac_board_disabled_314
	Linac_board_disabled_314Attrib	*linac_board_disabled_314 = new Linac_board_disabled_314Attrib();
	att_list.push_back(linac_board_disabled_314);

	//	Attribute : Linac_board_disabled_088
	Linac_board_disabled_088Attrib	*linac_board_disabled_088 = new Linac_board_disabled_088Attrib();
	att_list.push_back(linac_board_disabled_088);

	//	Attribute : Linac_board_disabled_232
	Linac_board_disabled_232Attrib	*linac_board_disabled_232 = new Linac_board_disabled_232Attrib();
	att_list.push_back(linac_board_disabled_232);

	//	Attribute : Linac_board_disabled_222
	Linac_board_disabled_222Attrib	*linac_board_disabled_222 = new Linac_board_disabled_222Attrib();
	att_list.push_back(linac_board_disabled_222);

	//	Attribute : Linac_board_disabled_227
	Linac_board_disabled_227Attrib	*linac_board_disabled_227 = new Linac_board_disabled_227Attrib();
	att_list.push_back(linac_board_disabled_227);

	//	Attribute : Linac_board_disabled_246
	Linac_board_disabled_246Attrib	*linac_board_disabled_246 = new Linac_board_disabled_246Attrib();
	att_list.push_back(linac_board_disabled_246);

	//	Attribute : Linac_board_disabled_264
	Linac_board_disabled_264Attrib	*linac_board_disabled_264 = new Linac_board_disabled_264Attrib();
	att_list.push_back(linac_board_disabled_264);

	//	Attribute : Linac_board_disabled_269
	Linac_board_disabled_269Attrib	*linac_board_disabled_269 = new Linac_board_disabled_269Attrib();
	att_list.push_back(linac_board_disabled_269);

	//	Attribute : Linac_board_disabled_292
	Linac_board_disabled_292Attrib	*linac_board_disabled_292 = new Linac_board_disabled_292Attrib();
	att_list.push_back(linac_board_disabled_292);

	//	Attribute : Linac_board_disabled_297
	Linac_board_disabled_297Attrib	*linac_board_disabled_297 = new Linac_board_disabled_297Attrib();
	att_list.push_back(linac_board_disabled_297);

	//	Attribute : Linac_board_disabled_320
	Linac_board_disabled_320Attrib	*linac_board_disabled_320 = new Linac_board_disabled_320Attrib();
	att_list.push_back(linac_board_disabled_320);

	//	Attribute : Linac_board_disabled_325
	Linac_board_disabled_325Attrib	*linac_board_disabled_325 = new Linac_board_disabled_325Attrib();
	att_list.push_back(linac_board_disabled_325);

	//	Attribute : Linac_boards_resettable
	Linac_boards_resettableAttrib	*linac_boards_resettable = new Linac_boards_resettableAttrib();
	att_list.push_back(linac_boards_resettable);

	//	Attribute : Linac_bst_1
	Linac_bst_1Attrib	*linac_bst_1 = new Linac_bst_1Attrib();
	att_list.push_back(linac_bst_1);

	//	Attribute : Linac_disp_ext_code
	Linac_disp_ext_codeAttrib	*linac_disp_ext_code = new Linac_disp_ext_codeAttrib();
	att_list.push_back(linac_disp_ext_code);

	//	Attribute : Linac_disp_int_code
	Linac_disp_int_codeAttrib	*linac_disp_int_code = new Linac_disp_int_codeAttrib();
	att_list.push_back(linac_disp_int_code);

	//	Attribute : Linac_doors_e0
	Linac_doors_e0Attrib	*linac_doors_e0 = new Linac_doors_e0Attrib();
	att_list.push_back(linac_doors_e0);

	//	Attribute : Linac_doors_e1
	Linac_doors_e1Attrib	*linac_doors_e1 = new Linac_doors_e1Attrib();
	att_list.push_back(linac_doors_e1);

	//	Attribute : Linac_doors_e2
	Linac_doors_e2Attrib	*linac_doors_e2 = new Linac_doors_e2Attrib();
	att_list.push_back(linac_doors_e2);

	//	Attribute : Linac_doors_e3
	Linac_doors_e3Attrib	*linac_doors_e3 = new Linac_doors_e3Attrib();
	att_list.push_back(linac_doors_e3);

	//	Attribute : Linac_doors_l
	Linac_doors_lAttrib	*linac_doors_l = new Linac_doors_lAttrib();
	att_list.push_back(linac_doors_l);

	//	Attribute : Linac_doors_tl
	Linac_doors_tlAttrib	*linac_doors_tl = new Linac_doors_tlAttrib();
	att_list.push_back(linac_doors_tl);

	//	Attribute : Linac_doors_memoopen_e0
	Linac_doors_memoopen_e0Attrib	*linac_doors_memoopen_e0 = new Linac_doors_memoopen_e0Attrib();
	att_list.push_back(linac_doors_memoopen_e0);

	//	Attribute : Linac_doors_memoopen_e1
	Linac_doors_memoopen_e1Attrib	*linac_doors_memoopen_e1 = new Linac_doors_memoopen_e1Attrib();
	att_list.push_back(linac_doors_memoopen_e1);

	//	Attribute : Linac_doors_memoopen_e2
	Linac_doors_memoopen_e2Attrib	*linac_doors_memoopen_e2 = new Linac_doors_memoopen_e2Attrib();
	att_list.push_back(linac_doors_memoopen_e2);

	//	Attribute : Linac_doors_memoopen_e3
	Linac_doors_memoopen_e3Attrib	*linac_doors_memoopen_e3 = new Linac_doors_memoopen_e3Attrib();
	att_list.push_back(linac_doors_memoopen_e3);

	//	Attribute : Linac_doors_memoopen_l
	Linac_doors_memoopen_lAttrib	*linac_doors_memoopen_l = new Linac_doors_memoopen_lAttrib();
	att_list.push_back(linac_doors_memoopen_l);

	//	Attribute : Linac_doors_memoopen_tl
	Linac_doors_memoopen_tlAttrib	*linac_doors_memoopen_tl = new Linac_doors_memoopen_tlAttrib();
	att_list.push_back(linac_doors_memoopen_tl);

	//	Attribute : Linac_emergency_buttons
	Linac_emergency_buttonsAttrib	*linac_emergency_buttons = new Linac_emergency_buttonsAttrib();
	att_list.push_back(linac_emergency_buttons);

	//	Attribute : Linac_gamma
	Linac_gammaAttrib	*linac_gamma = new Linac_gammaAttrib();
	att_list.push_back(linac_gamma);

	//	Attribute : Linac_key_glob
	Linac_key_globAttrib	*linac_key_glob = new Linac_key_globAttrib();
	att_list.push_back(linac_key_glob);

	//	Attribute : Linac_glob_signals
	Linac_glob_signalsAttrib	*linac_glob_signals = new Linac_glob_signalsAttrib();
	att_list.push_back(linac_glob_signals);

	//	Attribute : Linac_key_ext
	Linac_key_extAttrib	*linac_key_ext = new Linac_key_extAttrib();
	att_list.push_back(linac_key_ext);

	//	Attribute : Linac_key_int
	Linac_key_intAttrib	*linac_key_int = new Linac_key_intAttrib();
	att_list.push_back(linac_key_int);

	//	Attribute : Linac_key_release
	Linac_key_releaseAttrib	*linac_key_release = new Linac_key_releaseAttrib();
	att_list.push_back(linac_key_release);

	//	Attribute : Linac_mod_abi_hv
	Linac_mod_abi_hvAttrib	*linac_mod_abi_hv = new Linac_mod_abi_hvAttrib();
	att_list.push_back(linac_mod_abi_hv);

	//	Attribute : Linac_mod_abi_rf
	Linac_mod_abi_rfAttrib	*linac_mod_abi_rf = new Linac_mod_abi_rfAttrib();
	att_list.push_back(linac_mod_abi_rf);

	//	Attribute : Linac_mod_hv
	Linac_mod_hvAttrib	*linac_mod_hv = new Linac_mod_hvAttrib();
	att_list.push_back(linac_mod_hv);

	//	Attribute : Linac_mod_rf
	Linac_mod_rfAttrib	*linac_mod_rf = new Linac_mod_rfAttrib();
	att_list.push_back(linac_mod_rf);

	//	Attribute : Linac_mod_positions
	Linac_mod_positionsAttrib	*linac_mod_positions = new Linac_mod_positionsAttrib();
	att_list.push_back(linac_mod_positions);

	//	Attribute : Linac_mod_pre_hv_abi
	Linac_mod_pre_hv_abiAttrib	*linac_mod_pre_hv_abi = new Linac_mod_pre_hv_abiAttrib();
	att_list.push_back(linac_mod_pre_hv_abi);

	//	Attribute : Linac_pickup
	Linac_pickupAttrib	*linac_pickup = new Linac_pickupAttrib();
	att_list.push_back(linac_pickup);

	//	Attribute : Linac_safety
	Linac_safetyAttrib	*linac_safety = new Linac_safetyAttrib();
	att_list.push_back(linac_safety);

	//	Attribute : Linac_search_barriers
	Linac_search_barriersAttrib	*linac_search_barriers = new Linac_search_barriersAttrib();
	att_list.push_back(linac_search_barriers);

	//	Attribute : Linac_search_buttons
	Linac_search_buttonsAttrib	*linac_search_buttons = new Linac_search_buttonsAttrib();
	att_list.push_back(linac_search_buttons);

	//	Attribute : Linac_search_doorlights
	Linac_search_doorlightsAttrib	*linac_search_doorlights = new Linac_search_doorlightsAttrib();
	att_list.push_back(linac_search_doorlights);

	//	Attribute : Linac_search_lights
	Linac_search_lightsAttrib	*linac_search_lights = new Linac_search_lightsAttrib();
	att_list.push_back(linac_search_lights);

	//	Attribute : Linac_search_req_l
	Linac_search_req_lAttrib	*linac_search_req_l = new Linac_search_req_lAttrib();
	att_list.push_back(linac_search_req_l);

	//	Attribute : Linac_search_req_tl
	Linac_search_req_tlAttrib	*linac_search_req_tl = new Linac_search_req_tlAttrib();
	att_list.push_back(linac_search_req_tl);

	//	Attribute : Linac_search_req_e0
	Linac_search_req_e0Attrib	*linac_search_req_e0 = new Linac_search_req_e0Attrib();
	att_list.push_back(linac_search_req_e0);

	//	Attribute : Linac_search_req_e1
	Linac_search_req_e1Attrib	*linac_search_req_e1 = new Linac_search_req_e1Attrib();
	att_list.push_back(linac_search_req_e1);

	//	Attribute : Linac_search_req_e2
	Linac_search_req_e2Attrib	*linac_search_req_e2 = new Linac_search_req_e2Attrib();
	att_list.push_back(linac_search_req_e2);

	//	Attribute : Linac_search_req_e3
	Linac_search_req_e3Attrib	*linac_search_req_e3 = new Linac_search_req_e3Attrib();
	att_list.push_back(linac_search_req_e3);

	//	Attribute : Linac_search_signals_e0
	Linac_search_signals_e0Attrib	*linac_search_signals_e0 = new Linac_search_signals_e0Attrib();
	att_list.push_back(linac_search_signals_e0);

	//	Attribute : Linac_search_signals_e1
	Linac_search_signals_e1Attrib	*linac_search_signals_e1 = new Linac_search_signals_e1Attrib();
	att_list.push_back(linac_search_signals_e1);

	//	Attribute : Linac_search_signals_e2
	Linac_search_signals_e2Attrib	*linac_search_signals_e2 = new Linac_search_signals_e2Attrib();
	att_list.push_back(linac_search_signals_e2);

	//	Attribute : Linac_search_signals_e3
	Linac_search_signals_e3Attrib	*linac_search_signals_e3 = new Linac_search_signals_e3Attrib();
	att_list.push_back(linac_search_signals_e3);

	//	Attribute : Linac_search_signals_l
	Linac_search_signals_lAttrib	*linac_search_signals_l = new Linac_search_signals_lAttrib();
	att_list.push_back(linac_search_signals_l);

	//	Attribute : Linac_search_signals_tl
	Linac_search_signals_tlAttrib	*linac_search_signals_tl = new Linac_search_signals_tlAttrib();
	att_list.push_back(linac_search_signals_tl);

	//	Attribute : Linac_search_ini_e0
	Linac_search_ini_e0Attrib	*linac_search_ini_e0 = new Linac_search_ini_e0Attrib();
	att_list.push_back(linac_search_ini_e0);

	//	Attribute : Linac_search_ini_e1
	Linac_search_ini_e1Attrib	*linac_search_ini_e1 = new Linac_search_ini_e1Attrib();
	att_list.push_back(linac_search_ini_e1);

	//	Attribute : Linac_search_ini_e2
	Linac_search_ini_e2Attrib	*linac_search_ini_e2 = new Linac_search_ini_e2Attrib();
	att_list.push_back(linac_search_ini_e2);

	//	Attribute : Linac_search_ini_e3
	Linac_search_ini_e3Attrib	*linac_search_ini_e3 = new Linac_search_ini_e3Attrib();
	att_list.push_back(linac_search_ini_e3);

	//	Attribute : Linac_search_ini_l
	Linac_search_ini_lAttrib	*linac_search_ini_l = new Linac_search_ini_lAttrib();
	att_list.push_back(linac_search_ini_l);

	//	Attribute : Linac_search_ini_tl
	Linac_search_ini_tlAttrib	*linac_search_ini_tl = new Linac_search_ini_tlAttrib();
	att_list.push_back(linac_search_ini_tl);

	//	Attribute : Linac_search_fail_e0
	Linac_search_fail_e0Attrib	*linac_search_fail_e0 = new Linac_search_fail_e0Attrib();
	att_list.push_back(linac_search_fail_e0);

	//	Attribute : Linac_search_fail_e1
	Linac_search_fail_e1Attrib	*linac_search_fail_e1 = new Linac_search_fail_e1Attrib();
	att_list.push_back(linac_search_fail_e1);

	//	Attribute : Linac_search_fail_e2
	Linac_search_fail_e2Attrib	*linac_search_fail_e2 = new Linac_search_fail_e2Attrib();
	att_list.push_back(linac_search_fail_e2);

	//	Attribute : Linac_search_fail_e3
	Linac_search_fail_e3Attrib	*linac_search_fail_e3 = new Linac_search_fail_e3Attrib();
	att_list.push_back(linac_search_fail_e3);

	//	Attribute : Linac_search_fail_l
	Linac_search_fail_lAttrib	*linac_search_fail_l = new Linac_search_fail_lAttrib();
	att_list.push_back(linac_search_fail_l);

	//	Attribute : Linac_search_fail_tl
	Linac_search_fail_tlAttrib	*linac_search_fail_tl = new Linac_search_fail_tlAttrib();
	att_list.push_back(linac_search_fail_tl);

	//	Attribute : Linac_sir_buz
	Linac_sir_buzAttrib	*linac_sir_buz = new Linac_sir_buzAttrib();
	att_list.push_back(linac_sir_buz);

	//	Attribute : Linac_state
	Linac_stateAttrib	*linac_state = new Linac_stateAttrib();
	att_list.push_back(linac_state);

	//	Attribute : Linac_switches_abi
	Linac_switches_abiAttrib	*linac_switches_abi = new Linac_switches_abiAttrib();
	att_list.push_back(linac_switches_abi);

	//	Attribute : Linac_switches_config
	Linac_switches_configAttrib	*linac_switches_config = new Linac_switches_configAttrib();
	att_list.push_back(linac_switches_config);

	//	Attribute : Linac_switches_load
	Linac_switches_loadAttrib	*linac_switches_load = new Linac_switches_loadAttrib();
	att_list.push_back(linac_switches_load);

	//	Attribute : Linac_switches_moving
	Linac_switches_movingAttrib	*linac_switches_moving = new Linac_switches_movingAttrib();
	att_list.push_back(linac_switches_moving);

	//	Attribute : Linac_switches_stable
	Linac_switches_stableAttrib	*linac_switches_stable = new Linac_switches_stableAttrib();
	att_list.push_back(linac_switches_stable);

	//	Attribute : Linac_doors_ext
	Linac_doors_extAttrib	*linac_doors_ext = new Linac_doors_extAttrib();
	att_list.push_back(linac_doors_ext);

	//	Attribute : Linac_access_names
	Linac_access_namesAttrib	*linac_access_names = new Linac_access_namesAttrib();
	att_list.push_back(linac_access_names);

	//	Attribute : Linac_search_names
	Linac_search_namesAttrib	*linac_search_names = new Linac_search_namesAttrib();
	att_list.push_back(linac_search_names);

	//	Attribute : Linac_doors_memoopen_ext
	Linac_doors_memoopen_extAttrib	*linac_doors_memoopen_ext = new Linac_doors_memoopen_extAttrib();
	att_list.push_back(linac_doors_memoopen_ext);

	//	Attribute : Linac_emergency_memo_buttons
	Linac_emergency_memo_buttonsAttrib	*linac_emergency_memo_buttons = new Linac_emergency_memo_buttonsAttrib();
	att_list.push_back(linac_emergency_memo_buttons);

	//	Attribute : Linac_badge_on
	Linac_badge_onAttrib	*linac_badge_on = new Linac_badge_onAttrib();
	att_list.push_back(linac_badge_on);

	//	Attribute : Linac_mod_inhib_rf_k1
	Linac_mod_inhib_rf_k1Attrib	*linac_mod_inhib_rf_k1 = new Linac_mod_inhib_rf_k1Attrib();
	att_list.push_back(linac_mod_inhib_rf_k1);

	//	Attribute : Linac_mod_inhib_rf_k2
	Linac_mod_inhib_rf_k2Attrib	*linac_mod_inhib_rf_k2 = new Linac_mod_inhib_rf_k2Attrib();
	att_list.push_back(linac_mod_inhib_rf_k2);

	//	Attribute : Linac_mod_inhib_hv_k1
	Linac_mod_inhib_hv_k1Attrib	*linac_mod_inhib_hv_k1 = new Linac_mod_inhib_hv_k1Attrib();
	att_list.push_back(linac_mod_inhib_hv_k1);

	//	Attribute : Linac_mod_inhib_hv_k2
	Linac_mod_inhib_hv_k2Attrib	*linac_mod_inhib_hv_k2 = new Linac_mod_inhib_hv_k2Attrib();
	att_list.push_back(linac_mod_inhib_hv_k2);

	//	Attribute : Linac_mod_inhib_hv_ks
	Linac_mod_inhib_hv_ksAttrib	*linac_mod_inhib_hv_ks = new Linac_mod_inhib_hv_ksAttrib();
	att_list.push_back(linac_mod_inhib_hv_ks);

	//	Attribute : Linac_mod_inhib_rf_ks
	Linac_mod_inhib_rf_ksAttrib	*linac_mod_inhib_rf_ks = new Linac_mod_inhib_rf_ksAttrib();
	att_list.push_back(linac_mod_inhib_rf_ks);

	//	Attribute : Linac_mod_inhib_rf_gen
	Linac_mod_inhib_rf_genAttrib	*linac_mod_inhib_rf_gen = new Linac_mod_inhib_rf_genAttrib();
	att_list.push_back(linac_mod_inhib_rf_gen);

	//	Attribute : Linac_mod_inhib_hv_gen
	Linac_mod_inhib_hv_genAttrib	*linac_mod_inhib_hv_gen = new Linac_mod_inhib_hv_genAttrib();
	att_list.push_back(linac_mod_inhib_hv_gen);

	//	Attribute : Undulator_access_signals
	Undulator_access_signalsAttrib	*undulator_access_signals = new Undulator_access_signalsAttrib();
	att_list.push_back(undulator_access_signals);

	//	Attribute : Undulator_access_state
	Undulator_access_stateAttrib	*undulator_access_state = new Undulator_access_stateAttrib();
	att_list.push_back(undulator_access_state);

	//	Attribute : Undulator_access_hutch
	Undulator_access_hutchAttrib	*undulator_access_hutch = new Undulator_access_hutchAttrib();
	att_list.push_back(undulator_access_hutch);

	//	Attribute : Undulator_badge_all
	Undulator_badge_allAttrib	*undulator_badge_all = new Undulator_badge_allAttrib();
	att_list.push_back(undulator_badge_all);

	//	Attribute : Undulator_badge_ack
	Undulator_badge_ackAttrib	*undulator_badge_ack = new Undulator_badge_ackAttrib();
	att_list.push_back(undulator_badge_ack);

	//	Attribute : Undulator_badge_on
	Undulator_badge_onAttrib	*undulator_badge_on = new Undulator_badge_onAttrib();
	att_list.push_back(undulator_badge_on);

	//	Attribute : Undulator_boards_disabled
	Undulator_boards_disabledAttrib	*undulator_boards_disabled = new Undulator_boards_disabledAttrib();
	att_list.push_back(undulator_boards_disabled);

	//	Attribute : Undulator_board_disabled_008
	Undulator_board_disabled_008Attrib	*undulator_board_disabled_008 = new Undulator_board_disabled_008Attrib();
	att_list.push_back(undulator_board_disabled_008);

	//	Attribute : Undulator_board_disabled_024
	Undulator_board_disabled_024Attrib	*undulator_board_disabled_024 = new Undulator_board_disabled_024Attrib();
	att_list.push_back(undulator_board_disabled_024);

	//	Attribute : Undulator_board_disabled_100
	Undulator_board_disabled_100Attrib	*undulator_board_disabled_100 = new Undulator_board_disabled_100Attrib();
	att_list.push_back(undulator_board_disabled_100);

	//	Attribute : Undulator_board_disabled_106
	Undulator_board_disabled_106Attrib	*undulator_board_disabled_106 = new Undulator_board_disabled_106Attrib();
	att_list.push_back(undulator_board_disabled_106);

	//	Attribute : Undulator_board_disabled_126
	Undulator_board_disabled_126Attrib	*undulator_board_disabled_126 = new Undulator_board_disabled_126Attrib();
	att_list.push_back(undulator_board_disabled_126);

	//	Attribute : Undulator_board_disabled_132
	Undulator_board_disabled_132Attrib	*undulator_board_disabled_132 = new Undulator_board_disabled_132Attrib();
	att_list.push_back(undulator_board_disabled_132);

	//	Attribute : Undulator_board_disabled_152
	Undulator_board_disabled_152Attrib	*undulator_board_disabled_152 = new Undulator_board_disabled_152Attrib();
	att_list.push_back(undulator_board_disabled_152);

	//	Attribute : Undulator_board_disabled_158
	Undulator_board_disabled_158Attrib	*undulator_board_disabled_158 = new Undulator_board_disabled_158Attrib();
	att_list.push_back(undulator_board_disabled_158);

	//	Attribute : Undulator_board_disabled_178
	Undulator_board_disabled_178Attrib	*undulator_board_disabled_178 = new Undulator_board_disabled_178Attrib();
	att_list.push_back(undulator_board_disabled_178);

	//	Attribute : Undulator_board_disabled_184
	Undulator_board_disabled_184Attrib	*undulator_board_disabled_184 = new Undulator_board_disabled_184Attrib();
	att_list.push_back(undulator_board_disabled_184);

	//	Attribute : Undulator_board_disabled_204
	Undulator_board_disabled_204Attrib	*undulator_board_disabled_204 = new Undulator_board_disabled_204Attrib();
	att_list.push_back(undulator_board_disabled_204);

	//	Attribute : Undulator_board_disabled_214
	Undulator_board_disabled_214Attrib	*undulator_board_disabled_214 = new Undulator_board_disabled_214Attrib();
	att_list.push_back(undulator_board_disabled_214);

	//	Attribute : Undulator_board_disabled_248
	Undulator_board_disabled_248Attrib	*undulator_board_disabled_248 = new Undulator_board_disabled_248Attrib();
	att_list.push_back(undulator_board_disabled_248);

	//	Attribute : Undulator_board_disabled_270
	Undulator_board_disabled_270Attrib	*undulator_board_disabled_270 = new Undulator_board_disabled_270Attrib();
	att_list.push_back(undulator_board_disabled_270);

	//	Attribute : Undulator_board_disabled_288
	Undulator_board_disabled_288Attrib	*undulator_board_disabled_288 = new Undulator_board_disabled_288Attrib();
	att_list.push_back(undulator_board_disabled_288);

	//	Attribute : Undulator_boards_resettable
	Undulator_boards_resettableAttrib	*undulator_boards_resettable = new Undulator_boards_resettableAttrib();
	att_list.push_back(undulator_boards_resettable);

	//	Attribute : Undulator_bst1_fel1
	Undulator_bst1_fel1Attrib	*undulator_bst1_fel1 = new Undulator_bst1_fel1Attrib();
	att_list.push_back(undulator_bst1_fel1);

	//	Attribute : Undulator_bst2_fel1
	Undulator_bst2_fel1Attrib	*undulator_bst2_fel1 = new Undulator_bst2_fel1Attrib();
	att_list.push_back(undulator_bst2_fel1);

	//	Attribute : Undulator_bst1_fel2
	Undulator_bst1_fel2Attrib	*undulator_bst1_fel2 = new Undulator_bst1_fel2Attrib();
	att_list.push_back(undulator_bst1_fel2);

	//	Attribute : Undulator_bst2_fel2
	Undulator_bst2_fel2Attrib	*undulator_bst2_fel2 = new Undulator_bst2_fel2Attrib();
	att_list.push_back(undulator_bst2_fel2);

	//	Attribute : Undulator_bst_diag
	Undulator_bst_diagAttrib	*undulator_bst_diag = new Undulator_bst_diagAttrib();
	att_list.push_back(undulator_bst_diag);

	//	Attribute : Undulator_bst_inhibit_linac
	Undulator_bst_inhibit_linacAttrib	*undulator_bst_inhibit_linac = new Undulator_bst_inhibit_linacAttrib();
	att_list.push_back(undulator_bst_inhibit_linac);

	//	Attribute : Undulator_bst_inhibit_bl
	Undulator_bst_inhibit_blAttrib	*undulator_bst_inhibit_bl = new Undulator_bst_inhibit_blAttrib();
	att_list.push_back(undulator_bst_inhibit_bl);

	//	Attribute : Undulator_disp_ext_code
	Undulator_disp_ext_codeAttrib	*undulator_disp_ext_code = new Undulator_disp_ext_codeAttrib();
	att_list.push_back(undulator_disp_ext_code);

	//	Attribute : Undulator_disp_int_code
	Undulator_disp_int_codeAttrib	*undulator_disp_int_code = new Undulator_disp_int_codeAttrib();
	att_list.push_back(undulator_disp_int_code);

	//	Attribute : Undulator_doors_e4
	Undulator_doors_e4Attrib	*undulator_doors_e4 = new Undulator_doors_e4Attrib();
	att_list.push_back(undulator_doors_e4);

	//	Attribute : Undulator_doors_e5
	Undulator_doors_e5Attrib	*undulator_doors_e5 = new Undulator_doors_e5Attrib();
	att_list.push_back(undulator_doors_e5);

	//	Attribute : Undulator_doors_e6
	Undulator_doors_e6Attrib	*undulator_doors_e6 = new Undulator_doors_e6Attrib();
	att_list.push_back(undulator_doors_e6);

	//	Attribute : Undulator_doors_e7
	Undulator_doors_e7Attrib	*undulator_doors_e7 = new Undulator_doors_e7Attrib();
	att_list.push_back(undulator_doors_e7);

	//	Attribute : Undulator_doors_so
	Undulator_doors_soAttrib	*undulator_doors_so = new Undulator_doors_soAttrib();
	att_list.push_back(undulator_doors_so);

	//	Attribute : Undulator_doors_esa
	Undulator_doors_esaAttrib	*undulator_doors_esa = new Undulator_doors_esaAttrib();
	att_list.push_back(undulator_doors_esa);

	//	Attribute : Undulator_doors_memoopen_e4
	Undulator_doors_memoopen_e4Attrib	*undulator_doors_memoopen_e4 = new Undulator_doors_memoopen_e4Attrib();
	att_list.push_back(undulator_doors_memoopen_e4);

	//	Attribute : Undulator_doors_memoopen_e5
	Undulator_doors_memoopen_e5Attrib	*undulator_doors_memoopen_e5 = new Undulator_doors_memoopen_e5Attrib();
	att_list.push_back(undulator_doors_memoopen_e5);

	//	Attribute : Undulator_doors_memoopen_e6
	Undulator_doors_memoopen_e6Attrib	*undulator_doors_memoopen_e6 = new Undulator_doors_memoopen_e6Attrib();
	att_list.push_back(undulator_doors_memoopen_e6);

	//	Attribute : Undulator_doors_memoopen_e7
	Undulator_doors_memoopen_e7Attrib	*undulator_doors_memoopen_e7 = new Undulator_doors_memoopen_e7Attrib();
	att_list.push_back(undulator_doors_memoopen_e7);

	//	Attribute : Undulator_doors_memoopen_so
	Undulator_doors_memoopen_soAttrib	*undulator_doors_memoopen_so = new Undulator_doors_memoopen_soAttrib();
	att_list.push_back(undulator_doors_memoopen_so);

	//	Attribute : Undulator_doors_memoopen_esa
	Undulator_doors_memoopen_esaAttrib	*undulator_doors_memoopen_esa = new Undulator_doors_memoopen_esaAttrib();
	att_list.push_back(undulator_doors_memoopen_esa);

	//	Attribute : Undulator_emergency_buttons
	Undulator_emergency_buttonsAttrib	*undulator_emergency_buttons = new Undulator_emergency_buttonsAttrib();
	att_list.push_back(undulator_emergency_buttons);

	//	Attribute : Undulator_emergency_memo_buttons
	Undulator_emergency_memo_buttonsAttrib	*undulator_emergency_memo_buttons = new Undulator_emergency_memo_buttonsAttrib();
	att_list.push_back(undulator_emergency_memo_buttons);

	//	Attribute : Undulator_glob_signals
	Undulator_glob_signalsAttrib	*undulator_glob_signals = new Undulator_glob_signalsAttrib();
	att_list.push_back(undulator_glob_signals);

	//	Attribute : Undulator_key_glob
	Undulator_key_globAttrib	*undulator_key_glob = new Undulator_key_globAttrib();
	att_list.push_back(undulator_key_glob);

	//	Attribute : Undulator_key_ext
	Undulator_key_extAttrib	*undulator_key_ext = new Undulator_key_extAttrib();
	att_list.push_back(undulator_key_ext);

	//	Attribute : Undulator_key_int
	Undulator_key_intAttrib	*undulator_key_int = new Undulator_key_intAttrib();
	att_list.push_back(undulator_key_int);

	//	Attribute : Undulator_key_release
	Undulator_key_releaseAttrib	*undulator_key_release = new Undulator_key_releaseAttrib();
	att_list.push_back(undulator_key_release);

	//	Attribute : Undulator_search_barriers
	Undulator_search_barriersAttrib	*undulator_search_barriers = new Undulator_search_barriersAttrib();
	att_list.push_back(undulator_search_barriers);

	//	Attribute : Undulator_search_buttons
	Undulator_search_buttonsAttrib	*undulator_search_buttons = new Undulator_search_buttonsAttrib();
	att_list.push_back(undulator_search_buttons);

	//	Attribute : Undulator_search_doorlights
	Undulator_search_doorlightsAttrib	*undulator_search_doorlights = new Undulator_search_doorlightsAttrib();
	att_list.push_back(undulator_search_doorlights);

	//	Attribute : Undulator_search_lights
	Undulator_search_lightsAttrib	*undulator_search_lights = new Undulator_search_lightsAttrib();
	att_list.push_back(undulator_search_lights);

	//	Attribute : Undulator_search_req_so
	Undulator_search_req_soAttrib	*undulator_search_req_so = new Undulator_search_req_soAttrib();
	att_list.push_back(undulator_search_req_so);

	//	Attribute : Undulator_search_req_e4
	Undulator_search_req_e4Attrib	*undulator_search_req_e4 = new Undulator_search_req_e4Attrib();
	att_list.push_back(undulator_search_req_e4);

	//	Attribute : Undulator_search_req_e5
	Undulator_search_req_e5Attrib	*undulator_search_req_e5 = new Undulator_search_req_e5Attrib();
	att_list.push_back(undulator_search_req_e5);

	//	Attribute : Undulator_search_req_e6
	Undulator_search_req_e6Attrib	*undulator_search_req_e6 = new Undulator_search_req_e6Attrib();
	att_list.push_back(undulator_search_req_e6);

	//	Attribute : Undulator_search_req_e7
	Undulator_search_req_e7Attrib	*undulator_search_req_e7 = new Undulator_search_req_e7Attrib();
	att_list.push_back(undulator_search_req_e7);

	//	Attribute : Undulator_search_req_esa1
	Undulator_search_req_esa1Attrib	*undulator_search_req_esa1 = new Undulator_search_req_esa1Attrib();
	att_list.push_back(undulator_search_req_esa1);

	//	Attribute : Undulator_search_req_esa2
	Undulator_search_req_esa2Attrib	*undulator_search_req_esa2 = new Undulator_search_req_esa2Attrib();
	att_list.push_back(undulator_search_req_esa2);

	//	Attribute : Undulator_search_signals_so
	Undulator_search_signals_soAttrib	*undulator_search_signals_so = new Undulator_search_signals_soAttrib();
	att_list.push_back(undulator_search_signals_so);

	//	Attribute : Undulator_search_signals_e4
	Undulator_search_signals_e4Attrib	*undulator_search_signals_e4 = new Undulator_search_signals_e4Attrib();
	att_list.push_back(undulator_search_signals_e4);

	//	Attribute : Undulator_search_signals_e5
	Undulator_search_signals_e5Attrib	*undulator_search_signals_e5 = new Undulator_search_signals_e5Attrib();
	att_list.push_back(undulator_search_signals_e5);

	//	Attribute : Undulator_search_signals_e6
	Undulator_search_signals_e6Attrib	*undulator_search_signals_e6 = new Undulator_search_signals_e6Attrib();
	att_list.push_back(undulator_search_signals_e6);

	//	Attribute : Undulator_search_signals_e7
	Undulator_search_signals_e7Attrib	*undulator_search_signals_e7 = new Undulator_search_signals_e7Attrib();
	att_list.push_back(undulator_search_signals_e7);

	//	Attribute : Undulator_search_signals_esa1
	Undulator_search_signals_esa1Attrib	*undulator_search_signals_esa1 = new Undulator_search_signals_esa1Attrib();
	att_list.push_back(undulator_search_signals_esa1);

	//	Attribute : Undulator_search_signals_esa2
	Undulator_search_signals_esa2Attrib	*undulator_search_signals_esa2 = new Undulator_search_signals_esa2Attrib();
	att_list.push_back(undulator_search_signals_esa2);

	//	Attribute : Undulator_search_ini_so
	Undulator_search_ini_soAttrib	*undulator_search_ini_so = new Undulator_search_ini_soAttrib();
	att_list.push_back(undulator_search_ini_so);

	//	Attribute : Undulator_search_ini_e4
	Undulator_search_ini_e4Attrib	*undulator_search_ini_e4 = new Undulator_search_ini_e4Attrib();
	att_list.push_back(undulator_search_ini_e4);

	//	Attribute : Undulator_search_ini_e5
	Undulator_search_ini_e5Attrib	*undulator_search_ini_e5 = new Undulator_search_ini_e5Attrib();
	att_list.push_back(undulator_search_ini_e5);

	//	Attribute : Undulator_search_ini_e6
	Undulator_search_ini_e6Attrib	*undulator_search_ini_e6 = new Undulator_search_ini_e6Attrib();
	att_list.push_back(undulator_search_ini_e6);

	//	Attribute : Undulator_search_ini_e7
	Undulator_search_ini_e7Attrib	*undulator_search_ini_e7 = new Undulator_search_ini_e7Attrib();
	att_list.push_back(undulator_search_ini_e7);

	//	Attribute : Undulator_search_fail_so
	Undulator_search_fail_soAttrib	*undulator_search_fail_so = new Undulator_search_fail_soAttrib();
	att_list.push_back(undulator_search_fail_so);

	//	Attribute : Undulator_search_fail_e4
	Undulator_search_fail_e4Attrib	*undulator_search_fail_e4 = new Undulator_search_fail_e4Attrib();
	att_list.push_back(undulator_search_fail_e4);

	//	Attribute : Undulator_search_fail_e5
	Undulator_search_fail_e5Attrib	*undulator_search_fail_e5 = new Undulator_search_fail_e5Attrib();
	att_list.push_back(undulator_search_fail_e5);

	//	Attribute : Undulator_search_fail_e6
	Undulator_search_fail_e6Attrib	*undulator_search_fail_e6 = new Undulator_search_fail_e6Attrib();
	att_list.push_back(undulator_search_fail_e6);

	//	Attribute : Undulator_search_fail_e7
	Undulator_search_fail_e7Attrib	*undulator_search_fail_e7 = new Undulator_search_fail_e7Attrib();
	att_list.push_back(undulator_search_fail_e7);

	//	Attribute : Undulator_search_fail_esa1
	Undulator_search_fail_esa1Attrib	*undulator_search_fail_esa1 = new Undulator_search_fail_esa1Attrib();
	att_list.push_back(undulator_search_fail_esa1);

	//	Attribute : Undulator_search_fail_esa2
	Undulator_search_fail_esa2Attrib	*undulator_search_fail_esa2 = new Undulator_search_fail_esa2Attrib();
	att_list.push_back(undulator_search_fail_esa2);

	//	Attribute : Undulator_sir_buz
	Undulator_sir_buzAttrib	*undulator_sir_buz = new Undulator_sir_buzAttrib();
	att_list.push_back(undulator_sir_buz);

	//	Attribute : Undulator_state
	Undulator_stateAttrib	*undulator_state = new Undulator_stateAttrib();
	att_list.push_back(undulator_state);

	//	End of Automatic code generation
	//-------------------------------------------------------------
}





//+----------------------------------------------------------------------------
//
// method : 		FSafetyClass::get_class_property()
// 
// description : 	Read the class properties from database.
//
//-----------------------------------------------------------------------------
void FSafetyClass::get_class_property()
{
	//	Initialize your default values here (if not done with  POGO).
	//------------------------------------------------------------------

	//	Read class properties from database.(Automatic code generation)
	//------------------------------------------------------------------

	//	Call database and extract values
	//--------------------------------------------
	if (Tango::Util::instance()->_UseDb==true)
		get_db_class()->get_property(cl_prop);
	Tango::DbDatum	def_prop;
	int	i = -1;


	//	End of Automatic code generation
	//------------------------------------------------------------------

}

//+----------------------------------------------------------------------------
//
// method : 	FSafetyClass::set_default_property
// 
// description: Set default property (class and device) for wizard.
//              For each property, add to wizard property name and description
//              If default value has been set, add it to wizard property and
//              store it in a DbDatum.
//
//-----------------------------------------------------------------------------
void FSafetyClass::set_default_property()
{
	string	prop_name;
	string	prop_desc;
	string	prop_def;

	vector<string>	vect_data;
	//	Set Default Class Properties
	//	Set Default Device Properties
	prop_name = "Low_level_srv";
	prop_desc = "";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "Undulator_low_level_srv";
	prop_desc = "";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "Data_config";
	prop_desc = "";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "CmdCodeDescription";
	prop_desc = "";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "UndulatorCmdCodeDescription";
	prop_desc = "";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

}
//+----------------------------------------------------------------------------
//
// method : 		FSafetyClass::write_class_property
// 
// description : 	Set class description as property in database
//
//-----------------------------------------------------------------------------
void FSafetyClass::write_class_property()
{
	//	First time, check if database used
	//--------------------------------------------
	if (Tango::Util::_UseDb == false)
		return;

	Tango::DbData	data;
	string	classname = get_name();
	string	header;
	string::size_type	start, end;

	//	Put title
	Tango::DbDatum	title("ProjectTitle");
	string	str_title("");
	title << str_title;
	data.push_back(title);

	//	Put Description
	Tango::DbDatum	description("Description");
	vector<string>	str_desc;
	str_desc.push_back("hi level tango server that manages communication with FERMI safety PLC, by FSafety");
	description << str_desc;
	data.push_back(description);
		
	//	put cvs location
	string	rcsId(RcsId);
	string	filename(classname);
	start = rcsId.find("/");
	if (start!=string::npos)
	{
		filename += "Class.cpp";
		end   = rcsId.find(filename);
		if (end>start)
		{
			string	strloc = rcsId.substr(start, end-start);
			//	Check if specific repository
			start = strloc.find("/cvsroot/");
			if (start!=string::npos && start>0)
			{
				string	repository = strloc.substr(0, start);
				if (repository.find("/segfs/")!=string::npos)
					strloc = "ESRF:" + strloc.substr(start, strloc.length()-start);
			}
			Tango::DbDatum	cvs_loc("cvs_location");
			cvs_loc << strloc;
			data.push_back(cvs_loc);
		}
	}

	//	Get CVS tag revision
	string	tagname(TagName);
	header = "$ N a m e: ";
	start = header.length();
	string	endstr(" $");
	end   = tagname.find(endstr);
	if (end!=string::npos && end>start)
	{
		string	strtag = tagname.substr(start, end-start);
		Tango::DbDatum	cvs_tag("cvs_tag");
		cvs_tag << strtag;
		data.push_back(cvs_tag);
	}

	//	Get URL location
	string	httpServ(HttpServer);
	if (httpServ.length()>0)
	{
		Tango::DbDatum	db_doc_url("doc_url");
		db_doc_url << httpServ;
		data.push_back(db_doc_url);
	}

	//  Put inheritance
	Tango::DbDatum	inher_datum("InheritedFrom");
	vector<string> inheritance;
	inheritance.push_back("Device_4Impl");
	inher_datum << inheritance;
	data.push_back(inher_datum);

	//	Call database and and values
	//--------------------------------------------
	get_db_class()->put_property(data);
}

}	// namespace
