//=============================================================================
//
// file :         FSafetyClass.h
//
// description :  Include for the FSafetyClass root class.
//                This class is represents the singleton class for
//                the FSafety device class.
//                It contains all properties and methods which the 
//                FSafety requires only once e.g. the commands.
//			
// project :      TANGO Device Server
//
// $Author: graziano $
//
// $Revision: 1.22 $
//
// $Log: FSafetyClass.h,v $
// Revision 1.22  2017-08-24 07:51:16  graziano
// added Undulator_board_disabled_xxx attributes and fixed Version
//
// Revision 1.21  2016-03-17 13:49:53  graziano
// added new board disabled attributes
//
// Revision 1.20  2016-02-01 13:01:42  graziano
// fixed size of Linac_mod_inhib_rf_gen
//
// Revision 1.19  2015-07-06 08:12:40  graziano
// fixed for ctf
//
// Revision 1.18  2012-04-03 12:31:52  zambonl
// .ndd
//
// Revision 1.17  2012-04-03 09:23:07  zambonl
// .ndd
//
// Revision 1.16  2012-04-03 08:41:47  zambonl
// .ndd
//
// Revision 1.15  2010/11/09 10:32:37  zambonl
// .ndd
//
// Revision 1.14  2010/09/27 12:00:27  zambonl
//
// Revision 1.13  2010/08/26 10:20:36  zambonl
// .
//
// Revision 1.12  2010/06/21 14:44:17  zambonl
// ndd
//
// Revision 1.11  2010/06/16 06:34:42  zambonl
// ndd
//
// Revision 1.10  2010/06/10 16:41:12  zambonl
// ndd
//
// Revision 1.9  2010/01/28 11:03:53  zambonl
// ndd
//
// Revision 1.8  2009/08/28 10:35:52  sara
// Actived periodic refresh of names table
//
// Revision 1.7  2009/07/16 07:53:59  sara
// added command for door acknowledge, fixed bugs
//
// Revision 1.6  2009/07/13 12:39:28  sara
// commands ready
//
// Revision 1.5  2009/06/11 14:43:10  sara
// ll attributes are now static
//
// Revision 1.4  2009/04/27 08:17:34  sara
// added generig command SendCmd
//
// Revision 1.3  2009/04/21 14:32:49  sara
// fixed bug in dynamic StringSpectrumAttributes
//
// Revision 1.2  2009/04/20 12:13:09  sara
// added dynamic attributes for DevShort and DevString types
//
// Revision 1.1.1.1  2009/04/03 09:11:57  sara
// first import
//
//
// copyleft :     European Synchrotron Radiation Facility
//                BP 220, Grenoble 38043
//                FRANCE
//
//=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================

#ifndef _FSAFETYCLASS_H
#define _FSAFETYCLASS_H

#include <tango.h>
#include <FSafety.h>


namespace FSafety_ns
{//=====================================
//	Define classes for attributes
//=====================================
class Undulator_stateAttrib: public Tango::SpectrumAttr
{
public:
	Undulator_stateAttrib():SpectrumAttr("Undulator_state", Tango::DEV_BOOLEAN, Tango::READ, 4) {};
	~Undulator_stateAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_state(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_state_allowed(ty);}
};

class Undulator_sir_buzAttrib: public Tango::SpectrumAttr
{
public:
	Undulator_sir_buzAttrib():SpectrumAttr("Undulator_sir_buz", Tango::DEV_BOOLEAN, Tango::READ, 13) {};
	~Undulator_sir_buzAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_sir_buz(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_sir_buz_allowed(ty);}
};

class Undulator_search_fail_esa2Attrib: public Tango::SpectrumAttr
{
public:
	Undulator_search_fail_esa2Attrib():SpectrumAttr("Undulator_search_fail_esa2", Tango::DEV_BOOLEAN, Tango::READ, 7) {};
	~Undulator_search_fail_esa2Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_search_fail_esa2(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_search_fail_esa2_allowed(ty);}
};

class Undulator_search_fail_esa1Attrib: public Tango::SpectrumAttr
{
public:
	Undulator_search_fail_esa1Attrib():SpectrumAttr("Undulator_search_fail_esa1", Tango::DEV_BOOLEAN, Tango::READ, 7) {};
	~Undulator_search_fail_esa1Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_search_fail_esa1(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_search_fail_esa1_allowed(ty);}
};

class Undulator_search_fail_e7Attrib: public Tango::SpectrumAttr
{
public:
	Undulator_search_fail_e7Attrib():SpectrumAttr("Undulator_search_fail_e7", Tango::DEV_BOOLEAN, Tango::READ, 7) {};
	~Undulator_search_fail_e7Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_search_fail_e7(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_search_fail_e7_allowed(ty);}
};

class Undulator_search_fail_e6Attrib: public Tango::SpectrumAttr
{
public:
	Undulator_search_fail_e6Attrib():SpectrumAttr("Undulator_search_fail_e6", Tango::DEV_BOOLEAN, Tango::READ, 7) {};
	~Undulator_search_fail_e6Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_search_fail_e6(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_search_fail_e6_allowed(ty);}
};

class Undulator_search_fail_e5Attrib: public Tango::SpectrumAttr
{
public:
	Undulator_search_fail_e5Attrib():SpectrumAttr("Undulator_search_fail_e5", Tango::DEV_BOOLEAN, Tango::READ, 7) {};
	~Undulator_search_fail_e5Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_search_fail_e5(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_search_fail_e5_allowed(ty);}
};

class Undulator_search_fail_e4Attrib: public Tango::SpectrumAttr
{
public:
	Undulator_search_fail_e4Attrib():SpectrumAttr("Undulator_search_fail_e4", Tango::DEV_BOOLEAN, Tango::READ, 7) {};
	~Undulator_search_fail_e4Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_search_fail_e4(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_search_fail_e4_allowed(ty);}
};

class Undulator_search_fail_soAttrib: public Tango::SpectrumAttr
{
public:
	Undulator_search_fail_soAttrib():SpectrumAttr("Undulator_search_fail_so", Tango::DEV_BOOLEAN, Tango::READ, 23) {};
	~Undulator_search_fail_soAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_search_fail_so(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_search_fail_so_allowed(ty);}
};

class Undulator_search_ini_e7Attrib: public Tango::SpectrumAttr
{
public:
	Undulator_search_ini_e7Attrib():SpectrumAttr("Undulator_search_ini_e7", Tango::DEV_BOOLEAN, Tango::READ, 3) {};
	~Undulator_search_ini_e7Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_search_ini_e7(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_search_ini_e7_allowed(ty);}
};

class Undulator_search_ini_e6Attrib: public Tango::SpectrumAttr
{
public:
	Undulator_search_ini_e6Attrib():SpectrumAttr("Undulator_search_ini_e6", Tango::DEV_BOOLEAN, Tango::READ, 3) {};
	~Undulator_search_ini_e6Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_search_ini_e6(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_search_ini_e6_allowed(ty);}
};

class Undulator_search_ini_e5Attrib: public Tango::SpectrumAttr
{
public:
	Undulator_search_ini_e5Attrib():SpectrumAttr("Undulator_search_ini_e5", Tango::DEV_BOOLEAN, Tango::READ, 3) {};
	~Undulator_search_ini_e5Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_search_ini_e5(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_search_ini_e5_allowed(ty);}
};

class Undulator_search_ini_e4Attrib: public Tango::SpectrumAttr
{
public:
	Undulator_search_ini_e4Attrib():SpectrumAttr("Undulator_search_ini_e4", Tango::DEV_BOOLEAN, Tango::READ, 3) {};
	~Undulator_search_ini_e4Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_search_ini_e4(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_search_ini_e4_allowed(ty);}
};

class Undulator_search_ini_soAttrib: public Tango::SpectrumAttr
{
public:
	Undulator_search_ini_soAttrib():SpectrumAttr("Undulator_search_ini_so", Tango::DEV_BOOLEAN, Tango::READ, 24) {};
	~Undulator_search_ini_soAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_search_ini_so(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_search_ini_so_allowed(ty);}
};

class Undulator_search_signals_esa2Attrib: public Tango::SpectrumAttr
{
public:
	Undulator_search_signals_esa2Attrib():SpectrumAttr("Undulator_search_signals_esa2", Tango::DEV_BOOLEAN, Tango::READ, 13) {};
	~Undulator_search_signals_esa2Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_search_signals_esa2(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_search_signals_esa2_allowed(ty);}
};

class Undulator_search_signals_esa1Attrib: public Tango::SpectrumAttr
{
public:
	Undulator_search_signals_esa1Attrib():SpectrumAttr("Undulator_search_signals_esa1", Tango::DEV_BOOLEAN, Tango::READ, 13) {};
	~Undulator_search_signals_esa1Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_search_signals_esa1(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_search_signals_esa1_allowed(ty);}
};

class Undulator_search_signals_e7Attrib: public Tango::SpectrumAttr
{
public:
	Undulator_search_signals_e7Attrib():SpectrumAttr("Undulator_search_signals_e7", Tango::DEV_BOOLEAN, Tango::READ, 19) {};
	~Undulator_search_signals_e7Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_search_signals_e7(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_search_signals_e7_allowed(ty);}
};

class Undulator_search_signals_e6Attrib: public Tango::SpectrumAttr
{
public:
	Undulator_search_signals_e6Attrib():SpectrumAttr("Undulator_search_signals_e6", Tango::DEV_BOOLEAN, Tango::READ, 19) {};
	~Undulator_search_signals_e6Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_search_signals_e6(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_search_signals_e6_allowed(ty);}
};

class Undulator_search_signals_e5Attrib: public Tango::SpectrumAttr
{
public:
	Undulator_search_signals_e5Attrib():SpectrumAttr("Undulator_search_signals_e5", Tango::DEV_BOOLEAN, Tango::READ, 19) {};
	~Undulator_search_signals_e5Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_search_signals_e5(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_search_signals_e5_allowed(ty);}
};

class Undulator_search_signals_e4Attrib: public Tango::SpectrumAttr
{
public:
	Undulator_search_signals_e4Attrib():SpectrumAttr("Undulator_search_signals_e4", Tango::DEV_BOOLEAN, Tango::READ, 18) {};
	~Undulator_search_signals_e4Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_search_signals_e4(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_search_signals_e4_allowed(ty);}
};

class Undulator_search_signals_soAttrib: public Tango::SpectrumAttr
{
public:
	Undulator_search_signals_soAttrib():SpectrumAttr("Undulator_search_signals_so", Tango::DEV_BOOLEAN, Tango::READ, 17) {};
	~Undulator_search_signals_soAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_search_signals_so(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_search_signals_so_allowed(ty);}
};

class Undulator_search_req_esa2Attrib: public Tango::SpectrumAttr
{
public:
	Undulator_search_req_esa2Attrib():SpectrumAttr("Undulator_search_req_esa2", Tango::DEV_BOOLEAN, Tango::READ, 5) {};
	~Undulator_search_req_esa2Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_search_req_esa2(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_search_req_esa2_allowed(ty);}
};

class Undulator_search_req_esa1Attrib: public Tango::SpectrumAttr
{
public:
	Undulator_search_req_esa1Attrib():SpectrumAttr("Undulator_search_req_esa1", Tango::DEV_BOOLEAN, Tango::READ, 5) {};
	~Undulator_search_req_esa1Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_search_req_esa1(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_search_req_esa1_allowed(ty);}
};

class Undulator_search_req_e7Attrib: public Tango::SpectrumAttr
{
public:
	Undulator_search_req_e7Attrib():SpectrumAttr("Undulator_search_req_e7", Tango::DEV_BOOLEAN, Tango::READ, 3) {};
	~Undulator_search_req_e7Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_search_req_e7(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_search_req_e7_allowed(ty);}
};

class Undulator_search_req_e6Attrib: public Tango::SpectrumAttr
{
public:
	Undulator_search_req_e6Attrib():SpectrumAttr("Undulator_search_req_e6", Tango::DEV_BOOLEAN, Tango::READ, 3) {};
	~Undulator_search_req_e6Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_search_req_e6(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_search_req_e6_allowed(ty);}
};

class Undulator_search_req_e5Attrib: public Tango::SpectrumAttr
{
public:
	Undulator_search_req_e5Attrib():SpectrumAttr("Undulator_search_req_e5", Tango::DEV_BOOLEAN, Tango::READ, 3) {};
	~Undulator_search_req_e5Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_search_req_e5(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_search_req_e5_allowed(ty);}
};

class Undulator_search_req_e4Attrib: public Tango::SpectrumAttr
{
public:
	Undulator_search_req_e4Attrib():SpectrumAttr("Undulator_search_req_e4", Tango::DEV_BOOLEAN, Tango::READ, 3) {};
	~Undulator_search_req_e4Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_search_req_e4(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_search_req_e4_allowed(ty);}
};

class Undulator_search_req_soAttrib: public Tango::SpectrumAttr
{
public:
	Undulator_search_req_soAttrib():SpectrumAttr("Undulator_search_req_so", Tango::DEV_BOOLEAN, Tango::READ, 23) {};
	~Undulator_search_req_soAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_search_req_so(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_search_req_so_allowed(ty);}
};

class Undulator_search_lightsAttrib: public Tango::SpectrumAttr
{
public:
	Undulator_search_lightsAttrib():SpectrumAttr("Undulator_search_lights", Tango::DEV_BOOLEAN, Tango::READ, 13) {};
	~Undulator_search_lightsAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_search_lights(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_search_lights_allowed(ty);}
};

class Undulator_search_doorlightsAttrib: public Tango::SpectrumAttr
{
public:
	Undulator_search_doorlightsAttrib():SpectrumAttr("Undulator_search_doorlights", Tango::DEV_BOOLEAN, Tango::READ, 5) {};
	~Undulator_search_doorlightsAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_search_doorlights(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_search_doorlights_allowed(ty);}
};

class Undulator_search_buttonsAttrib: public Tango::SpectrumAttr
{
public:
	Undulator_search_buttonsAttrib():SpectrumAttr("Undulator_search_buttons", Tango::DEV_BOOLEAN, Tango::READ, 13) {};
	~Undulator_search_buttonsAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_search_buttons(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_search_buttons_allowed(ty);}
};

class Undulator_search_barriersAttrib: public Tango::SpectrumAttr
{
public:
	Undulator_search_barriersAttrib():SpectrumAttr("Undulator_search_barriers", Tango::DEV_BOOLEAN, Tango::READ, 5) {};
	~Undulator_search_barriersAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_search_barriers(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_search_barriers_allowed(ty);}
};

class Undulator_key_releaseAttrib: public Tango::SpectrumAttr
{
public:
	Undulator_key_releaseAttrib():SpectrumAttr("Undulator_key_release", Tango::DEV_BOOLEAN, Tango::READ, 16) {};
	~Undulator_key_releaseAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_key_release(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_key_release_allowed(ty);}
};

class Undulator_key_intAttrib: public Tango::SpectrumAttr
{
public:
	Undulator_key_intAttrib():SpectrumAttr("Undulator_key_int", Tango::DEV_BOOLEAN, Tango::READ, 16) {};
	~Undulator_key_intAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_key_int(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_key_int_allowed(ty);}
};

class Undulator_key_extAttrib: public Tango::SpectrumAttr
{
public:
	Undulator_key_extAttrib():SpectrumAttr("Undulator_key_ext", Tango::DEV_BOOLEAN, Tango::READ, 16) {};
	~Undulator_key_extAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_key_ext(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_key_ext_allowed(ty);}
};

class Undulator_key_globAttrib: public Tango::SpectrumAttr
{
public:
	Undulator_key_globAttrib():SpectrumAttr("Undulator_key_glob", Tango::DEV_BOOLEAN, Tango::READ, 2) {};
	~Undulator_key_globAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_key_glob(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_key_glob_allowed(ty);}
};

class Undulator_glob_signalsAttrib: public Tango::SpectrumAttr
{
public:
	Undulator_glob_signalsAttrib():SpectrumAttr("Undulator_glob_signals", Tango::DEV_BOOLEAN, Tango::READ, 9) {};
	~Undulator_glob_signalsAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_glob_signals(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_glob_signals_allowed(ty);}
};

class Undulator_emergency_memo_buttonsAttrib: public Tango::SpectrumAttr
{
public:
	Undulator_emergency_memo_buttonsAttrib():SpectrumAttr("Undulator_emergency_memo_buttons", Tango::DEV_BOOLEAN, Tango::READ, 15) {};
	~Undulator_emergency_memo_buttonsAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_emergency_memo_buttons(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_emergency_memo_buttons_allowed(ty);}
};

class Undulator_emergency_buttonsAttrib: public Tango::SpectrumAttr
{
public:
	Undulator_emergency_buttonsAttrib():SpectrumAttr("Undulator_emergency_buttons", Tango::DEV_BOOLEAN, Tango::READ, 15) {};
	~Undulator_emergency_buttonsAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_emergency_buttons(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_emergency_buttons_allowed(ty);}
};

class Undulator_doors_memoopen_esaAttrib: public Tango::SpectrumAttr
{
public:
	Undulator_doors_memoopen_esaAttrib():SpectrumAttr("Undulator_doors_memoopen_esa", Tango::DEV_BOOLEAN, Tango::READ, 2) {};
	~Undulator_doors_memoopen_esaAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_doors_memoopen_esa(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_doors_memoopen_esa_allowed(ty);}
};

class Undulator_doors_memoopen_soAttrib: public Tango::SpectrumAttr
{
public:
	Undulator_doors_memoopen_soAttrib():SpectrumAttr("Undulator_doors_memoopen_so", Tango::DEV_BOOLEAN, Tango::READ, 4) {};
	~Undulator_doors_memoopen_soAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_doors_memoopen_so(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_doors_memoopen_so_allowed(ty);}
};

class Undulator_doors_memoopen_e7Attrib: public Tango::SpectrumAttr
{
public:
	Undulator_doors_memoopen_e7Attrib():SpectrumAttr("Undulator_doors_memoopen_e7", Tango::DEV_BOOLEAN, Tango::READ, 4) {};
	~Undulator_doors_memoopen_e7Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_doors_memoopen_e7(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_doors_memoopen_e7_allowed(ty);}
};

class Undulator_doors_memoopen_e6Attrib: public Tango::SpectrumAttr
{
public:
	Undulator_doors_memoopen_e6Attrib():SpectrumAttr("Undulator_doors_memoopen_e6", Tango::DEV_BOOLEAN, Tango::READ, 4) {};
	~Undulator_doors_memoopen_e6Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_doors_memoopen_e6(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_doors_memoopen_e6_allowed(ty);}
};

class Undulator_doors_memoopen_e5Attrib: public Tango::SpectrumAttr
{
public:
	Undulator_doors_memoopen_e5Attrib():SpectrumAttr("Undulator_doors_memoopen_e5", Tango::DEV_BOOLEAN, Tango::READ, 4) {};
	~Undulator_doors_memoopen_e5Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_doors_memoopen_e5(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_doors_memoopen_e5_allowed(ty);}
};

class Undulator_doors_memoopen_e4Attrib: public Tango::SpectrumAttr
{
public:
	Undulator_doors_memoopen_e4Attrib():SpectrumAttr("Undulator_doors_memoopen_e4", Tango::DEV_BOOLEAN, Tango::READ, 4) {};
	~Undulator_doors_memoopen_e4Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_doors_memoopen_e4(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_doors_memoopen_e4_allowed(ty);}
};

class Undulator_doors_esaAttrib: public Tango::SpectrumAttr
{
public:
	Undulator_doors_esaAttrib():SpectrumAttr("Undulator_doors_esa", Tango::DEV_BOOLEAN, Tango::READ, 2) {};
	~Undulator_doors_esaAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_doors_esa(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_doors_esa_allowed(ty);}
};

class Undulator_doors_soAttrib: public Tango::SpectrumAttr
{
public:
	Undulator_doors_soAttrib():SpectrumAttr("Undulator_doors_so", Tango::DEV_BOOLEAN, Tango::READ, 4) {};
	~Undulator_doors_soAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_doors_so(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_doors_so_allowed(ty);}
};

class Undulator_doors_e7Attrib: public Tango::SpectrumAttr
{
public:
	Undulator_doors_e7Attrib():SpectrumAttr("Undulator_doors_e7", Tango::DEV_BOOLEAN, Tango::READ, 4) {};
	~Undulator_doors_e7Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_doors_e7(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_doors_e7_allowed(ty);}
};

class Undulator_doors_e6Attrib: public Tango::SpectrumAttr
{
public:
	Undulator_doors_e6Attrib():SpectrumAttr("Undulator_doors_e6", Tango::DEV_BOOLEAN, Tango::READ, 4) {};
	~Undulator_doors_e6Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_doors_e6(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_doors_e6_allowed(ty);}
};

class Undulator_doors_e5Attrib: public Tango::SpectrumAttr
{
public:
	Undulator_doors_e5Attrib():SpectrumAttr("Undulator_doors_e5", Tango::DEV_BOOLEAN, Tango::READ, 4) {};
	~Undulator_doors_e5Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_doors_e5(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_doors_e5_allowed(ty);}
};

class Undulator_doors_e4Attrib: public Tango::SpectrumAttr
{
public:
	Undulator_doors_e4Attrib():SpectrumAttr("Undulator_doors_e4", Tango::DEV_BOOLEAN, Tango::READ, 4) {};
	~Undulator_doors_e4Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_doors_e4(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_doors_e4_allowed(ty);}
};

class Undulator_disp_int_codeAttrib: public Tango::SpectrumAttr
{
public:
	Undulator_disp_int_codeAttrib():SpectrumAttr("Undulator_disp_int_code", Tango::DEV_SHORT, Tango::READ, 1) {};
	~Undulator_disp_int_codeAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_disp_int_code(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_disp_int_code_allowed(ty);}
};

class Undulator_disp_ext_codeAttrib: public Tango::SpectrumAttr
{
public:
	Undulator_disp_ext_codeAttrib():SpectrumAttr("Undulator_disp_ext_code", Tango::DEV_SHORT, Tango::READ, 1) {};
	~Undulator_disp_ext_codeAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_disp_ext_code(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_disp_ext_code_allowed(ty);}
};

class Undulator_bst_inhibit_blAttrib: public Tango::SpectrumAttr
{
public:
	Undulator_bst_inhibit_blAttrib():SpectrumAttr("Undulator_bst_inhibit_bl", Tango::DEV_BOOLEAN, Tango::READ, 12) {};
	~Undulator_bst_inhibit_blAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_bst_inhibit_bl(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_bst_inhibit_bl_allowed(ty);}
};

class Undulator_bst_inhibit_linacAttrib: public Tango::SpectrumAttr
{
public:
	Undulator_bst_inhibit_linacAttrib():SpectrumAttr("Undulator_bst_inhibit_linac", Tango::DEV_BOOLEAN, Tango::READ, 12) {};
	~Undulator_bst_inhibit_linacAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_bst_inhibit_linac(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_bst_inhibit_linac_allowed(ty);}
};

class Undulator_bst_diagAttrib: public Tango::SpectrumAttr
{
public:
	Undulator_bst_diagAttrib():SpectrumAttr("Undulator_bst_diag", Tango::DEV_BOOLEAN, Tango::READ, 13) {};
	~Undulator_bst_diagAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_bst_diag(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_bst_diag_allowed(ty);}
};

class Undulator_bst2_fel2Attrib: public Tango::SpectrumAttr
{
public:
	Undulator_bst2_fel2Attrib():SpectrumAttr("Undulator_bst2_fel2", Tango::DEV_BOOLEAN, Tango::READ, 13) {};
	~Undulator_bst2_fel2Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_bst2_fel2(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_bst2_fel2_allowed(ty);}
};

class Undulator_bst1_fel2Attrib: public Tango::SpectrumAttr
{
public:
	Undulator_bst1_fel2Attrib():SpectrumAttr("Undulator_bst1_fel2", Tango::DEV_BOOLEAN, Tango::READ, 13) {};
	~Undulator_bst1_fel2Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_bst1_fel2(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_bst1_fel2_allowed(ty);}
};

class Undulator_bst2_fel1Attrib: public Tango::SpectrumAttr
{
public:
	Undulator_bst2_fel1Attrib():SpectrumAttr("Undulator_bst2_fel1", Tango::DEV_BOOLEAN, Tango::READ, 13) {};
	~Undulator_bst2_fel1Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_bst2_fel1(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_bst2_fel1_allowed(ty);}
};

class Undulator_bst1_fel1Attrib: public Tango::SpectrumAttr
{
public:
	Undulator_bst1_fel1Attrib():SpectrumAttr("Undulator_bst1_fel1", Tango::DEV_BOOLEAN, Tango::READ, 13) {};
	~Undulator_bst1_fel1Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_bst1_fel1(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_bst1_fel1_allowed(ty);}
};

class Undulator_boards_resettableAttrib: public Tango::SpectrumAttr
{
public:
	Undulator_boards_resettableAttrib():SpectrumAttr("Undulator_boards_resettable", Tango::DEV_BOOLEAN, Tango::READ, 17) {};
	~Undulator_boards_resettableAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_boards_resettable(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_boards_resettable_allowed(ty);}
};

class Undulator_boards_disabledAttrib: public Tango::SpectrumAttr
{
public:
	Undulator_boards_disabledAttrib():SpectrumAttr("Undulator_boards_disabled", Tango::DEV_BOOLEAN, Tango::READ, 17) {};
	~Undulator_boards_disabledAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_boards_disabled(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_boards_disabled_allowed(ty);}
};

class Undulator_board_disabled_008Attrib: public Tango::SpectrumAttr
{
	public:
		Undulator_board_disabled_008Attrib():SpectrumAttr("Undulator_board_disabled_008", Tango::DEV_BOOLEAN, Tango::READ, 20) {};
		~Undulator_board_disabled_008Attrib() {};
	
		virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FSafety *>(dev))->read_Undulator_board_disabled_008(att);}
		virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FSafety *>(dev))->is_Undulator_board_disabled_008_allowed(ty);}
};

class Undulator_board_disabled_024Attrib: public Tango::SpectrumAttr
{
	public:
		Undulator_board_disabled_024Attrib():SpectrumAttr("Undulator_board_disabled_024", Tango::DEV_BOOLEAN, Tango::READ, 20) {};
		~Undulator_board_disabled_024Attrib() {};
	
		virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FSafety *>(dev))->read_Undulator_board_disabled_024(att);}
		virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FSafety *>(dev))->is_Undulator_board_disabled_024_allowed(ty);}
};

class Undulator_board_disabled_100Attrib: public Tango::SpectrumAttr
{
	public:
		Undulator_board_disabled_100Attrib():SpectrumAttr("Undulator_board_disabled_100", Tango::DEV_BOOLEAN, Tango::READ, 20) {};
		~Undulator_board_disabled_100Attrib() {};
	
		virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FSafety *>(dev))->read_Undulator_board_disabled_100(att);}
		virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FSafety *>(dev))->is_Undulator_board_disabled_100_allowed(ty);}
};

class Undulator_board_disabled_106Attrib: public Tango::SpectrumAttr
{
	public:
		Undulator_board_disabled_106Attrib():SpectrumAttr("Undulator_board_disabled_106", Tango::DEV_BOOLEAN, Tango::READ, 20) {};
		~Undulator_board_disabled_106Attrib() {};
	
		virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FSafety *>(dev))->read_Undulator_board_disabled_106(att);}
		virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FSafety *>(dev))->is_Undulator_board_disabled_106_allowed(ty);}
};

class Undulator_board_disabled_126Attrib: public Tango::SpectrumAttr
{
	public:
		Undulator_board_disabled_126Attrib():SpectrumAttr("Undulator_board_disabled_126", Tango::DEV_BOOLEAN, Tango::READ, 20) {};
		~Undulator_board_disabled_126Attrib() {};
	
		virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FSafety *>(dev))->read_Undulator_board_disabled_126(att);}
		virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FSafety *>(dev))->is_Undulator_board_disabled_126_allowed(ty);}
};

class Undulator_board_disabled_132Attrib: public Tango::SpectrumAttr
{
	public:
		Undulator_board_disabled_132Attrib():SpectrumAttr("Undulator_board_disabled_132", Tango::DEV_BOOLEAN, Tango::READ, 20) {};
		~Undulator_board_disabled_132Attrib() {};
	
		virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FSafety *>(dev))->read_Undulator_board_disabled_132(att);}
		virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FSafety *>(dev))->is_Undulator_board_disabled_132_allowed(ty);}
};

class Undulator_board_disabled_152Attrib: public Tango::SpectrumAttr
{
	public:
		Undulator_board_disabled_152Attrib():SpectrumAttr("Undulator_board_disabled_152", Tango::DEV_BOOLEAN, Tango::READ, 20) {};
		~Undulator_board_disabled_152Attrib() {};
	
		virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FSafety *>(dev))->read_Undulator_board_disabled_152(att);}
		virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FSafety *>(dev))->is_Undulator_board_disabled_152_allowed(ty);}
};

class Undulator_board_disabled_158Attrib: public Tango::SpectrumAttr
{
	public:
		Undulator_board_disabled_158Attrib():SpectrumAttr("Undulator_board_disabled_158", Tango::DEV_BOOLEAN, Tango::READ, 20) {};
		~Undulator_board_disabled_158Attrib() {};
	
		virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FSafety *>(dev))->read_Undulator_board_disabled_158(att);}
		virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FSafety *>(dev))->is_Undulator_board_disabled_158_allowed(ty);}
};

class Undulator_board_disabled_178Attrib: public Tango::SpectrumAttr
{
	public:
		Undulator_board_disabled_178Attrib():SpectrumAttr("Undulator_board_disabled_178", Tango::DEV_BOOLEAN, Tango::READ, 20) {};
		~Undulator_board_disabled_178Attrib() {};
	
		virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FSafety *>(dev))->read_Undulator_board_disabled_178(att);}
		virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FSafety *>(dev))->is_Undulator_board_disabled_178_allowed(ty);}
};

class Undulator_board_disabled_184Attrib: public Tango::SpectrumAttr
{
	public:
		Undulator_board_disabled_184Attrib():SpectrumAttr("Undulator_board_disabled_184", Tango::DEV_BOOLEAN, Tango::READ, 20) {};
		~Undulator_board_disabled_184Attrib() {};
	
		virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FSafety *>(dev))->read_Undulator_board_disabled_184(att);}
		virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FSafety *>(dev))->is_Undulator_board_disabled_184_allowed(ty);}
};

class Undulator_board_disabled_204Attrib: public Tango::SpectrumAttr
{
	public:
		Undulator_board_disabled_204Attrib():SpectrumAttr("Undulator_board_disabled_204", Tango::DEV_BOOLEAN, Tango::READ, 20) {};
		~Undulator_board_disabled_204Attrib() {};
	
		virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FSafety *>(dev))->read_Undulator_board_disabled_204(att);}
		virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FSafety *>(dev))->is_Undulator_board_disabled_204_allowed(ty);}
};

class Undulator_board_disabled_214Attrib: public Tango::SpectrumAttr
{
	public:
		Undulator_board_disabled_214Attrib():SpectrumAttr("Undulator_board_disabled_214", Tango::DEV_BOOLEAN, Tango::READ, 20) {};
		~Undulator_board_disabled_214Attrib() {};
	
		virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FSafety *>(dev))->read_Undulator_board_disabled_214(att);}
		virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FSafety *>(dev))->is_Undulator_board_disabled_214_allowed(ty);}
};

class Undulator_board_disabled_248Attrib: public Tango::SpectrumAttr
{
	public:
		Undulator_board_disabled_248Attrib():SpectrumAttr("Undulator_board_disabled_248", Tango::DEV_BOOLEAN, Tango::READ, 20) {};
		~Undulator_board_disabled_248Attrib() {};
	
		virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FSafety *>(dev))->read_Undulator_board_disabled_248(att);}
		virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FSafety *>(dev))->is_Undulator_board_disabled_248_allowed(ty);}
};

class Undulator_board_disabled_270Attrib: public Tango::SpectrumAttr
{
	public:
		Undulator_board_disabled_270Attrib():SpectrumAttr("Undulator_board_disabled_270", Tango::DEV_BOOLEAN, Tango::READ, 20) {};
		~Undulator_board_disabled_270Attrib() {};
	
		virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FSafety *>(dev))->read_Undulator_board_disabled_270(att);}
		virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FSafety *>(dev))->is_Undulator_board_disabled_270_allowed(ty);}
};

class Undulator_board_disabled_288Attrib: public Tango::SpectrumAttr
{
	public:
		Undulator_board_disabled_288Attrib():SpectrumAttr("Undulator_board_disabled_288", Tango::DEV_BOOLEAN, Tango::READ, 20) {};
		~Undulator_board_disabled_288Attrib() {};
	
		virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FSafety *>(dev))->read_Undulator_board_disabled_288(att);}
		virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FSafety *>(dev))->is_Undulator_board_disabled_288_allowed(ty);}
};

class Undulator_badge_onAttrib: public Tango::SpectrumAttr
{
public:
	Undulator_badge_onAttrib():SpectrumAttr("Undulator_badge_on", Tango::DEV_BOOLEAN, Tango::READ, 16) {};
	~Undulator_badge_onAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_badge_on(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_badge_on_allowed(ty);}
};

class Undulator_badge_ackAttrib: public Tango::SpectrumAttr
{
public:
	Undulator_badge_ackAttrib():SpectrumAttr("Undulator_badge_ack", Tango::DEV_STRING, Tango::READ, 1) {};
	~Undulator_badge_ackAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_badge_ack(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_badge_ack_allowed(ty);}
};

class Undulator_badge_allAttrib: public Tango::SpectrumAttr
{
public:
	Undulator_badge_allAttrib():SpectrumAttr("Undulator_badge_all", Tango::DEV_STRING, Tango::READ, 16) {};
	~Undulator_badge_allAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_badge_all(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_badge_all_allowed(ty);}
};

class Undulator_access_hutchAttrib: public Tango::SpectrumAttr
{
public:
	Undulator_access_hutchAttrib():SpectrumAttr("Undulator_access_hutch", Tango::DEV_BOOLEAN, Tango::READ, 14) {};
	~Undulator_access_hutchAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_access_hutch(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_access_hutch_allowed(ty);}
};

class Undulator_access_stateAttrib: public Tango::SpectrumAttr
{
public:
	Undulator_access_stateAttrib():SpectrumAttr("Undulator_access_state", Tango::DEV_BOOLEAN, Tango::READ, 15) {};
	~Undulator_access_stateAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_access_state(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_access_state_allowed(ty);}
};

class Undulator_access_signalsAttrib: public Tango::SpectrumAttr
{
public:
	Undulator_access_signalsAttrib():SpectrumAttr("Undulator_access_signals", Tango::DEV_BOOLEAN, Tango::READ, 36) {};
	~Undulator_access_signalsAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_access_signals(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_access_signals_allowed(ty);}
};

class Linac_mod_inhib_hv_genAttrib: public Tango::SpectrumAttr
{
public:
	Linac_mod_inhib_hv_genAttrib():SpectrumAttr("Linac_mod_inhib_hv_gen", Tango::DEV_BOOLEAN, Tango::READ, 13) {};
	~Linac_mod_inhib_hv_genAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_mod_inhib_hv_gen(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_mod_inhib_hv_gen_allowed(ty);}
};

class Linac_mod_inhib_rf_genAttrib: public Tango::SpectrumAttr
{
public:
	Linac_mod_inhib_rf_genAttrib():SpectrumAttr("Linac_mod_inhib_rf_gen", Tango::DEV_BOOLEAN, Tango::READ, 17) {};
	~Linac_mod_inhib_rf_genAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_mod_inhib_rf_gen(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_mod_inhib_rf_gen_allowed(ty);}
};

class Linac_mod_inhib_rf_ksAttrib: public Tango::SpectrumAttr
{
public:
	Linac_mod_inhib_rf_ksAttrib():SpectrumAttr("Linac_mod_inhib_rf_ks", Tango::DEV_BOOLEAN, Tango::READ, 27) {};
	~Linac_mod_inhib_rf_ksAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_mod_inhib_rf_ks(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_mod_inhib_rf_ks_allowed(ty);}
};

class Linac_mod_inhib_hv_ksAttrib: public Tango::SpectrumAttr
{
public:
	Linac_mod_inhib_hv_ksAttrib():SpectrumAttr("Linac_mod_inhib_hv_ks", Tango::DEV_BOOLEAN, Tango::READ, 9) {};
	~Linac_mod_inhib_hv_ksAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_mod_inhib_hv_ks(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_mod_inhib_hv_ks_allowed(ty);}
};

class Linac_mod_inhib_hv_k2Attrib: public Tango::SpectrumAttr
{
public:
	Linac_mod_inhib_hv_k2Attrib():SpectrumAttr("Linac_mod_inhib_hv_k2", Tango::DEV_BOOLEAN, Tango::READ, 9) {};
	~Linac_mod_inhib_hv_k2Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_mod_inhib_hv_k2(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_mod_inhib_hv_k2_allowed(ty);}
};

class Linac_mod_inhib_hv_k1Attrib: public Tango::SpectrumAttr
{
public:
	Linac_mod_inhib_hv_k1Attrib():SpectrumAttr("Linac_mod_inhib_hv_k1", Tango::DEV_BOOLEAN, Tango::READ, 9) {};
	~Linac_mod_inhib_hv_k1Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_mod_inhib_hv_k1(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_mod_inhib_hv_k1_allowed(ty);}
};

class Linac_mod_inhib_rf_k2Attrib: public Tango::SpectrumAttr
{
public:
	Linac_mod_inhib_rf_k2Attrib():SpectrumAttr("Linac_mod_inhib_rf_k2", Tango::DEV_BOOLEAN, Tango::READ, 20) {};
	~Linac_mod_inhib_rf_k2Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_mod_inhib_rf_k2(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_mod_inhib_rf_k2_allowed(ty);}
};

class Linac_mod_inhib_rf_k1Attrib: public Tango::SpectrumAttr
{
public:
	Linac_mod_inhib_rf_k1Attrib():SpectrumAttr("Linac_mod_inhib_rf_k1", Tango::DEV_BOOLEAN, Tango::READ, 27) {};
	~Linac_mod_inhib_rf_k1Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_mod_inhib_rf_k1(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_mod_inhib_rf_k1_allowed(ty);}
};

class Linac_badge_onAttrib: public Tango::SpectrumAttr
{
public:
	Linac_badge_onAttrib():SpectrumAttr("Linac_badge_on", Tango::DEV_BOOLEAN, Tango::READ, 16) {};
	~Linac_badge_onAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_badge_on(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_badge_on_allowed(ty);}
};

class Linac_emergency_memo_buttonsAttrib: public Tango::SpectrumAttr
{
public:
	Linac_emergency_memo_buttonsAttrib():SpectrumAttr("Linac_emergency_memo_buttons", Tango::DEV_BOOLEAN, Tango::READ, 15) {};
	~Linac_emergency_memo_buttonsAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_emergency_memo_buttons(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_emergency_memo_buttons_allowed(ty);}
};

class Linac_doors_memoopen_extAttrib: public Tango::SpectrumAttr
{
public:
	Linac_doors_memoopen_extAttrib():SpectrumAttr("Linac_doors_memoopen_ext", Tango::DEV_BOOLEAN, Tango::READ, 3) {};
	~Linac_doors_memoopen_extAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_doors_memoopen_ext(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_doors_memoopen_ext_allowed(ty);}
};

class Linac_search_namesAttrib: public Tango::SpectrumAttr
{
public:
	Linac_search_namesAttrib():SpectrumAttr("Linac_search_names", Tango::DEV_STRING, Tango::READ, 116) {};
	~Linac_search_namesAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_search_names(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_search_names_allowed(ty);}
};

class Linac_access_namesAttrib: public Tango::SpectrumAttr
{
public:
	Linac_access_namesAttrib():SpectrumAttr("Linac_access_names", Tango::DEV_STRING, Tango::READ, 116) {};
	~Linac_access_namesAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_access_names(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_access_names_allowed(ty);}
};

class Linac_doors_extAttrib: public Tango::SpectrumAttr
{
public:
	Linac_doors_extAttrib():SpectrumAttr("Linac_doors_ext", Tango::DEV_BOOLEAN, Tango::READ, 3) {};
	~Linac_doors_extAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_doors_ext(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_doors_ext_allowed(ty);}
};

class Linac_switches_stableAttrib: public Tango::SpectrumAttr
{
public:
	Linac_switches_stableAttrib():SpectrumAttr("Linac_switches_stable", Tango::DEV_BOOLEAN, Tango::READ, 12) {};
	~Linac_switches_stableAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_switches_stable(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_switches_stable_allowed(ty);}
};

class Linac_switches_movingAttrib: public Tango::SpectrumAttr
{
public:
	Linac_switches_movingAttrib():SpectrumAttr("Linac_switches_moving", Tango::DEV_BOOLEAN, Tango::READ, 16) {};
	~Linac_switches_movingAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_switches_moving(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_switches_moving_allowed(ty);}
};

class Linac_switches_loadAttrib: public Tango::SpectrumAttr
{
public:
	Linac_switches_loadAttrib():SpectrumAttr("Linac_switches_load", Tango::DEV_BOOLEAN, Tango::READ, 25) {};
	~Linac_switches_loadAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_switches_load(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_switches_load_allowed(ty);}
};

class Linac_switches_configAttrib: public Tango::SpectrumAttr
{
public:
	Linac_switches_configAttrib():SpectrumAttr("Linac_switches_config", Tango::DEV_SHORT, Tango::READ, 10) {};
	~Linac_switches_configAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_switches_config(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_switches_config_allowed(ty);}
};

class Linac_switches_abiAttrib: public Tango::SpectrumAttr
{
public:
	Linac_switches_abiAttrib():SpectrumAttr("Linac_switches_abi", Tango::DEV_BOOLEAN, Tango::READ, 20) {};
	~Linac_switches_abiAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_switches_abi(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_switches_abi_allowed(ty);}
};

class Linac_stateAttrib: public Tango::SpectrumAttr
{
public:
	Linac_stateAttrib():SpectrumAttr("Linac_state", Tango::DEV_BOOLEAN, Tango::READ, 4) {};
	~Linac_stateAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_state(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_state_allowed(ty);}
};

class Linac_sir_buzAttrib: public Tango::SpectrumAttr
{
public:
	Linac_sir_buzAttrib():SpectrumAttr("Linac_sir_buz", Tango::DEV_BOOLEAN, Tango::READ, 11) {};
	~Linac_sir_buzAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_sir_buz(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_sir_buz_allowed(ty);}
};

class Linac_search_fail_tlAttrib: public Tango::SpectrumAttr
{
public:
	Linac_search_fail_tlAttrib():SpectrumAttr("Linac_search_fail_tl", Tango::DEV_BOOLEAN, Tango::READ, 8) {};
	~Linac_search_fail_tlAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_search_fail_tl(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_search_fail_tl_allowed(ty);}
};

class Linac_search_fail_lAttrib: public Tango::SpectrumAttr
{
public:
	Linac_search_fail_lAttrib():SpectrumAttr("Linac_search_fail_l", Tango::DEV_BOOLEAN, Tango::READ, 23) {};
	~Linac_search_fail_lAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_search_fail_l(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_search_fail_l_allowed(ty);}
};

class Linac_search_fail_e3Attrib: public Tango::SpectrumAttr
{
public:
	Linac_search_fail_e3Attrib():SpectrumAttr("Linac_search_fail_e3", Tango::DEV_BOOLEAN, Tango::READ, 8) {};
	~Linac_search_fail_e3Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_search_fail_e3(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_search_fail_e3_allowed(ty);}
};

class Linac_search_fail_e2Attrib: public Tango::SpectrumAttr
{
public:
	Linac_search_fail_e2Attrib():SpectrumAttr("Linac_search_fail_e2", Tango::DEV_BOOLEAN, Tango::READ, 9) {};
	~Linac_search_fail_e2Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_search_fail_e2(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_search_fail_e2_allowed(ty);}
};

class Linac_search_fail_e1Attrib: public Tango::SpectrumAttr
{
public:
	Linac_search_fail_e1Attrib():SpectrumAttr("Linac_search_fail_e1", Tango::DEV_BOOLEAN, Tango::READ, 9) {};
	~Linac_search_fail_e1Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_search_fail_e1(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_search_fail_e1_allowed(ty);}
};

class Linac_search_fail_e0Attrib: public Tango::SpectrumAttr
{
public:
	Linac_search_fail_e0Attrib():SpectrumAttr("Linac_search_fail_e0", Tango::DEV_BOOLEAN, Tango::READ, 9) {};
	~Linac_search_fail_e0Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_search_fail_e0(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_search_fail_e0_allowed(ty);}
};

class Linac_search_ini_tlAttrib: public Tango::SpectrumAttr
{
public:
	Linac_search_ini_tlAttrib():SpectrumAttr("Linac_search_ini_tl", Tango::DEV_BOOLEAN, Tango::READ, 5) {};
	~Linac_search_ini_tlAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_search_ini_tl(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_search_ini_tl_allowed(ty);}
};

class Linac_search_ini_lAttrib: public Tango::SpectrumAttr
{
public:
	Linac_search_ini_lAttrib():SpectrumAttr("Linac_search_ini_l", Tango::DEV_BOOLEAN, Tango::READ, 24) {};
	~Linac_search_ini_lAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_search_ini_l(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_search_ini_l_allowed(ty);}
};

class Linac_search_ini_e3Attrib: public Tango::SpectrumAttr
{
public:
	Linac_search_ini_e3Attrib():SpectrumAttr("Linac_search_ini_e3", Tango::DEV_BOOLEAN, Tango::READ, 4) {};
	~Linac_search_ini_e3Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_search_ini_e3(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_search_ini_e3_allowed(ty);}
};

class Linac_search_ini_e2Attrib: public Tango::SpectrumAttr
{
public:
	Linac_search_ini_e2Attrib():SpectrumAttr("Linac_search_ini_e2", Tango::DEV_BOOLEAN, Tango::READ, 5) {};
	~Linac_search_ini_e2Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_search_ini_e2(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_search_ini_e2_allowed(ty);}
};

class Linac_search_ini_e1Attrib: public Tango::SpectrumAttr
{
public:
	Linac_search_ini_e1Attrib():SpectrumAttr("Linac_search_ini_e1", Tango::DEV_BOOLEAN, Tango::READ, 5) {};
	~Linac_search_ini_e1Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_search_ini_e1(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_search_ini_e1_allowed(ty);}
};

class Linac_search_ini_e0Attrib: public Tango::SpectrumAttr
{
public:
	Linac_search_ini_e0Attrib():SpectrumAttr("Linac_search_ini_e0", Tango::DEV_BOOLEAN, Tango::READ, 5) {};
	~Linac_search_ini_e0Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_search_ini_e0(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_search_ini_e0_allowed(ty);}
};

class Linac_search_signals_tlAttrib: public Tango::SpectrumAttr
{
public:
	Linac_search_signals_tlAttrib():SpectrumAttr("Linac_search_signals_tl", Tango::DEV_BOOLEAN, Tango::READ, 10) {};
	~Linac_search_signals_tlAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_search_signals_tl(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_search_signals_tl_allowed(ty);}
};

class Linac_search_signals_lAttrib: public Tango::SpectrumAttr
{
public:
	Linac_search_signals_lAttrib():SpectrumAttr("Linac_search_signals_l", Tango::DEV_BOOLEAN, Tango::READ, 17) {};
	~Linac_search_signals_lAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_search_signals_l(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_search_signals_l_allowed(ty);}
};

class Linac_search_signals_e3Attrib: public Tango::SpectrumAttr
{
public:
	Linac_search_signals_e3Attrib():SpectrumAttr("Linac_search_signals_e3", Tango::DEV_BOOLEAN, Tango::READ, 19) {};
	~Linac_search_signals_e3Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_search_signals_e3(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_search_signals_e3_allowed(ty);}
};

class Linac_search_signals_e2Attrib: public Tango::SpectrumAttr
{
public:
	Linac_search_signals_e2Attrib():SpectrumAttr("Linac_search_signals_e2", Tango::DEV_BOOLEAN, Tango::READ, 19) {};
	~Linac_search_signals_e2Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_search_signals_e2(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_search_signals_e2_allowed(ty);}
};

class Linac_search_signals_e1Attrib: public Tango::SpectrumAttr
{
public:
	Linac_search_signals_e1Attrib():SpectrumAttr("Linac_search_signals_e1", Tango::DEV_BOOLEAN, Tango::READ, 19) {};
	~Linac_search_signals_e1Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_search_signals_e1(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_search_signals_e1_allowed(ty);}
};

class Linac_search_signals_e0Attrib: public Tango::SpectrumAttr
{
public:
	Linac_search_signals_e0Attrib():SpectrumAttr("Linac_search_signals_e0", Tango::DEV_BOOLEAN, Tango::READ, 18) {};
	~Linac_search_signals_e0Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_search_signals_e0(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_search_signals_e0_allowed(ty);}
};

class Linac_search_req_e3Attrib: public Tango::SpectrumAttr
{
public:
	Linac_search_req_e3Attrib():SpectrumAttr("Linac_search_req_e3", Tango::DEV_BOOLEAN, Tango::READ, 4) {};
	~Linac_search_req_e3Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_search_req_e3(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_search_req_e3_allowed(ty);}
};

class Linac_search_req_e2Attrib: public Tango::SpectrumAttr
{
public:
	Linac_search_req_e2Attrib():SpectrumAttr("Linac_search_req_e2", Tango::DEV_BOOLEAN, Tango::READ, 5) {};
	~Linac_search_req_e2Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_search_req_e2(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_search_req_e2_allowed(ty);}
};

class Linac_search_req_e1Attrib: public Tango::SpectrumAttr
{
public:
	Linac_search_req_e1Attrib():SpectrumAttr("Linac_search_req_e1", Tango::DEV_BOOLEAN, Tango::READ, 5) {};
	~Linac_search_req_e1Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_search_req_e1(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_search_req_e1_allowed(ty);}
};

class Linac_search_req_e0Attrib: public Tango::SpectrumAttr
{
public:
	Linac_search_req_e0Attrib():SpectrumAttr("Linac_search_req_e0", Tango::DEV_BOOLEAN, Tango::READ, 5) {};
	~Linac_search_req_e0Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_search_req_e0(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_search_req_e0_allowed(ty);}
};

class Linac_search_req_tlAttrib: public Tango::SpectrumAttr
{
public:
	Linac_search_req_tlAttrib():SpectrumAttr("Linac_search_req_tl", Tango::DEV_BOOLEAN, Tango::READ, 5) {};
	~Linac_search_req_tlAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_search_req_tl(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_search_req_tl_allowed(ty);}
};

class Linac_search_req_lAttrib: public Tango::SpectrumAttr
{
public:
	Linac_search_req_lAttrib():SpectrumAttr("Linac_search_req_l", Tango::DEV_BOOLEAN, Tango::READ, 22) {};
	~Linac_search_req_lAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_search_req_l(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_search_req_l_allowed(ty);}
};

class Linac_search_lightsAttrib: public Tango::SpectrumAttr
{
public:
	Linac_search_lightsAttrib():SpectrumAttr("Linac_search_lights", Tango::DEV_BOOLEAN, Tango::READ, 12) {};
	~Linac_search_lightsAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_search_lights(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_search_lights_allowed(ty);}
};

class Linac_search_doorlightsAttrib: public Tango::SpectrumAttr
{
public:
	Linac_search_doorlightsAttrib():SpectrumAttr("Linac_search_doorlights", Tango::DEV_BOOLEAN, Tango::READ, 5) {};
	~Linac_search_doorlightsAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_search_doorlights(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_search_doorlights_allowed(ty);}
};

class Linac_search_buttonsAttrib: public Tango::SpectrumAttr
{
public:
	Linac_search_buttonsAttrib():SpectrumAttr("Linac_search_buttons", Tango::DEV_BOOLEAN, Tango::READ, 12) {};
	~Linac_search_buttonsAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_search_buttons(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_search_buttons_allowed(ty);}
};

class Linac_search_barriersAttrib: public Tango::SpectrumAttr
{
public:
	Linac_search_barriersAttrib():SpectrumAttr("Linac_search_barriers", Tango::DEV_BOOLEAN, Tango::READ, 3) {};
	~Linac_search_barriersAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_search_barriers(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_search_barriers_allowed(ty);}
};

class Linac_safetyAttrib: public Tango::SpectrumAttr
{
public:
	Linac_safetyAttrib():SpectrumAttr("Linac_safety", Tango::DEV_BOOLEAN, Tango::READ, 11) {};
	~Linac_safetyAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_safety(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_safety_allowed(ty);}
};

class Linac_pickupAttrib: public Tango::SpectrumAttr
{
public:
	Linac_pickupAttrib():SpectrumAttr("Linac_pickup", Tango::DEV_BOOLEAN, Tango::READ, 10) {};
	~Linac_pickupAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_pickup(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_pickup_allowed(ty);}
};

class Linac_mod_pre_hv_abiAttrib: public Tango::SpectrumAttr
{
public:
	Linac_mod_pre_hv_abiAttrib():SpectrumAttr("Linac_mod_pre_hv_abi", Tango::DEV_BOOLEAN, Tango::READ, 16) {};
	~Linac_mod_pre_hv_abiAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_mod_pre_hv_abi(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_mod_pre_hv_abi_allowed(ty);}
};

class Linac_mod_positionsAttrib: public Tango::SpectrumAttr
{
public:
	Linac_mod_positionsAttrib():SpectrumAttr("Linac_mod_positions", Tango::DEV_BOOLEAN, Tango::READ, 15) {};
	~Linac_mod_positionsAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_mod_positions(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_mod_positions_allowed(ty);}
};

class Linac_mod_rfAttrib: public Tango::SpectrumAttr
{
public:
	Linac_mod_rfAttrib():SpectrumAttr("Linac_mod_rf", Tango::DEV_BOOLEAN, Tango::READ, 16) {};
	~Linac_mod_rfAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_mod_rf(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_mod_rf_allowed(ty);}
};

class Linac_mod_hvAttrib: public Tango::SpectrumAttr
{
public:
	Linac_mod_hvAttrib():SpectrumAttr("Linac_mod_hv", Tango::DEV_BOOLEAN, Tango::READ, 16) {};
	~Linac_mod_hvAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_mod_hv(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_mod_hv_allowed(ty);}
};

class Linac_mod_abi_rfAttrib: public Tango::SpectrumAttr
{
public:
	Linac_mod_abi_rfAttrib():SpectrumAttr("Linac_mod_abi_rf", Tango::DEV_BOOLEAN, Tango::READ, 32) {};
	~Linac_mod_abi_rfAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_mod_abi_rf(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_mod_abi_rf_allowed(ty);}
};

class Linac_mod_abi_hvAttrib: public Tango::SpectrumAttr
{
public:
	Linac_mod_abi_hvAttrib():SpectrumAttr("Linac_mod_abi_hv", Tango::DEV_BOOLEAN, Tango::READ, 32) {};
	~Linac_mod_abi_hvAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_mod_abi_hv(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_mod_abi_hv_allowed(ty);}
};

class Linac_key_releaseAttrib: public Tango::SpectrumAttr
{
public:
	Linac_key_releaseAttrib():SpectrumAttr("Linac_key_release", Tango::DEV_BOOLEAN, Tango::READ, 16) {};
	~Linac_key_releaseAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_key_release(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_key_release_allowed(ty);}
};

class Linac_key_intAttrib: public Tango::SpectrumAttr
{
public:
	Linac_key_intAttrib():SpectrumAttr("Linac_key_int", Tango::DEV_BOOLEAN, Tango::READ, 16) {};
	~Linac_key_intAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_key_int(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_key_int_allowed(ty);}
};

class Linac_key_extAttrib: public Tango::SpectrumAttr
{
public:
	Linac_key_extAttrib():SpectrumAttr("Linac_key_ext", Tango::DEV_BOOLEAN, Tango::READ, 16) {};
	~Linac_key_extAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_key_ext(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_key_ext_allowed(ty);}
};

class Linac_glob_signalsAttrib: public Tango::SpectrumAttr
{
public:
	Linac_glob_signalsAttrib():SpectrumAttr("Linac_glob_signals", Tango::DEV_BOOLEAN, Tango::READ, 10) {};
	~Linac_glob_signalsAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_glob_signals(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_glob_signals_allowed(ty);}
};

class Linac_key_globAttrib: public Tango::SpectrumAttr
{
public:
	Linac_key_globAttrib():SpectrumAttr("Linac_key_glob", Tango::DEV_BOOLEAN, Tango::READ, 2) {};
	~Linac_key_globAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_key_glob(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_key_glob_allowed(ty);}
};

class Linac_gammaAttrib: public Tango::SpectrumAttr
{
public:
	Linac_gammaAttrib():SpectrumAttr("Linac_gamma", Tango::DEV_BOOLEAN, Tango::READ, 6) {};
	~Linac_gammaAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_gamma(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_gamma_allowed(ty);}
};

class Linac_emergency_buttonsAttrib: public Tango::SpectrumAttr
{
public:
	Linac_emergency_buttonsAttrib():SpectrumAttr("Linac_emergency_buttons", Tango::DEV_BOOLEAN, Tango::READ, 15) {};
	~Linac_emergency_buttonsAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_emergency_buttons(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_emergency_buttons_allowed(ty);}
};

class Linac_doors_memoopen_tlAttrib: public Tango::SpectrumAttr
{
public:
	Linac_doors_memoopen_tlAttrib():SpectrumAttr("Linac_doors_memoopen_tl", Tango::DEV_BOOLEAN, Tango::READ, 2) {};
	~Linac_doors_memoopen_tlAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_doors_memoopen_tl(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_doors_memoopen_tl_allowed(ty);}
};

class Linac_doors_memoopen_lAttrib: public Tango::SpectrumAttr
{
public:
	Linac_doors_memoopen_lAttrib():SpectrumAttr("Linac_doors_memoopen_l", Tango::DEV_BOOLEAN, Tango::READ, 3) {};
	~Linac_doors_memoopen_lAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_doors_memoopen_l(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_doors_memoopen_l_allowed(ty);}
};

class Linac_doors_memoopen_e3Attrib: public Tango::SpectrumAttr
{
public:
	Linac_doors_memoopen_e3Attrib():SpectrumAttr("Linac_doors_memoopen_e3", Tango::DEV_BOOLEAN, Tango::READ, 6) {};
	~Linac_doors_memoopen_e3Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_doors_memoopen_e3(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_doors_memoopen_e3_allowed(ty);}
};

class Linac_doors_memoopen_e2Attrib: public Tango::SpectrumAttr
{
public:
	Linac_doors_memoopen_e2Attrib():SpectrumAttr("Linac_doors_memoopen_e2", Tango::DEV_BOOLEAN, Tango::READ, 4) {};
	~Linac_doors_memoopen_e2Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_doors_memoopen_e2(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_doors_memoopen_e2_allowed(ty);}
};

class Linac_doors_memoopen_e1Attrib: public Tango::SpectrumAttr
{
public:
	Linac_doors_memoopen_e1Attrib():SpectrumAttr("Linac_doors_memoopen_e1", Tango::DEV_BOOLEAN, Tango::READ, 4) {};
	~Linac_doors_memoopen_e1Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_doors_memoopen_e1(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_doors_memoopen_e1_allowed(ty);}
};

class Linac_doors_memoopen_e0Attrib: public Tango::SpectrumAttr
{
public:
	Linac_doors_memoopen_e0Attrib():SpectrumAttr("Linac_doors_memoopen_e0", Tango::DEV_BOOLEAN, Tango::READ, 4) {};
	~Linac_doors_memoopen_e0Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_doors_memoopen_e0(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_doors_memoopen_e0_allowed(ty);}
};

class Linac_doors_tlAttrib: public Tango::SpectrumAttr
{
public:
	Linac_doors_tlAttrib():SpectrumAttr("Linac_doors_tl", Tango::DEV_BOOLEAN, Tango::READ, 2) {};
	~Linac_doors_tlAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_doors_tl(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_doors_tl_allowed(ty);}
};

class Linac_doors_lAttrib: public Tango::SpectrumAttr
{
public:
	Linac_doors_lAttrib():SpectrumAttr("Linac_doors_l", Tango::DEV_BOOLEAN, Tango::READ, 3) {};
	~Linac_doors_lAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_doors_l(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_doors_l_allowed(ty);}
};

class Linac_doors_e3Attrib: public Tango::SpectrumAttr
{
public:
	Linac_doors_e3Attrib():SpectrumAttr("Linac_doors_e3", Tango::DEV_BOOLEAN, Tango::READ, 5) {};
	~Linac_doors_e3Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_doors_e3(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_doors_e3_allowed(ty);}
};

class Linac_doors_e2Attrib: public Tango::SpectrumAttr
{
public:
	Linac_doors_e2Attrib():SpectrumAttr("Linac_doors_e2", Tango::DEV_BOOLEAN, Tango::READ, 4) {};
	~Linac_doors_e2Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_doors_e2(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_doors_e2_allowed(ty);}
};

class Linac_doors_e1Attrib: public Tango::SpectrumAttr
{
public:
	Linac_doors_e1Attrib():SpectrumAttr("Linac_doors_e1", Tango::DEV_BOOLEAN, Tango::READ, 4) {};
	~Linac_doors_e1Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_doors_e1(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_doors_e1_allowed(ty);}
};

class Linac_doors_e0Attrib: public Tango::SpectrumAttr
{
public:
	Linac_doors_e0Attrib():SpectrumAttr("Linac_doors_e0", Tango::DEV_BOOLEAN, Tango::READ, 4) {};
	~Linac_doors_e0Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_doors_e0(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_doors_e0_allowed(ty);}
};

class Linac_disp_int_codeAttrib: public Tango::SpectrumAttr
{
public:
	Linac_disp_int_codeAttrib():SpectrumAttr("Linac_disp_int_code", Tango::DEV_SHORT, Tango::READ, 1) {};
	~Linac_disp_int_codeAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_disp_int_code(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_disp_int_code_allowed(ty);}
};

class Linac_disp_ext_codeAttrib: public Tango::SpectrumAttr
{
public:
	Linac_disp_ext_codeAttrib():SpectrumAttr("Linac_disp_ext_code", Tango::DEV_SHORT, Tango::READ, 1) {};
	~Linac_disp_ext_codeAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_disp_ext_code(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_disp_ext_code_allowed(ty);}
};

class Linac_bst_1Attrib: public Tango::SpectrumAttr
{
public:
	Linac_bst_1Attrib():SpectrumAttr("Linac_bst_1", Tango::DEV_BOOLEAN, Tango::READ, 13) {};
	~Linac_bst_1Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_bst_1(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_bst_1_allowed(ty);}
};

class Linac_boards_resettableAttrib: public Tango::SpectrumAttr
{
public:
	Linac_boards_resettableAttrib():SpectrumAttr("Linac_boards_resettable", Tango::DEV_BOOLEAN, Tango::READ, 35) {};
	~Linac_boards_resettableAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_boards_resettable(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_boards_resettable_allowed(ty);}
};

class Linac_boards_disabledAttrib: public Tango::SpectrumAttr
{
public:
	Linac_boards_disabledAttrib():SpectrumAttr("Linac_boards_disabled", Tango::DEV_BOOLEAN, Tango::READ, 35) {};
	~Linac_boards_disabledAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_boards_disabled(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_boards_disabled_allowed(ty);}
};

class Linac_board_disabled_008Attrib: public Tango::SpectrumAttr
{
	public:
		Linac_board_disabled_008Attrib():SpectrumAttr("Linac_board_disabled_008", Tango::DEV_BOOLEAN, Tango::READ, 20) {};
		~Linac_board_disabled_008Attrib() {};
	
		virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FSafety *>(dev))->read_Linac_board_disabled_008(att);}
		virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FSafety *>(dev))->is_Linac_board_disabled_008_allowed(ty);}
};

class Linac_board_disabled_040Attrib: public Tango::SpectrumAttr
{
	public:
		Linac_board_disabled_040Attrib():SpectrumAttr("Linac_board_disabled_040", Tango::DEV_BOOLEAN, Tango::READ, 20) {};
		~Linac_board_disabled_040Attrib() {};
	
		virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FSafety *>(dev))->read_Linac_board_disabled_040(att);}
		virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FSafety *>(dev))->is_Linac_board_disabled_040_allowed(ty);}
};

class Linac_board_disabled_058Attrib: public Tango::SpectrumAttr
{
	public:
		Linac_board_disabled_058Attrib():SpectrumAttr("Linac_board_disabled_058", Tango::DEV_BOOLEAN, Tango::READ, 20) {};
		~Linac_board_disabled_058Attrib() {};
	
		virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FSafety *>(dev))->read_Linac_board_disabled_058(att);}
		virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FSafety *>(dev))->is_Linac_board_disabled_058_allowed(ty);}
};

class Linac_board_disabled_068Attrib: public Tango::SpectrumAttr
{
	public:
		Linac_board_disabled_068Attrib():SpectrumAttr("Linac_board_disabled_068", Tango::DEV_BOOLEAN, Tango::READ, 20) {};
		~Linac_board_disabled_068Attrib() {};
	
		virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FSafety *>(dev))->read_Linac_board_disabled_068(att);}
		virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FSafety *>(dev))->is_Linac_board_disabled_068_allowed(ty);}
};

class Linac_board_disabled_078Attrib: public Tango::SpectrumAttr
{
	public:
		Linac_board_disabled_078Attrib():SpectrumAttr("Linac_board_disabled_078", Tango::DEV_BOOLEAN, Tango::READ, 20) {};
		~Linac_board_disabled_078Attrib() {};
	
		virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FSafety *>(dev))->read_Linac_board_disabled_078(att);}
		virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FSafety *>(dev))->is_Linac_board_disabled_078_allowed(ty);}
};

class Linac_board_disabled_100Attrib: public Tango::SpectrumAttr
{
	public:
		Linac_board_disabled_100Attrib():SpectrumAttr("Linac_board_disabled_100", Tango::DEV_BOOLEAN, Tango::READ, 20) {};
		~Linac_board_disabled_100Attrib() {};
	
		virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FSafety *>(dev))->read_Linac_board_disabled_100(att);}
		virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FSafety *>(dev))->is_Linac_board_disabled_100_allowed(ty);}
};

class Linac_board_disabled_106Attrib: public Tango::SpectrumAttr
{
	public:
		Linac_board_disabled_106Attrib():SpectrumAttr("Linac_board_disabled_106", Tango::DEV_BOOLEAN, Tango::READ, 20) {};
		~Linac_board_disabled_106Attrib() {};
	
		virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FSafety *>(dev))->read_Linac_board_disabled_106(att);}
		virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FSafety *>(dev))->is_Linac_board_disabled_106_allowed(ty);}
};

class Linac_board_disabled_126Attrib: public Tango::SpectrumAttr
{
	public:
		Linac_board_disabled_126Attrib():SpectrumAttr("Linac_board_disabled_126", Tango::DEV_BOOLEAN, Tango::READ, 20) {};
		~Linac_board_disabled_126Attrib() {};
	
		virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FSafety *>(dev))->read_Linac_board_disabled_126(att);}
		virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FSafety *>(dev))->is_Linac_board_disabled_126_allowed(ty);}
};

class Linac_board_disabled_132Attrib: public Tango::SpectrumAttr
{
	public:
		Linac_board_disabled_132Attrib():SpectrumAttr("Linac_board_disabled_132", Tango::DEV_BOOLEAN, Tango::READ, 20) {};
		~Linac_board_disabled_132Attrib() {};
	
		virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FSafety *>(dev))->read_Linac_board_disabled_132(att);}
		virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FSafety *>(dev))->is_Linac_board_disabled_132_allowed(ty);}
};

class Linac_board_disabled_152Attrib: public Tango::SpectrumAttr
{
	public:
		Linac_board_disabled_152Attrib():SpectrumAttr("Linac_board_disabled_152", Tango::DEV_BOOLEAN, Tango::READ, 20) {};
		~Linac_board_disabled_152Attrib() {};
	
		virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FSafety *>(dev))->read_Linac_board_disabled_152(att);}
		virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FSafety *>(dev))->is_Linac_board_disabled_152_allowed(ty);}
};

class Linac_board_disabled_158Attrib: public Tango::SpectrumAttr
{
	public:
		Linac_board_disabled_158Attrib():SpectrumAttr("Linac_board_disabled_158", Tango::DEV_BOOLEAN, Tango::READ, 20) {};
		~Linac_board_disabled_158Attrib() {};
	
		virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FSafety *>(dev))->read_Linac_board_disabled_158(att);}
		virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FSafety *>(dev))->is_Linac_board_disabled_158_allowed(ty);}
};

class Linac_board_disabled_178Attrib: public Tango::SpectrumAttr
{
	public:
		Linac_board_disabled_178Attrib():SpectrumAttr("Linac_board_disabled_178", Tango::DEV_BOOLEAN, Tango::READ, 20) {};
		~Linac_board_disabled_178Attrib() {};
	
		virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FSafety *>(dev))->read_Linac_board_disabled_178(att);}
		virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FSafety *>(dev))->is_Linac_board_disabled_178_allowed(ty);}
};

class Linac_board_disabled_184Attrib: public Tango::SpectrumAttr
{
	public:
		Linac_board_disabled_184Attrib():SpectrumAttr("Linac_board_disabled_184", Tango::DEV_BOOLEAN, Tango::READ, 20) {};
		~Linac_board_disabled_184Attrib() {};
	
		virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FSafety *>(dev))->read_Linac_board_disabled_184(att);}
		virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FSafety *>(dev))->is_Linac_board_disabled_184_allowed(ty);}
};

class Linac_board_disabled_190Attrib: public Tango::SpectrumAttr
{
	public:
		Linac_board_disabled_190Attrib():SpectrumAttr("Linac_board_disabled_190", Tango::DEV_BOOLEAN, Tango::READ, 20) {};
		~Linac_board_disabled_190Attrib() {};
	
		virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FSafety *>(dev))->read_Linac_board_disabled_190(att);}
		virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FSafety *>(dev))->is_Linac_board_disabled_190_allowed(ty);}
};

class Linac_board_disabled_196Attrib: public Tango::SpectrumAttr
{
	public:
		Linac_board_disabled_196Attrib():SpectrumAttr("Linac_board_disabled_196", Tango::DEV_BOOLEAN, Tango::READ, 20) {};
		~Linac_board_disabled_196Attrib() {};
	
		virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FSafety *>(dev))->read_Linac_board_disabled_196(att);}
		virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FSafety *>(dev))->is_Linac_board_disabled_196_allowed(ty);}
};

class Linac_board_disabled_202Attrib: public Tango::SpectrumAttr
{
	public:
		Linac_board_disabled_202Attrib():SpectrumAttr("Linac_board_disabled_202", Tango::DEV_BOOLEAN, Tango::READ, 20) {};
		~Linac_board_disabled_202Attrib() {};
	
		virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FSafety *>(dev))->read_Linac_board_disabled_202(att);}
		virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FSafety *>(dev))->is_Linac_board_disabled_202_allowed(ty);}
};

class Linac_board_disabled_216Attrib: public Tango::SpectrumAttr
{
	public:
		Linac_board_disabled_216Attrib():SpectrumAttr("Linac_board_disabled_216", Tango::DEV_BOOLEAN, Tango::READ, 20) {};
		~Linac_board_disabled_216Attrib() {};
	
		virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FSafety *>(dev))->read_Linac_board_disabled_216(att);}
		virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FSafety *>(dev))->is_Linac_board_disabled_216_allowed(ty);}
};

class Linac_board_disabled_240Attrib: public Tango::SpectrumAttr
{
	public:
		Linac_board_disabled_240Attrib():SpectrumAttr("Linac_board_disabled_240", Tango::DEV_BOOLEAN, Tango::READ, 20) {};
		~Linac_board_disabled_240Attrib() {};
	
		virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FSafety *>(dev))->read_Linac_board_disabled_240(att);}
		virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FSafety *>(dev))->is_Linac_board_disabled_240_allowed(ty);}
};

class Linac_board_disabled_252Attrib: public Tango::SpectrumAttr
{
	public:
		Linac_board_disabled_252Attrib():SpectrumAttr("Linac_board_disabled_252", Tango::DEV_BOOLEAN, Tango::READ, 20) {};
		~Linac_board_disabled_252Attrib() {};
	
		virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FSafety *>(dev))->read_Linac_board_disabled_252(att);}
		virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FSafety *>(dev))->is_Linac_board_disabled_252_allowed(ty);}
};

class Linac_board_disabled_258Attrib: public Tango::SpectrumAttr
{
	public:
		Linac_board_disabled_258Attrib():SpectrumAttr("Linac_board_disabled_258", Tango::DEV_BOOLEAN, Tango::READ, 20) {};
		~Linac_board_disabled_258Attrib() {};
	
		virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FSafety *>(dev))->read_Linac_board_disabled_258(att);}
		virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FSafety *>(dev))->is_Linac_board_disabled_258_allowed(ty);}
};

class Linac_board_disabled_280Attrib: public Tango::SpectrumAttr
{
	public:
		Linac_board_disabled_280Attrib():SpectrumAttr("Linac_board_disabled_280", Tango::DEV_BOOLEAN, Tango::READ, 20) {};
		~Linac_board_disabled_280Attrib() {};
	
		virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FSafety *>(dev))->read_Linac_board_disabled_280(att);}
		virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FSafety *>(dev))->is_Linac_board_disabled_280_allowed(ty);}
};

class Linac_board_disabled_286Attrib: public Tango::SpectrumAttr
{
	public:
		Linac_board_disabled_286Attrib():SpectrumAttr("Linac_board_disabled_286", Tango::DEV_BOOLEAN, Tango::READ, 20) {};
		~Linac_board_disabled_286Attrib() {};
	
		virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FSafety *>(dev))->read_Linac_board_disabled_286(att);}
		virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FSafety *>(dev))->is_Linac_board_disabled_286_allowed(ty);}
};

class Linac_board_disabled_308Attrib: public Tango::SpectrumAttr
{
	public:
		Linac_board_disabled_308Attrib():SpectrumAttr("Linac_board_disabled_308", Tango::DEV_BOOLEAN, Tango::READ, 20) {};
		~Linac_board_disabled_308Attrib() {};
	
		virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FSafety *>(dev))->read_Linac_board_disabled_308(att);}
		virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FSafety *>(dev))->is_Linac_board_disabled_308_allowed(ty);}
};

class Linac_board_disabled_314Attrib: public Tango::SpectrumAttr
{
	public:
		Linac_board_disabled_314Attrib():SpectrumAttr("Linac_board_disabled_314", Tango::DEV_BOOLEAN, Tango::READ, 20) {};
		~Linac_board_disabled_314Attrib() {};
	
		virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FSafety *>(dev))->read_Linac_board_disabled_314(att);}
		virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FSafety *>(dev))->is_Linac_board_disabled_314_allowed(ty);}
};

class Linac_board_disabled_088Attrib: public Tango::SpectrumAttr
{
	public:
		Linac_board_disabled_088Attrib():SpectrumAttr("Linac_board_disabled_088", Tango::DEV_BOOLEAN, Tango::READ, 20) {};
		~Linac_board_disabled_088Attrib() {};
	
		virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FSafety *>(dev))->read_Linac_board_disabled_088(att);}
		virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FSafety *>(dev))->is_Linac_board_disabled_088_allowed(ty);}
};

class Linac_board_disabled_232Attrib: public Tango::SpectrumAttr
{
	public:
		Linac_board_disabled_232Attrib():SpectrumAttr("Linac_board_disabled_232", Tango::DEV_BOOLEAN, Tango::READ, 20) {};
		~Linac_board_disabled_232Attrib() {};
	
		virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FSafety *>(dev))->read_Linac_board_disabled_232(att);}
		virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FSafety *>(dev))->is_Linac_board_disabled_232_allowed(ty);}
};

class Linac_board_disabled_222Attrib: public Tango::SpectrumAttr
{
	public:
		Linac_board_disabled_222Attrib():SpectrumAttr("Linac_board_disabled_222", Tango::DEV_BOOLEAN, Tango::READ, 20) {};
		~Linac_board_disabled_222Attrib() {};
	
		virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FSafety *>(dev))->read_Linac_board_disabled_222(att);}
		virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FSafety *>(dev))->is_Linac_board_disabled_222_allowed(ty);}
};

class Linac_board_disabled_227Attrib: public Tango::SpectrumAttr
{
	public:
		Linac_board_disabled_227Attrib():SpectrumAttr("Linac_board_disabled_227", Tango::DEV_BOOLEAN, Tango::READ, 20) {};
		~Linac_board_disabled_227Attrib() {};
	
		virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FSafety *>(dev))->read_Linac_board_disabled_227(att);}
		virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FSafety *>(dev))->is_Linac_board_disabled_227_allowed(ty);}
};

class Linac_board_disabled_246Attrib: public Tango::SpectrumAttr
{
	public:
		Linac_board_disabled_246Attrib():SpectrumAttr("Linac_board_disabled_246", Tango::DEV_BOOLEAN, Tango::READ, 20) {};
		~Linac_board_disabled_246Attrib() {};
	
		virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FSafety *>(dev))->read_Linac_board_disabled_246(att);}
		virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FSafety *>(dev))->is_Linac_board_disabled_246_allowed(ty);}
};

class Linac_board_disabled_264Attrib: public Tango::SpectrumAttr
{
	public:
		Linac_board_disabled_264Attrib():SpectrumAttr("Linac_board_disabled_264", Tango::DEV_BOOLEAN, Tango::READ, 20) {};
		~Linac_board_disabled_264Attrib() {};
	
		virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FSafety *>(dev))->read_Linac_board_disabled_264(att);}
		virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FSafety *>(dev))->is_Linac_board_disabled_264_allowed(ty);}
};

class Linac_board_disabled_269Attrib: public Tango::SpectrumAttr
{
	public:
		Linac_board_disabled_269Attrib():SpectrumAttr("Linac_board_disabled_269", Tango::DEV_BOOLEAN, Tango::READ, 20) {};
		~Linac_board_disabled_269Attrib() {};
	
		virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FSafety *>(dev))->read_Linac_board_disabled_269(att);}
		virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FSafety *>(dev))->is_Linac_board_disabled_269_allowed(ty);}
};

class Linac_board_disabled_292Attrib: public Tango::SpectrumAttr
{
	public:
		Linac_board_disabled_292Attrib():SpectrumAttr("Linac_board_disabled_292", Tango::DEV_BOOLEAN, Tango::READ, 20) {};
		~Linac_board_disabled_292Attrib() {};
	
		virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FSafety *>(dev))->read_Linac_board_disabled_292(att);}
		virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FSafety *>(dev))->is_Linac_board_disabled_292_allowed(ty);}
};

class Linac_board_disabled_297Attrib: public Tango::SpectrumAttr
{
	public:
		Linac_board_disabled_297Attrib():SpectrumAttr("Linac_board_disabled_297", Tango::DEV_BOOLEAN, Tango::READ, 20) {};
		~Linac_board_disabled_297Attrib() {};
	
		virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FSafety *>(dev))->read_Linac_board_disabled_297(att);}
		virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FSafety *>(dev))->is_Linac_board_disabled_297_allowed(ty);}
};

class Linac_board_disabled_320Attrib: public Tango::SpectrumAttr
{
	public:
		Linac_board_disabled_320Attrib():SpectrumAttr("Linac_board_disabled_320", Tango::DEV_BOOLEAN, Tango::READ, 20) {};
		~Linac_board_disabled_320Attrib() {};
	
		virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FSafety *>(dev))->read_Linac_board_disabled_320(att);}
		virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FSafety *>(dev))->is_Linac_board_disabled_320_allowed(ty);}
};

class Linac_board_disabled_325Attrib: public Tango::SpectrumAttr
{
	public:
		Linac_board_disabled_325Attrib():SpectrumAttr("Linac_board_disabled_325", Tango::DEV_BOOLEAN, Tango::READ, 20) {};
		~Linac_board_disabled_325Attrib() {};
	
		virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<FSafety *>(dev))->read_Linac_board_disabled_325(att);}
		virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<FSafety *>(dev))->is_Linac_board_disabled_325_allowed(ty);}
};

class Linac_badge_ackAttrib: public Tango::SpectrumAttr
{
public:
	Linac_badge_ackAttrib():SpectrumAttr("Linac_badge_ack", Tango::DEV_STRING, Tango::READ, 1) {};
	~Linac_badge_ackAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_badge_ack(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_badge_ack_allowed(ty);}
};

class Linac_badge_allAttrib: public Tango::SpectrumAttr
{
public:
	Linac_badge_allAttrib():SpectrumAttr("Linac_badge_all", Tango::DEV_STRING, Tango::READ, 16) {};
	~Linac_badge_allAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_badge_all(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_badge_all_allowed(ty);}
};

class Linac_access_stateAttrib: public Tango::SpectrumAttr
{
public:
	Linac_access_stateAttrib():SpectrumAttr("Linac_access_state", Tango::DEV_BOOLEAN, Tango::READ, 15) {};
	~Linac_access_stateAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_access_state(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_access_state_allowed(ty);}
};

class Linac_access_signalsAttrib: public Tango::SpectrumAttr
{
public:
	Linac_access_signalsAttrib():SpectrumAttr("Linac_access_signals", Tango::DEV_BOOLEAN, Tango::READ, 36) {};
	~Linac_access_signalsAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_access_signals(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_access_signals_allowed(ty);}
};

class Exphall_gammaAttrib: public Tango::SpectrumAttr
{
public:
	Exphall_gammaAttrib():SpectrumAttr("Exphall_gamma", Tango::DEV_BOOLEAN, Tango::READ, 6) {};
	~Exphall_gammaAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Exphall_gamma(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Exphall_gamma_allowed(ty);}
};

class VersionAttrib: public Tango::SpectrumAttr
{
public:
	VersionAttrib():SpectrumAttr("Version", Tango::DEV_STRING, Tango::READ, 1) {};
	~VersionAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Version(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Version_allowed(ty);}
};

class Undulator_sprd_fel_2Attrib: public Tango::Attr
{
public:
	Undulator_sprd_fel_2Attrib():Attr("Undulator_sprd_fel_2", Tango::DEV_SHORT, Tango::READ) {};
	~Undulator_sprd_fel_2Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_sprd_fel_2(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_sprd_fel_2_allowed(ty);}
};

class Undulator_sprd_fel_1Attrib: public Tango::Attr
{
public:
	Undulator_sprd_fel_1Attrib():Attr("Undulator_sprd_fel_1", Tango::DEV_SHORT, Tango::READ) {};
	~Undulator_sprd_fel_1Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_sprd_fel_1(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_sprd_fel_1_allowed(ty);}
};

class Undulator_mbd_01Attrib: public Tango::Attr
{
public:
	Undulator_mbd_01Attrib():Attr("Undulator_mbd_01", Tango::DEV_SHORT, Tango::READ) {};
	~Undulator_mbd_01Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_mbd_01(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_mbd_01_allowed(ty);}
};

class Undulator_mbd_fel_2Attrib: public Tango::Attr
{
public:
	Undulator_mbd_fel_2Attrib():Attr("Undulator_mbd_fel_2", Tango::DEV_SHORT, Tango::READ) {};
	~Undulator_mbd_fel_2Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_mbd_fel_2(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_mbd_fel_2_allowed(ty);}
};

class Undulator_mbd_fel_1Attrib: public Tango::Attr
{
public:
	Undulator_mbd_fel_1Attrib():Attr("Undulator_mbd_fel_1", Tango::DEV_SHORT, Tango::READ) {};
	~Undulator_mbd_fel_1Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_mbd_fel_1(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_mbd_fel_1_allowed(ty);}
};

class Undulator_cm_mbd_01Attrib: public Tango::Attr
{
public:
	Undulator_cm_mbd_01Attrib():Attr("Undulator_cm_mbd_01", Tango::DEV_DOUBLE, Tango::READ) {};
	~Undulator_cm_mbd_01Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_cm_mbd_01(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_cm_mbd_01_allowed(ty);}
};

class Undulator_cm_mbd_fel_02_01Attrib: public Tango::Attr
{
public:
	Undulator_cm_mbd_fel_02_01Attrib():Attr("Undulator_cm_mbd_fel_02_01", Tango::DEV_DOUBLE, Tango::READ) {};
	~Undulator_cm_mbd_fel_02_01Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_cm_mbd_fel_02_01(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_cm_mbd_fel_02_01_allowed(ty);}
};

class Undulator_cm_mbd_fel_01_01Attrib: public Tango::Attr
{
public:
	Undulator_cm_mbd_fel_01_01Attrib():Attr("Undulator_cm_mbd_fel_01_01", Tango::DEV_DOUBLE, Tango::READ) {};
	~Undulator_cm_mbd_fel_01_01Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_cm_mbd_fel_01_01(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_cm_mbd_fel_01_01_allowed(ty);}
};

class Undulator_cm_sfel_02_01Attrib: public Tango::Attr
{
public:
	Undulator_cm_sfel_02_01Attrib():Attr("Undulator_cm_sfel_02_01", Tango::DEV_DOUBLE, Tango::READ) {};
	~Undulator_cm_sfel_02_01Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_cm_sfel_02_01(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_cm_sfel_02_01_allowed(ty);}
};

class Undulator_cm_sfel_01_01Attrib: public Tango::Attr
{
public:
	Undulator_cm_sfel_01_01Attrib():Attr("Undulator_cm_sfel_01_01", Tango::DEV_DOUBLE, Tango::READ) {};
	~Undulator_cm_sfel_01_01Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_cm_sfel_01_01(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_cm_sfel_01_01_allowed(ty);}
};

class Undulator_plc_statusAttrib: public Tango::Attr
{
public:
	Undulator_plc_statusAttrib():Attr("Undulator_plc_status", Tango::DEV_BOOLEAN, Tango::READ) {};
	~Undulator_plc_statusAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Undulator_plc_status(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Undulator_plc_status_allowed(ty);}
};

class Plc_statusAttrib: public Tango::Attr
{
public:
	Plc_statusAttrib():Attr("Plc_status", Tango::DEV_BOOLEAN, Tango::READ) {};
	~Plc_statusAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Plc_status(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Plc_status_allowed(ty);}
};

class Linac_mbd_currentAttrib: public Tango::Attr
{
public:
	Linac_mbd_currentAttrib():Attr("Linac_mbd_current", Tango::DEV_DOUBLE, Tango::READ) {};
	~Linac_mbd_currentAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_mbd_current(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_mbd_current_allowed(ty);}
};

class Linac_mod_onS0Attrib: public Tango::Attr
{
public:
	Linac_mod_onS0Attrib():Attr("Linac_mod_onS0", Tango::DEV_SHORT, Tango::READ) {};
	~Linac_mod_onS0Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_mod_onS0(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_mod_onS0_allowed(ty);}
};

class Linac_mod_on_pcgunAttrib: public Tango::Attr
{
public:
	Linac_mod_on_pcgunAttrib():Attr("Linac_mod_on_pcgun", Tango::DEV_SHORT, Tango::READ) {};
	~Linac_mod_on_pcgunAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<FSafety *>(dev))->read_Linac_mod_on_pcgun(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<FSafety *>(dev))->is_Linac_mod_on_pcgun_allowed(ty);}
};

//=========================================
//	Define classes for commands
//=========================================
class UndulatorServiceCmd : public Tango::Command
{
public:
	UndulatorServiceCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	UndulatorServiceCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~UndulatorServiceCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<FSafety *>(dev))->is_UndulatorService_allowed(any);}
};



class UndulatorAckDoorCmd : public Tango::Command
{
public:
	UndulatorAckDoorCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	UndulatorAckDoorCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~UndulatorAckDoorCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<FSafety *>(dev))->is_UndulatorAckDoor_allowed(any);}
};



class UndulatorDoorOpenCmd : public Tango::Command
{
public:
	UndulatorDoorOpenCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	UndulatorDoorOpenCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~UndulatorDoorOpenCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<FSafety *>(dev))->is_UndulatorDoorOpen_allowed(any);}
};



class UndulatorDoorResetCmd : public Tango::Command
{
public:
	UndulatorDoorResetCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	UndulatorDoorResetCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~UndulatorDoorResetCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<FSafety *>(dev))->is_UndulatorDoorReset_allowed(any);}
};



class UndulatorSearchStopCmd : public Tango::Command
{
public:
	UndulatorSearchStopCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	UndulatorSearchStopCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~UndulatorSearchStopCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<FSafety *>(dev))->is_UndulatorSearchStop_allowed(any);}
};



class UndulatorSearchStartCmd : public Tango::Command
{
public:
	UndulatorSearchStartCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	UndulatorSearchStartCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~UndulatorSearchStartCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<FSafety *>(dev))->is_UndulatorSearchStart_allowed(any);}
};



class UndulatorSearchRequestCmd : public Tango::Command
{
public:
	UndulatorSearchRequestCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	UndulatorSearchRequestCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~UndulatorSearchRequestCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<FSafety *>(dev))->is_UndulatorSearchRequest_allowed(any);}
};



class UndulatorEmeAckCmd : public Tango::Command
{
public:
	UndulatorEmeAckCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	UndulatorEmeAckCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~UndulatorEmeAckCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<FSafety *>(dev))->is_UndulatorEmeAck_allowed(any);}
};



class UndulatorRPasvCmd : public Tango::Command
{
public:
	UndulatorRPasvCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	UndulatorRPasvCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~UndulatorRPasvCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<FSafety *>(dev))->is_UndulatorRPasv_allowed(any);}
};



class UndulatorBstCloseCmd : public Tango::Command
{
public:
	UndulatorBstCloseCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	UndulatorBstCloseCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~UndulatorBstCloseCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<FSafety *>(dev))->is_UndulatorBstClose_allowed(any);}
};



class UndulatorBstOpenCmd : public Tango::Command
{
public:
	UndulatorBstOpenCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	UndulatorBstOpenCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~UndulatorBstOpenCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<FSafety *>(dev))->is_UndulatorBstOpen_allowed(any);}
};



class UndulatorDelPostoCmd : public Tango::Command
{
public:
	UndulatorDelPostoCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	UndulatorDelPostoCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~UndulatorDelPostoCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<FSafety *>(dev))->is_UndulatorDelPosto_allowed(any);}
};



class LinacServiceClass : public Tango::Command
{
public:
	LinacServiceClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	LinacServiceClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~LinacServiceClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<FSafety *>(dev))->is_LinacService_allowed(any);}
};



class LinacAckDoorCmd : public Tango::Command
{
public:
	LinacAckDoorCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	LinacAckDoorCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~LinacAckDoorCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<FSafety *>(dev))->is_LinacAckDoor_allowed(any);}
};



class LinacDoorOpenClass : public Tango::Command
{
public:
	LinacDoorOpenClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	LinacDoorOpenClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~LinacDoorOpenClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<FSafety *>(dev))->is_LinacDoorOpen_allowed(any);}
};



class LinacDoorResetClass : public Tango::Command
{
public:
	LinacDoorResetClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	LinacDoorResetClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~LinacDoorResetClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<FSafety *>(dev))->is_LinacDoorReset_allowed(any);}
};



class LinacSearchStopClass : public Tango::Command
{
public:
	LinacSearchStopClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	LinacSearchStopClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~LinacSearchStopClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<FSafety *>(dev))->is_LinacSearchStop_allowed(any);}
};



class LinacSearchStartCmd : public Tango::Command
{
public:
	LinacSearchStartCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	LinacSearchStartCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~LinacSearchStartCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<FSafety *>(dev))->is_LinacSearchStart_allowed(any);}
};



class LinacSearchRequestClass : public Tango::Command
{
public:
	LinacSearchRequestClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	LinacSearchRequestClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~LinacSearchRequestClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<FSafety *>(dev))->is_LinacSearchRequest_allowed(any);}
};



class LinacEmeTLAckCmd : public Tango::Command
{
public:
	LinacEmeTLAckCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	LinacEmeTLAckCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~LinacEmeTLAckCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<FSafety *>(dev))->is_LinacEmeTLAck_allowed(any);}
};



class LinacEmeAckClass : public Tango::Command
{
public:
	LinacEmeAckClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	LinacEmeAckClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~LinacEmeAckClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<FSafety *>(dev))->is_LinacEmeAck_allowed(any);}
};



class LinacRPasvClass : public Tango::Command
{
public:
	LinacRPasvClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	LinacRPasvClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~LinacRPasvClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<FSafety *>(dev))->is_LinacRPasv_allowed(any);}
};



class LinacBstCloseClass : public Tango::Command
{
public:
	LinacBstCloseClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	LinacBstCloseClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~LinacBstCloseClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<FSafety *>(dev))->is_LinacBstClose_allowed(any);}
};



class LinacBstOpenClass : public Tango::Command
{
public:
	LinacBstOpenClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	LinacBstOpenClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~LinacBstOpenClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<FSafety *>(dev))->is_LinacBstOpen_allowed(any);}
};



class LinacDelPostoCmd : public Tango::Command
{
public:
	LinacDelPostoCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	LinacDelPostoCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~LinacDelPostoCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<FSafety *>(dev))->is_LinacDelPosto_allowed(any);}
};



class LinacSwitchConfClass : public Tango::Command
{
public:
	LinacSwitchConfClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	LinacSwitchConfClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~LinacSwitchConfClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<FSafety *>(dev))->is_LinacSwitchConf_allowed(any);}
};



//
// The FSafetyClass singleton definition
//

class
#ifdef WIN32
	__declspec(dllexport)
#endif
	FSafetyClass : public Tango::DeviceClass
{
public:
//	properties member data

//	add your own data members here
//------------------------------------
public:
	Tango::DbData	cl_prop;
	Tango::DbData	cl_def_prop;
	Tango::DbData	dev_def_prop;

//	Method prototypes
	static FSafetyClass *init(const char *);
	static FSafetyClass *instance();
	~FSafetyClass();
	Tango::DbDatum	get_class_property(string &);
	Tango::DbDatum	get_default_device_property(string &);
	Tango::DbDatum	get_default_class_property(string &);
	
protected:
	FSafetyClass(string &);
	static FSafetyClass *_instance;
	void command_factory();
	void get_class_property();
	void attribute_factory(vector<Tango::Attr *> &);
	void write_class_property();
	void set_default_property();

private:
	void device_factory(const Tango::DevVarStringArray *);
};


}	//	namespace FSafety_ns

#endif // _FSAFETYCLASS_H
